#ifndef EPD_H
#define EPD_H

// includes

#include <stdio.h>
#include "board.h"
#include "movelist.h"

// macros

#define MAXEPDFIELD 255

/* Error codes */
enum {
   EPD_SUCCESS,
   EPD_ERROR
};


// types

typedef struct {
  FILE *fp;
}   epd_iter_t;

typedef struct {
    board_t board[1];
    movelist_t bm[1];
    char c0[MAXEPDFIELD];
    char id[MAXEPDFIELD];
} epd_t;

// variables

extern epd_iter_t EPDIter[1];

// functions

/*  The EPD routines  */
int EPDFromString (epd_t *epd, const char *p);
void EPDIterInit(epd_iter_t *epd_iter);
int EPDIterStart(epd_iter_t *epd_iter, char *file);
void EPDIterClose(epd_iter_t *epd_iter);
int EPDIterNext(epd_iter_t *epd_iter, epd_t *epd);
void EPDShow(epd_t *epd);



#endif
