#ifndef ETABLE_H
#define ETABLE_H

// includes

#include "board.h"

// macros
#ifndef EVALSLOTS
#define EVALSLOTS  1048576
#endif
#define EVAL_VALID(board,p) ((p)->ekey==KEY((board)->HashKey))
#define ETABLE_LOWERBOUND 2
#define ETABLE_UPPERBOUND 4
#define ETABLE_EXACTSCORE 8
#define ETABLE_UNKNOWN   16

// types

typedef struct{
    KeyType ekey;
    short score;
    short flags;
} etable_slot_t;

typedef struct {
    etable_slot_t *Slot;
    unsigned long GoodEvalHashCnt;
    unsigned long TotalEvalHashCnt;
    unsigned long EHashMask;
    unsigned int Size;
}etable_t;

// variables

extern etable_t ETable[1]; 

// functions

void ETableInit(etable_t *etable);
void ETableClear(etable_t *etable);
void ETableZero (etable_t *etable);
void ETableResetStats(etable_t *etable);
void ETableSetSize(etable_t *etable, unsigned int size);
void ETableSetSizeMb(etable_t *etable, unsigned int size);
etable_slot_t * ETableGet(etable_t *etable, 
			  board_t *board);


void ETableStatsShow(etable_t *etable);

#endif
