#ifndef GTB_H
#define GTB_H

// includes 


#include "board.h"
#include "movelist.h"

// macros

#define GTB_MODE_WDL  0x01
#define GTB_MODE_SOFT 0x02

#define GTB_WIN_SCORE 7000

// types

// due to the design of GTB this is unfortunately a singleton....

typedef struct {
    int verbosity;
    int	scheme ;
    const char ** path;
    size_t cache_size;
    int wdl_fraction;
    int state;
    int have_libgtb;
    uint64_t tbhits;
} gtb_t;

// variables

extern gtb_t GTB[1];

// functions

void GTBInit(gtb_t *gtb);
void GTBSync(gtb_t *gtb);
void GTBSetPath(gtb_t *gtb, char *path);
void GTBSetCacheSize(gtb_t *gtb, size_t cache_size);
void GTBSetWDLFraction(gtb_t *gtb, int wdl_fraction);
void GTBSetScheme(gtb_t *gtb, int scheme);
void GTBSetVerbosity(gtb_t *gtb, int verbosity);
int  GTBScore(gtb_t *gtb, board_t *board, int mode, int *flags);
void GTBShow(gtb_t *gtb);
void GTBQuery(gtb_t *gtb, board_t *board, movelist_t *movelist);
void GTBResetStats(gtb_t *gtb);
void GTBStatsShow(gtb_t *gtb);

#endif 
