#include <string.h>

#include "history.h"
#include "move.h"
#include "util.h"
#include "log.h"
#include "search.h"
#include "piece.h"

#define HISTSCORE(d)	((d)*(d))
#define HISTORY_MAX 1048576

history_t History[1];


static int HistoryIndex(board_t *board,int move){
    int index;
    ASSERT(board->cboard[FROMSQ(move)]>0);
    index=board->cboard[FROMSQ(move)]-1+6*board->side+12*TOSQ(move);
    ASSERT(0<=index && index<HISTORY_SIZE);
    return index;
	   
}

void HistoryInit(history_t *history){
    memset(history,0,sizeof(history_t));
    history->history_max=HISTORY_MAX;
}

void HistoryGood(history_t *history, board_t *board, int move, int depth){
    int index, index1;
    if(move & (CAPTURE | PROMOTION)){
	return;
    }
    if(board->cboard[TOSQ(move)]!=empty){
	return;
    }
    index=HistoryIndex(board,move);
    (history->history)[index] += search.HistoryGood*(HISTSCORE(depth));
    if((history->history)[index]>history->history_fill){
	history->history_fill=(history->history)[index];
    }
    history->history_max -= search.HistoryBad;
    if(history->history_fill>=history->history_max){
	int delta;
	//	printf("Overflow good hist_max=%ld hist_fill=%ld peek=%ld fill=%d\n",history->history_max,history->history_fill,(history->history)[index],search.HistoryGood*(HISTSCORE(depth)));
	delta=HISTORY_MAX-history->history_max;
	history->history_fill=0;
	history->history_max=HISTORY_MAX;
	for(index1=0;index1<HISTORY_SIZE;index1++){
	    (history->history)[index1]=
		MIN((history->history)[index1]+delta,HISTORY_MAX);
	    (history->history)[index1]=((history->history)[index1])/2;
	    if((history->history)[index1]>history->history_fill){
		history->history_fill=(history->history)[index1];
	    }
	}
    }
}

int HistoryGet(history_t *history, board_t *board, int move){
    int index;
    index=HistoryIndex(board,move);
    return ((history->history)[index])>>6;
}

