#include "board.h"
#include "piece.h"
#include "endgame.h"
#include "eval.h"
#include "square.h"

int ScoreKPPP_K(board_t *board, uint32_t *flags){
    int side, xside,ps,xps,winner,loser,first,last,file,on_same_file,s;
    int wk,bk;
    int KPPP_K;
    BitBoard c;
    
    KPPP_K=false;
    side=board->side;
    xside=1^side;
    ps=nbits(board->b[side][pawn]);
    xps=nbits(board->b[xside][pawn]);
    if(ps<2 && xps<2){
    }else if(nbits(board->friends[side])==ps+1 
	     && nbits(board->friends[xside])==1) {
	winner=side;
	loser=xside;
	KPPP_K=true;
    }else if(nbits(board->friends[xside])==xps+1
	     && nbits(board->friends[side])==1) {
	winner=xside;
	loser=side;
	KPPP_K=true;
    }
    if(!KPPP_K){
	*flags=EG_NOTRECOGNIZED;
	return EG_SCORENOTRECOGNIZED;
    }
    *flags=EG_EXACTSCORE;
    c=board->b[winner][pawn];
    if(winner==white){
	first=trailz(c);
	last=leadz(c);
    }else{
	first=leadz(c);
	last=trailz(c);
    }
    file=FILE_(first);
    on_same_file=(bitboards.FileBit[file] & c)==c?true:false;
    
    if(!on_same_file){
	s=evals.ValueQ-50+((winner==white)?RANK(first):7-RANK(first)); // score for winner
	s=(winner==board->side)?s:-s; // score for side
	return s;
    }

    /*
     * On same file; mirror everything if winner==black.
     */

    side=(winner==white)?side:1^side;
    first=(winner==white)?first:63-first;
    last=(winner==white)?first:63-last;
    wk= board->king[winner];
    wk=(winner==white)?wk:63-wk;
    bk= board->king[1^winner];
    bk=(winner==white)?bk:63-bk;

    /* 
     *  In case of rook pawn only look at first pawn.
     */

    if(file==A_FILE || file==H_FILE){
	if(KPK_raw(wk,bk,first,side)==0){
	    return DRAWSCORE;
	}else{
	    s = evals.ValueQ +RANK(first)-50; // score for winner
	    s=(winner==board->side)?s:-s; // score for side
	    return s;
	}
    }

    /*
     * For non rook pawn there are only a few draw patterns.
     */

    if(RANK(first)==rank6[white] && RANK(last)==rank5[white]){
	if(bk==first+8){  
	    return DRAWSCORE;
	}
	if(bk==first+16 && side==black){
	    return DRAWSCORE;
	
}	if(bk==first+15 && wk==first-1 && side==white){
	    return DRAWSCORE;
	}	
	if(bk==first+17 && wk==first+1 && side==white){
	    return DRAWSCORE;
	}
    }
    *flags=EG_NOTRECOGNIZED;
    return EG_SCORENOTRECOGNIZED;
    

}
