#include "board.h"
#include "piece.h"
#include "endgame.h"
#include "eval.h"
#include "square.h"

int ScoreKPPP_KPP_(board_t *board, uint32_t *flags){
    int side, xside,ps,xps,winner,loser,first,file,s;
    int on_same_file;
    int wk,bk;
    int KPPP_KPP_;
    BitBoard c;
    
    KPPP_KPP_=false;
    side=board->side;
    xside=1^side;
    ps=nbits(board->b[side][pawn]);
    xps=nbits(board->b[xside][pawn]);
    if(ps==xps){
	*flags=EG_NOTRECOGNIZED;
	return EG_SCORENOTRECOGNIZED;
    }
    if(nbits(board->friends[side])==ps+1 
       && nbits(board->friends[xside])==xps+1) {
	KPPP_KPP_=true;
	if(ps>xps){
	    winner=side;
	    loser=xside;
	    *flags=EG_UPPERBOUND;
	}else{
	    winner=xside;
	    loser=side;
	    *flags=EG_LOWERBOUND;
	}
    }
    if(!KPPP_KPP_){
	*flags=EG_NOTRECOGNIZED;
	return EG_SCORENOTRECOGNIZED;
    }
    c=board->b[winner][pawn];
    if(winner==white){
	first=trailz(c);
    }else{
	first=leadz(c);
    }
    file=FILE_(first);
    on_same_file=(bitboards.FileBit[file] & c)==c?true:false;

    
    if(!on_same_file || (file!=A_FILE && file!=H_FILE)){
	*flags=EG_NOTRECOGNIZED;
	return EG_SCORENOTRECOGNIZED;
    }
    side=(winner==white)?side:1^side;
    first=(winner==white)?first:63-first;
    wk= board->king[winner];
    wk=(winner==white)?wk:63-wk;
    bk= board->king[1^winner];
    bk=(winner==white)?bk:63-bk;
    s=KPK_raw(wk,bk,first,side);
    s=(winner==board->side)?s:-s;
    return s;
}
