#include <stdlib.h>
#include <stdio.h>


#include "endgame.h"
#include "piece.h"
#include "square.h"
#include "board.h"
#include "bitboard.h"

static const int multiplier[16]={16,16,16,15,14,13,12,10,8,6,4,2,2,2,2,2};

int ScoreKRKP(board_t *board, uint32_t *flags){
    int side,xside,score,winner,loser,KRKP,pawn_sq;
    int pawn_file,pawn_rank,king_loser_file,king_loser_rank,cutoff,prom_square; 
    side=board->side;
    xside=1^side;
    KRKP=false;
    *flags=EG_NOTRECOGNIZED;
    score=EG_SCORENOTRECOGNIZED;
    if((nbits(board->friends[side])==nbits(board->b[side][rook])+1)
	   && (nbits(board->b[side][rook])==1)
	   && nbits(board->friends[xside])==nbits(board->b[xside][pawn])+1
	   && (nbits(board->b[xside][pawn])==1)
	   ){
	winner=side;
	loser=xside;
	KRKP=true;
    }else if((nbits(board->friends[xside])==nbits(board->b[xside][rook])+1)
	   && (nbits(board->b[xside][rook])==1)
	   && nbits(board->friends[side])==nbits(board->b[side][pawn])+1
	   && (nbits(board->b[side][pawn])==1)
	   ){
	winner=xside;
	loser=side;
	KRKP=true;
    }
    if(KRKP){
	pawn_sq=leadz(board->b[loser][pawn]);
        pawn_rank=(winner==white)?7-RANK(pawn_sq):RANK(pawn_sq);
	pawn_file=FILE_(pawn_sq);
	prom_square=(winner==white)?SQUARE(pawn_file,0):SQUARE(pawn_file,7);
	//	king_winner_file=FILE_(board->king[winner]);
	//	cutoff=abs(king_winner_file-pawn_file)+pawn_rank;
	cutoff=MIN(15,pawn_rank+distance[board->king[winner]][pawn_sq]);
	*flags=EG_MULTIPLIER;
	score=multiplier[cutoff];
	//	printf("KRKP detected, pawn_sq=%d, pawn_rank=%d, winner=%d, king=%d, distance=%d, cutoff=%d, score=%d\n",pawn_sq,pawn_rank,winner,board->king[winner],distance[board->king[winner]][pawn_sq],cutoff,score);
	return score;

    }
    return score;
}
