#include <stdlib.h>
#include <stdio.h>


#include "endgame.h"
#include "piece.h"
#include "square.h"
#include "board.h"
#include "bitboard.h"

static const int rule_off[8]={8,6,5,5,5,5,6,8};
static const int multiplier[16]={0,1,2,3,4,4,5,5,6,6,7,7,8,8,9,9};


int ScoreKRPKR(board_t *board, uint32_t *flags){
    int side,xside,score,winner,loser,KRPKR,pawn_sq;
    int pawn_file,pawn_rank,king_loser_file,king_loser_rank,cutoff,prom_square; 
    side=board->side;
    xside=1^side;
    KRPKR=false;
    *flags=EG_NOTRECOGNIZED;
    score=EG_SCORENOTRECOGNIZED;
    if((nbits(board->friends[side])==nbits(board->b[side][pawn])+nbits(board->b[side][rook])+1)
       && (nbits(board->b[side][rook])==1)
       && (nbits(board->b[side][pawn])==1)
       && nbits(board->friends[xside])==nbits(board->b[xside][rook])+1
       && (nbits(board->b[xside][rook])==1)
       ){
	winner=side;
	loser=xside;
	KRPKR=true;
    }else if((nbits(board->friends[xside])==nbits(board->b[xside][pawn])+nbits(board->b[xside][rook])+1)
	     && (nbits(board->b[xside][rook])==1)
	     && (nbits(board->b[xside][pawn])==1)
	     && nbits(board->friends[side])==nbits(board->b[side][rook])+1
	     && (nbits(board->b[side][rook])==1)
	     ){
	winner=xside;
	loser=side;
	KRPKR=true;
    }
    if(KRPKR){
	// defending king in front of pawn
	pawn_sq=leadz(board->b[winner][pawn]);
	if(bitboards.Front[winner][pawn_sq] & board->b[loser][king]){
	    *flags=EG_EXACTSCORE;
	    return DRAWSCORE;
	}
	// defending king not vertically cut off, rule of five
	pawn_file=FILE_(pawn_sq);
	pawn_rank=(winner==white)?RANK(pawn_sq):7-RANK(pawn_sq);
	prom_square=SQUARE(pawn_file,winner==white?7:0);
	king_loser_file=FILE_(board->king[loser]);
	king_loser_rank=(winner==white)?RANK(board->king[loser]):7-RANK(board->king[loser]);
	cutoff=abs(king_loser_file-pawn_file);
	if(cutoff+pawn_rank<=rule_off[pawn_file] && king_loser_rank>=pawn_rank-1){
	    //	    printf("Rule of five applies cutoff+pawn_rank=%d prom_square=%d loser_king=%d dist=%d\n",cutoff+pawn_rank,prom_square,board->king[loser],taxicab[board->king[loser]][prom_square]);
	    *flags=EG_MULTIPLIER;
	    // score for winner
	    //	    score=DRAWSCORE-4*distance[board->king[loser]][prom_square];
	    score=multiplier[taxicab[board->king[loser]][prom_square]];
	    return score;
	}
	// rook pawn is generally drawish
	if(pawn_file==0 || pawn_file==7){
	    *flags=EG_MULTIPLIER;
	    score=8;
	    return score;
	}
    }
    return score;
}    
