#ifndef MOVELIST_H
#define MOVELIST_H

// includes

#include "util.h"


// types

typedef struct
{
   int move;   /* the move that produced this particular board */
   int score;  /* the scored value of this leaf */
} leaf;


typedef struct {
  leaf moves[MAXMOVES];
  int gencnt;
} movelist_t;

// includes 

#include "board.h"

// functions

void MoveListInit(movelist_t *movelist);
void MoveListFilter(board_t *board, movelist_t *movelist);
void MoveListToString(board_t *board, movelist_t *movelist, char *s);
void MoveListShow(board_t *board, movelist_t *movelist);
leaf *MoveListPickUniform(movelist_t *movelist);
leaf *MoveListPickRandom(movelist_t *movelist);
leaf *MoveListPickBest(movelist_t *movelist);
void MoveListPickSel(movelist_t *movelist, leaf *head);
void MoveListAdd(board_t *board, movelist_t *movelist, leaf *p);
void MoveListFromString(board_t *board, movelist_t *movelist, char *s);
void MoveListCopy(movelist_t *dst_movelist, movelist_t *src_movelist);
int MoveListContains(movelist_t *movelist, int move);
leaf * MoveListFind(movelist_t *movelist, int move);


#endif
