#include <string.h>

#include "util.h"
#include "searchdata.h"
#include "board.h"
#include "history.h"

void SearchDataInit(searchdata_t *searchdata){
    SearchDataInitSafe(searchdata, History);
}

void SearchDataInitSafe(searchdata_t *searchdata, history_t *history){
    memset(searchdata,0,sizeof(searchdata_t));
    searchdata->history=history;
    HistoryInit(history);
}

void SearchDataSave(searchdata_t *searchdata, int ply, searchdatasave_t *s){
    s->Hashmv=searchdata->Hashmv[ply];
    s->reduction=searchdata->reduction[ply];
    s->nodetype=searchdata->nodetype[ply];
    s->singular=searchdata->singular[ply];
}

void SearchDataRestore(searchdata_t *searchdata, int ply, searchdatasave_t *s){
    searchdata->Hashmv[ply]=s->Hashmv;
    searchdata->reduction[ply]=s->reduction;
    searchdata->nodetype[ply]=s->nodetype;
    searchdata->singular[ply]=s->singular;
}

