#ifndef SEARCHDATA_H
#define SEARCHDATA_H

// includes

#include <setjmp.h>
#include "util.h"
#include "board.h"
#include "moveseq.h"
#include "timer.h"
#include "history.h"

// types

typedef struct{

    /* for timeouts */
    jmp_buf rootpointer;
    
    int RootDepth;
    int RootScore;
    int RootAlpha;
    int RootBeta;
    int RootState;
    board_t *RootBoard;

    /* periodic updates */
    int  RootMoves;
    int  RootMovesRemaining;
    char RootMoveCurrent[SANSZ];
    char RootMoveCurrentLAN[SANSZ];
    
    timer__t timer[1];
    history_t *history;
    int lazydiff[2];
    int posdiff[2];
    
    int killer1[MAXPLYDEPTH];
    int killer2[MAXPLYDEPTH];
    int Hashmv[MAXPLYDEPTH];
    uint8_t reduction[MAXPLYDEPTH];
    uint8_t nodetype[MAXPLYDEPTH];
    uint8_t singular[MAXPLYDEPTH];
    uint8_t seldepth;
    moveseq_t moveseq[1];
    int DumpId;
} searchdata_t;

typedef struct {
    int Hashmv;
    int reduction;
    int nodetype;
    int singular;
} searchdatasave_t;

// functions

void SearchDataInit(searchdata_t *searchdata);
void SearchDataInitSafe(searchdata_t *searchdata, history_t *history);
void SearchDataSave(searchdata_t *searchdata, int ply, searchdatasave_t *s);
void SearchDataRestore(searchdata_t *searchdata, int ply, searchdatasave_t *s);
#endif
