#ifndef SEARCHPARAMS_H
#define SEARCHPARAMS_H


// includes

#include "protocol.h"
#include "option.h"
#include "uci.h"



// types 

typedef struct {
    int protocol;     // PROTOCOL_XBOARD or PROTOCOL_UCI
    float TCinc;      
    int SearchDepth;  
    float ST;
    int movestogo;
    int NPS;
    int pondering;
    int infinite;   // the search can only be interupted by the user
    int ponder;     // in xboard mode affects format of engine output
                    // implies infinite
    int post;
    uint64_t nodes;
    float SearchTime;
    float maxtime;
    float timelimit;
    movelist_t movelist[1];
    int listen;
} searchparams_t;

// functions
void SearchParamsShow(searchparams_t *searchparams);

void SearchParamsCreate(searchparams_t *searchparams, 
			protocol_t *protocol);
void SearchParamsCreateUci(searchparams_t *searchparams,
			   uci_t *uci,
			   option_list_t *option);
#endif
