#include <stdlib.h>

#include "board.h"
#include "searchparams.h"
#include "searchstats.h"
#include "iterate.h"
#include "util.h"
#include "input.h"

#define SIGDEPTH 12

static char * fens[]={
  "r2q1rk1/pbpn1pp1/1p2pn1p/3p4/2PP3B/P1Q1PP2/1P4PP/R3KBNR w KQ - 0 11",
  "r2q1rk1/pbp1bppp/1p2pn2/8/3P1B2/2PB1N2/PP2QPPP/R4RK1 b - - 0 11",
  "r1bq1rk1/4bppp/p2ppn2/1p4B1/3QP2P/2N2P2/PPP3P1/2KR1B1R w - b6 0 12",
  "2k5/4K3/1pP5/1P6/8/8/8/8 w - - 0 1",
  NULL
};


static void SigSearchParamsCreate(searchparams_t *searchparams, int depth){
    searchparams->protocol=PROTOCOL_XBOARD;
    searchparams->TCinc=0;
    searchparams->SearchDepth=depth;
    searchparams->ST=0;
    searchparams->movestogo=0;
    searchparams->NPS=0;
    searchparams->pondering=false;
    searchparams->infinite=false;
    searchparams->ponder=false;
    searchparams->post=false;
    searchparams->nodes=0;
    searchparams->movelist->gencnt=0;
    searchparams->timelimit=1000000000;
    searchparams->SearchTime=0;
    searchparams->maxtime=0;
    searchparams->listen=false;
}

int SigCompute(void){
    char **fen;
    board_t board[1];
    searchparams_t searchparams[1];
    searchstats_t searchstats[1];
    int total=0;
    SearchStatsInit(searchstats);
    SigSearchParamsCreate(searchparams, SIGDEPTH);
    for(fen=fens;*fen!=NULL;fen++){
	BoardFromFen(board,*fen,false);
	Iterate (board,searchparams,searchstats);
	total+=searchstats->NodeCnt+searchstats->QuiesCnt;
    
    }
    return total;
}
