#include <string.h>

#include "endgame.h"
#include "piece.h"
#include "square.h"
#include "board.h"
#include "eval.h"
#include "material.h"
#include "gtb.h"
#include "protocol.h"
#include "log.h"
#include "attack.h"

// This is a bloody mess, but as long as it works....


// bitbase generated from Gaviota Tablebases.

static uint64_t KBPK_rank6_[64/*wk*/][64/*bk*/][2/*side*/]={
    /* bit=wb */
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x5faf77fbfdfeffff),
    ULL(0x5ffffffffffeffff),
    ULL(0x6fd7bb7dfefeffff),
    ULL(0x6ffffffffffeffff),
    ULL(0x77ebddbe7ffeffff),
    ULL(0x77fffffffffeffff),
    ULL(0x7bf5eedfbf7effff),
    ULL(0x7bfffffffffeffff),
    ULL(0x7dfaf7efdfbe7fff),
    ULL(0x7dfffffffffeffff),
    ULL(0x7efdfbf7efdebf7f),
    ULL(0x7efffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2fdfaf77fbfcfeff),
    ULL(0x7fdffffffffeffff),
    ULL(0x57efd7bb7dfeffff),
    ULL(0x7feffffffffeffff),
    ULL(0x6bf7ebddbe7effff),
    ULL(0x7ff7fffffffeffff),
    ULL(0x75fbf5eedfbe7fff),
    ULL(0x7ffbfffffffeffff),
    ULL(0x7afdfaf7efdebf7f),
    ULL(0x7ffdfffffffeffff),
    ULL(0x7dfefdfbf7eedfbf),
    ULL(0x7ffefffffffeffff),
    ULL(0x5fbf7fbfdfeef7fb),
    ULL(0x7fff7ffffffeffff),
    ULL(0x6f5fbf5feff6fbfd),
    ULL(0x7fffbffffffeffff),
    ULL(0x77afdfaf77fafdfe),
    ULL(0x7fffdffffffeffff),
    ULL(0x3bd7efd7bb7cfeff),
    ULL(0x7fffeffffffeffff),
    ULL(0x5debf7ebddbe7fff),
    ULL(0x7ffff7fffffeffff),
    ULL(0x6ef5fbf5eedebf7f),
    ULL(0x7ffffbfffffeffff),
    ULL(0x77fafdfaf7eedfbf),
    ULL(0x7ffffdfffffeffff),
    ULL(0x7bfdfefdfbf6efdf),
    ULL(0x7ffffefffffeffff),
    ULL(0x6fdfbf7fbfdeeff7),
    ULL(0x7fffff7ffffeffff),
    ULL(0x77ef5fbf5feef7fb),
    ULL(0x7fffffbffffeffff),
    ULL(0x7b77afdfaf76fbfd),
    ULL(0x7fffffdffffeffff),
    ULL(0x7dbbd7efd7ba7dfe),
    ULL(0x7fffffeffffeffff),
    ULL(0x3eddebf7ebdcbe7f),
    ULL(0x7ffffff7fffeffff),
    ULL(0x5feef5fbf5eedfbf),
    ULL(0x7ffffffbfffefeff),
    ULL(0x6ff7fafdfaf6efdf),
    ULL(0x7ffffffdfffefeff),
    ULL(0x77fbfdfefdfaf7ef),
    ULL(0x7ffffffefffefeff),
    ULL(0x77efdfbf7fbedfef),
    ULL(0x7fffffff7ffeffff),
    ULL(0x7bf7ef5fbf5eeff7),
    ULL(0x7fffffffbffeffff),
    ULL(0x7dfb77afdfae77fb),
    ULL(0x7fffffffdffeffff),
    ULL(0x7e7dbbd7efd6bb7d),
    ULL(0x7fffffffeffeffff),
    ULL(0x7fbeddebf7eaddbe),
    ULL(0x3a5daed7e372be5d),
    ULL(0x3fdfeef5fbf4eedf),
    ULL(0x2a55aa55ab50ae5d),
    ULL(0x5feff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0x6ff7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0x7bf7efdfbf7ebfdf),
    ULL(0x7fffffffff7effff),
    ULL(0x7dfbf7ef5fbe5fef),
    ULL(0x7fffffffffbeffff),
    ULL(0x7efdfb77afdeaf77),
    ULL(0x7fffffffffdeffff),
    ULL(0x7ffe7dbbd7eed7bb),
    ULL(0x7fffffffffeefeff),
    ULL(0x7f7fbeddebf6ebdd),
    ULL(0x2a55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0x2a55aa55ab50aa5d),
    ULL(0x2a55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0x7ffffffffffeffff),
    ULL(0x7ffffffffffeffff),
    ULL(0x7dfbf7efdfbe7fbf),
    ULL(0x7ffffffffffe7fff),
    ULL(0x7efdfbf7ef5ebf5f),
    ULL(0x7ffffffffffebfff),
    ULL(0x7ffefdfb77aedfaf),
    ULL(0x7ffffffffffedfff),
    ULL(0x7ffffe7dbbd6efd7),
    ULL(0x7ffffffffffeeeff),
    ULL(0x7fff7fbeddeaf6eb),
    ULL(0x2a55aa55aa50a251),
    ULL(0x2a55aa55aa54aa55),
    ULL(0x2a55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0x2a55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0x7efdfbf7efdebf7f),
    ULL(0x7ffffffffffeff7f),
    ULL(0x7ffefdfbf7ee5fbf),
    ULL(0x7ffffffffffeffbf),
    ULL(0x7ffffefdfb76afdf),
    ULL(0x7ffffffffffeffdf),
    ULL(0x7ffffffe7dbad7ef),
    ULL(0x7ffffffffffefeef),
    ULL(0x7fffff7fbedcebf7),
    ULL(0x2ad5ea75ba5caa53),
    ULL(0x7fff7fbfdeecf4f3),
    ULL(0x2ad5ea75ba5caa51),
    ULL(0x2a55aa55aa54aa55),
    ULL(0x2a55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0x2a55aa55aa54aa54),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xafd7bb7dfefeffff),
    ULL(0xaffffffffffeffff),
    ULL(0xb7ebddbe7ffeffff),
    ULL(0xb7fffffffffeffff),
    ULL(0xbbf5eedfbf7effff),
    ULL(0xbbfffffffffeffff),
    ULL(0xbdfaf7efdfbe7fff),
    ULL(0xbdfffffffffeffff),
    ULL(0xbefdfbf7efdebf7f),
    ULL(0xbefffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x97efd7bb7dfeffff),
    ULL(0xbfeffffffffeffff),
    ULL(0xabf7ebddbe7effff),
    ULL(0xbff7fffffffeffff),
    ULL(0xb5fbf5eedfbe7fff),
    ULL(0xbffbfffffffeffff),
    ULL(0xbafdfaf7efdebf7f),
    ULL(0xbffdfffffffeffff),
    ULL(0xbdfefdfbf7eedfbf),
    ULL(0xbffefffffffeffff),
    ULL(0x9fbf7fbfdfeef7fb),
    ULL(0xbfff7ffffffeffff),
    ULL(0xaf5fbf5feff6fbfd),
    ULL(0xbfffbffffffeffff),
    ULL(0x37afdfaf77fafdfe),
    ULL(0xbfffdffffffeffff),
    ULL(0xbbd7efd7bb7cfeff),
    ULL(0xbfffeffffffeffff),
    ULL(0x9debf7ebddbe7fff),
    ULL(0xbffff7fffffeffff),
    ULL(0xaef5fbf5eedebf7f),
    ULL(0xbffffbfffffeffff),
    ULL(0xb7fafdfaf7eedfbf),
    ULL(0xbffffdfffffeffff),
    ULL(0xbbfdfefdfbf6efdf),
    ULL(0xbffffefffffeffff),
    ULL(0xafdfbf7fbfdeeff7),
    ULL(0xbfffff7ffffeffff),
    ULL(0xb7ef5fbf5feef7fb),
    ULL(0xbfffffbffffeffff),
    ULL(0xbb77afdfaf76fbfd),
    ULL(0xbfffffdffffeffff),
    ULL(0x3dbbd7efd7ba7dfe),
    ULL(0xbfffffeffffeffff),
    ULL(0xbeddebf7ebdcbe7f),
    ULL(0xbffffff7fffeffff),
    ULL(0x9feef5fbf5eedfbf),
    ULL(0xbffffffbfffefeff),
    ULL(0xaff7fafdfaf6efdf),
    ULL(0xbffffffdfffefeff),
    ULL(0xb7fbfdfefdfaf7ef),
    ULL(0xbffffffefffefeff),
    ULL(0xb7efdfbf7fbedfef),
    ULL(0xbfffffff7ffeffff),
    ULL(0xbbf7ef5fbf5eeff7),
    ULL(0xbfffffffbffeffff),
    ULL(0xbdfb77afdfae77fb),
    ULL(0xbfffffffdffeffff),
    ULL(0xbe7dbbd7efd6bb7d),
    ULL(0xbfffffffeffeffff),
    ULL(0x3fbeddebf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfeef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0x9feff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xaff7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xbbf7efdfbf7ebfdf),
    ULL(0xbfffffffff7effff),
    ULL(0xbdfbf7ef5fbe5fef),
    ULL(0xbfffffffffbeffff),
    ULL(0xbefdfb77afdeaf77),
    ULL(0xbfffffffffdeffff),
    ULL(0xbffe7dbbd7eed7bb),
    ULL(0xbfffffffffeefeff),
    ULL(0xbf7fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xbffffffffffeffff),
    ULL(0xbffffffffffeffff),
    ULL(0xbdfbf7efdfbe7fbf),
    ULL(0xbffffffffffe7fff),
    ULL(0xbefdfbf7ef5ebf5f),
    ULL(0xbffffffffffebfff),
    ULL(0xbffefdfb77aedfaf),
    ULL(0xbffffffffffedfff),
    ULL(0xbffffe7dbbd6efd7),
    ULL(0xbffffffffffeeeff),
    ULL(0xbfff7fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xbefdfbf7efdebf7f),
    ULL(0xbffffffffffeff7f),
    ULL(0xbffefdfbf7ee5fbf),
    ULL(0xbffffffffffeffbf),
    ULL(0xbffffefdfb76afdf),
    ULL(0xbffffffffffeffdf),
    ULL(0xbffffffe7dbad7ef),
    ULL(0xbffffffffffefeef),
    ULL(0xbfffff7fbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xbfff7fbfdeecf4f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x5fbfdfeff7fafdfe),
    ULL(0x1fffbfdfeff6fbfd),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xd7ebddbe7ffeffff),
    ULL(0xd7fffffffffeffff),
    ULL(0xdbf5eedfbf7effff),
    ULL(0xdbfffffffffeffff),
    ULL(0xddfaf7efdfbe7fff),
    ULL(0xddfffffffffeffff),
    ULL(0xdefdfbf7efdebf7f),
    ULL(0xdefffffffffeffff),
    ULL(0x9f7fbfdfeff6fbfd),
    ULL(0xdf7ffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xcbf7ebddbe7effff),
    ULL(0xdff7fffffffeffff),
    ULL(0xd5fbf5eedfbe7fff),
    ULL(0xdffbfffffffeffff),
    ULL(0xdafdfaf7efdebf7f),
    ULL(0xdffdfffffffeffff),
    ULL(0xddfefdfbf7eedfbf),
    ULL(0xdffefffffffeffff),
    ULL(0xdfbf7fbfdfeef7fb),
    ULL(0xdfff7ffffffeffff),
    ULL(0xcf5fbf5feff6fbfd),
    ULL(0xdfffbffffffeffff),
    ULL(0x57afdfaf77fafdfe),
    ULL(0xdfffdffffffeffff),
    ULL(0x9bd7efd7bb7cfeff),
    ULL(0xdfffeffffffeffff),
    ULL(0xddebf7ebddbe7fff),
    ULL(0xdffff7fffffeffff),
    ULL(0xcef5fbf5eedebf7f),
    ULL(0xdffffbfffffeffff),
    ULL(0xd7fafdfaf7eedfbf),
    ULL(0xdffffdfffffeffff),
    ULL(0xdbfdfefdfbf6efdf),
    ULL(0xdffffefffffeffff),
    ULL(0xcfdfbf7fbfdeeff7),
    ULL(0xdfffff7ffffeffff),
    ULL(0xd7ef5fbf5feef7fb),
    ULL(0xdfffffbffffeffff),
    ULL(0xdb77afdfaf76fbfd),
    ULL(0xdfffffdffffeffff),
    ULL(0x5dbbd7efd7ba7dfe),
    ULL(0xdfffffeffffeffff),
    ULL(0x9eddebf7ebdcbe7f),
    ULL(0xdffffff7fffeffff),
    ULL(0xdfeef5fbf5eedfbf),
    ULL(0xdffffffbfffefeff),
    ULL(0xcff7fafdfaf6efdf),
    ULL(0xdffffffdfffefeff),
    ULL(0xd7fbfdfefdfaf7ef),
    ULL(0xdffffffefffefeff),
    ULL(0xd7efdfbf7fbedfef),
    ULL(0xdfffffff7ffeffff),
    ULL(0xdbf7ef5fbf5eeff7),
    ULL(0xdfffffffbffeffff),
    ULL(0xddfb77afdfae77fb),
    ULL(0xdfffffffdffeffff),
    ULL(0xde7dbbd7efd6bb7d),
    ULL(0xdfffffffeffeffff),
    ULL(0x5fbeddebf7eaddbe),
    ULL(0x9a5daed7e372be5d),
    ULL(0x9fdfeef5fbf4eedf),
    ULL(0x8a55aa55ab50ae5d),
    ULL(0xdfeff7fafdfaf6ef),
    ULL(0x0010080400000204),
    ULL(0xcff7fbfdfefcfaf7),
    ULL(0x0010080402000204),
    ULL(0xdbf7efdfbf7ebfdf),
    ULL(0xdfffffffff7effff),
    ULL(0xddfbf7ef5fbe5fef),
    ULL(0xdfffffffffbeffff),
    ULL(0xdefdfb77afdeaf77),
    ULL(0xdfffffffffdeffff),
    ULL(0xdffe7dbbd7eed7bb),
    ULL(0xdfffffffffeefeff),
    ULL(0xdf7fbeddebf6ebdd),
    ULL(0x8a55aa55ab52aa5d),
    ULL(0x1a1d8ec6e172b44c),
    ULL(0x8a55aa55ab50aa5d),
    ULL(0x8a55aa55aa54aa55),
    ULL(0x0010080402000204),
    ULL(0xdffffffffffeffff),
    ULL(0xdffffffffffeffff),
    ULL(0xddfbf7efdfbe7fbf),
    ULL(0xdffffffffffe7fff),
    ULL(0xdefdfbf7ef5ebf5f),
    ULL(0xdffffffffffebfff),
    ULL(0xdffefdfb77aedfaf),
    ULL(0xdffffffffffedfff),
    ULL(0xdffffe7dbbd6efd7),
    ULL(0xdffffffffffeeeff),
    ULL(0xdfff7fbeddeaf6eb),
    ULL(0x8a55aa55aa50a251),
    ULL(0x8a55aa55aa54aa55),
    ULL(0x8a55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x0010080402000000),
    ULL(0x8a55aa55aa54aa55),
    ULL(0x0010080402000204),
    ULL(0xdefdfbf7efdebf7f),
    ULL(0xdffffffffffeff7f),
    ULL(0xdffefdfbf7ee5fbf),
    ULL(0xdffffffffffeffbf),
    ULL(0xdffffefdfb76afdf),
    ULL(0xdffffffffffeffdf),
    ULL(0xdffffffe7dbad7ef),
    ULL(0xdffffffffffefeef),
    ULL(0xdfffff7fbedcebf7),
    ULL(0x8ad5ea75ba5caa53),
    ULL(0xdfff7fbfdeecf5f3),
    ULL(0x8ad5ea75ba5caa51),
    ULL(0x8a55aa55aa54aa55),
    ULL(0x8a55aa55aa54aa50),
    ULL(0x0a158a45a250a854),
    ULL(0x8a55aa55aa54aa54),
    ULL(0x6fbfdfeff7fafdfe),
    ULL(0x6ffffffffffeffff),
    ULL(0xaf5feff7fbfcfeff),
    ULL(0xaffffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xebf5eedfbf7effff),
    ULL(0xebfffffffffeffff),
    ULL(0xedfaf7efdfbe7fff),
    ULL(0xedfffffffffeffff),
    ULL(0xeefdfbf7efdebf7f),
    ULL(0xeefffffffffeffff),
    ULL(0xaf7fbfdfeff6fbfd),
    ULL(0xef7ffffffffeffff),
    ULL(0x4fbf5feff7fafdfe),
    ULL(0xefbffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xe5fbf5eedfbe7fff),
    ULL(0xeffbfffffffeffff),
    ULL(0xeafdfaf7efdebf7f),
    ULL(0xeffdfffffffeffff),
    ULL(0xedfefdfbf7eedfbf),
    ULL(0xeffefffffffeffff),
    ULL(0xcfbf7fbfdfeef7fb),
    ULL(0xefff7ffffffeffff),
    ULL(0xef5fbf5feff6fbfd),
    ULL(0xefffbffffffeffff),
    ULL(0x67afdfaf77fafdfe),
    ULL(0xefffdffffffeffff),
    ULL(0xabd7efd7bb7cfeff),
    ULL(0xefffeffffffeffff),
    ULL(0xcdebf7ebddbe7fff),
    ULL(0xeffff7fffffeffff),
    ULL(0xeef5fbf5eedebf7f),
    ULL(0xeffffbfffffeffff),
    ULL(0xe7fafdfaf7eedfbf),
    ULL(0xeffffdfffffeffff),
    ULL(0xebfdfefdfbf6efdf),
    ULL(0xeffffefffffeffff),
    ULL(0xefdfbf7fbfdeeff7),
    ULL(0xefffff7ffffeffff),
    ULL(0xe7ef5fbf5feef7fb),
    ULL(0xefffffbffffeffff),
    ULL(0xeb77afdfaf76fbfd),
    ULL(0xefffffdffffeffff),
    ULL(0x6dbbd7efd7ba7dfe),
    ULL(0xefffffeffffeffff),
    ULL(0xaeddebf7ebdcbe7f),
    ULL(0xeffffff7fffeffff),
    ULL(0xcfeef5fbf5eedfbf),
    ULL(0xeffffffbfffefeff),
    ULL(0xeff7fafdfaf6efdf),
    ULL(0xeffffffdfffefeff),
    ULL(0xe7fbfdfefdfaf7ef),
    ULL(0xeffffffefffefeff),
    ULL(0xe7efdfbf7fbedfef),
    ULL(0xefffffff7ffeffff),
    ULL(0xebf7ef5fbf5eeff7),
    ULL(0xefffffffbffeffff),
    ULL(0xedfb77afdfae77fb),
    ULL(0xefffffffdffeffff),
    ULL(0xee7dbbd7efd6bb7d),
    ULL(0xefffffffeffeffff),
    ULL(0x6fbeddebf7eaddbe),
    ULL(0xaa5daed7e372be5d),
    ULL(0xafdfeef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xcfeff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xebf7efdfbf7ebfdf),
    ULL(0xefffffffff7effff),
    ULL(0xedfbf7ef5fbe5fef),
    ULL(0xefffffffffbeffff),
    ULL(0xeefdfb77afdeaf77),
    ULL(0xefffffffffdeffff),
    ULL(0xeffe7dbbd7eed7bb),
    ULL(0xefffffffffeefeff),
    ULL(0xef7fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x2a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xeffffffffffeffff),
    ULL(0xeffffffffffeffff),
    ULL(0xedfbf7efdfbe7fbf),
    ULL(0xeffffffffffe7fff),
    ULL(0xeefdfbf7ef5ebf5f),
    ULL(0xeffffffffffebfff),
    ULL(0xeffefdfb77aedfaf),
    ULL(0xeffffffffffedfff),
    ULL(0xeffffe7dbbd6efd7),
    ULL(0xeffffffffffeeeff),
    ULL(0xefff7fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xeefdfbf7efdebf7f),
    ULL(0xeffffffffffeff7f),
    ULL(0xeffefdfbf7ee5fbf),
    ULL(0xeffffffffffeffbf),
    ULL(0xeffffefdfb76afdf),
    ULL(0xeffffffffffeffdf),
    ULL(0xeffffffe7dbad7ef),
    ULL(0xeffffffffffefeef),
    ULL(0xefffff7fbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xefff7fbfdeecf5f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x77bfdfeff7fafdfe),
    ULL(0x77fffffffffeffff),
    ULL(0xb75feff7fbfcfeff),
    ULL(0xb7fffffffffeffff),
    ULL(0xd7af77fbfdfeffff),
    ULL(0xd7fffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf5faf7efdfbe7fff),
    ULL(0xf5fffffffffeffff),
    ULL(0xf6fdfbf7efdebf7f),
    ULL(0xf6fffffffffeffff),
    ULL(0xb77fbfdfeff6fbfd),
    ULL(0xf77ffffffffeffff),
    ULL(0x57bf5feff7fafdfe),
    ULL(0xf7bffffffffeffff),
    ULL(0xa7dfaf77fbfcfeff),
    ULL(0xf7dffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf2fdfaf7efdebf7f),
    ULL(0xf7fdfffffffeffff),
    ULL(0xf5fefdfbf7eedfbf),
    ULL(0xf7fefffffffeffff),
    ULL(0xd7bf7fbfdfeef7fb),
    ULL(0xf7ff7ffffffeffff),
    ULL(0xe75fbf5feff6fbfd),
    ULL(0xf7ffbffffffeffff),
    ULL(0x77afdfaf77fafdfe),
    ULL(0xf7ffdffffffeffff),
    ULL(0xb3d7efd7bb7cfeff),
    ULL(0xf7ffeffffffeffff),
    ULL(0xd5ebf7ebddbe7fff),
    ULL(0xf7fff7fffffeffff),
    ULL(0xe6f5fbf5eedebf7f),
    ULL(0xf7fffbfffffeffff),
    ULL(0xf7fafdfaf7eedfbf),
    ULL(0xf7fffdfffffeffff),
    ULL(0xf3fdfefdfbf6efdf),
    ULL(0xf7fffefffffeffff),
    ULL(0xe7dfbf7fbfdeeff7),
    ULL(0xf7ffff7ffffeffff),
    ULL(0xf7ef5fbf5feef7fb),
    ULL(0xf7ffffbffffeffff),
    ULL(0xf377afdfaf76fbfd),
    ULL(0xf7ffffdffffeffff),
    ULL(0x75bbd7efd7ba7dfe),
    ULL(0xf7ffffeffffeffff),
    ULL(0xb6ddebf7ebdcbe7f),
    ULL(0xf7fffff7fffeffff),
    ULL(0xd7eef5fbf5eedfbf),
    ULL(0xf7fffffbfffefeff),
    ULL(0xe7f7fafdfaf6efdf),
    ULL(0xf7fffffdfffefeff),
    ULL(0xf7fbfdfefdfaf7ef),
    ULL(0xf7fffffefffefeff),
    ULL(0xf7efdfbf7fbedfef),
    ULL(0xf7ffffff7ffeffff),
    ULL(0xf3f7ef5fbf5eeff7),
    ULL(0xf7ffffffbffeffff),
    ULL(0xf5fb77afdfae77fb),
    ULL(0xf7ffffffdffeffff),
    ULL(0xf67dbbd7efd6bb7d),
    ULL(0xf7ffffffeffeffff),
    ULL(0x77beddebf7eaddbe),
    ULL(0xb25daed7e372be5d),
    ULL(0xb7dfeef5fbf4eedf),
    ULL(0xa255aa55ab50ae5d),
    ULL(0xd7eff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xe7f7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xf3f7efdfbf7ebfdf),
    ULL(0xf7ffffffff7effff),
    ULL(0xf5fbf7ef5fbe5fef),
    ULL(0xf7ffffffffbeffff),
    ULL(0xf6fdfb77afdeaf77),
    ULL(0xf7ffffffffdeffff),
    ULL(0xf7fe7dbbd7eed7bb),
    ULL(0xf7ffffffffeefeff),
    ULL(0xf77fbeddebf6ebdd),
    ULL(0xa255aa55ab52aa5d),
    ULL(0x321d8ec6e172b44c),
    ULL(0xa255aa55ab50aa5d),
    ULL(0xa255aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xf7fffffffffeffff),
    ULL(0xf7fffffffffeffff),
    ULL(0xf5fbf7efdfbe7fbf),
    ULL(0xf7fffffffffe7fff),
    ULL(0xf6fdfbf7ef5ebf5f),
    ULL(0xf7fffffffffebfff),
    ULL(0xf7fefdfb77aedfaf),
    ULL(0xf7fffffffffedfff),
    ULL(0xf7fffe7dbbd6efd7),
    ULL(0xf7fffffffffeeeff),
    ULL(0xf7ff7fbeddeaf6eb),
    ULL(0xa255aa55aa50a251),
    ULL(0xa255aa55aa54aa55),
    ULL(0xa255aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xa255aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xf6fdfbf7efdebf7f),
    ULL(0xf7fffffffffeff7f),
    ULL(0xf7fefdfbf7ee5fbf),
    ULL(0xf7fffffffffeffbf),
    ULL(0xf7fffefdfb76afdf),
    ULL(0xf7fffffffffeffdf),
    ULL(0xf7fffffe7dbad7ef),
    ULL(0xf7fffffffffefeef),
    ULL(0xf7ffff7fbedcebf7),
    ULL(0xa2d5ea75ba5caa53),
    ULL(0xf7ff7fbfdeecf5f3),
    ULL(0xa2d5ea75ba5caa51),
    ULL(0xa255aa55aa54aa55),
    ULL(0xa255aa55aa54aa50),
    ULL(0x22158a45a250a854),
    ULL(0xa255aa55aa54aa54),
    ULL(0x7bbfdfeff7fafdfe),
    ULL(0x7bfffffffffeffff),
    ULL(0xbb5feff7fbfcfeff),
    ULL(0xbbfffffffffeffff),
    ULL(0xdbaf77fbfdfeffff),
    ULL(0xdbfffffffffeffff),
    ULL(0xebd7bb7dfefeffff),
    ULL(0xebfffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfafdfbf7efdebf7f),
    ULL(0xf8fffdfbf7eedfbf),
    ULL(0xbb7fbfdfeff6fbfd),
    ULL(0xfb7ffffffffeffff),
    ULL(0x5bbf5feff7fafdfe),
    ULL(0xfbbffffffffeffff),
    ULL(0xabdfaf77fbfcfeff),
    ULL(0xfbdffffffffeffff),
    ULL(0xd3efd7bb7dfeffff),
    ULL(0xfbeffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf9fefdfbf7eedfbf),
    ULL(0xfbfefffffffeffff),
    ULL(0xdbbf7fbfdfeef7fb),
    ULL(0xfbff7ffffffeffff),
    ULL(0xeb5fbf5feff6fbfd),
    ULL(0xfbffbffffffeffff),
    ULL(0x73afdfaf77fafdfe),
    ULL(0xfbffdffffffeffff),
    ULL(0xbbd7efd7bb7cfeff),
    ULL(0xfbffeffffffeffff),
    ULL(0xd9ebf7ebddbe7fff),
    ULL(0xfbfff7fffffeffff),
    ULL(0xeaf5fbf5eedebf7f),
    ULL(0xfbfffbfffffeffff),
    ULL(0xf3fafdfaf7eedfbf),
    ULL(0xfbfffdfffffeffff),
    ULL(0xfbfdfefdfbf6efdf),
    ULL(0xfbfffefffffeffff),
    ULL(0xebdfbf7fbfdeeff7),
    ULL(0xfbffff7ffffeffff),
    ULL(0xf3ef5fbf5feef7fb),
    ULL(0xfbffffbffffeffff),
    ULL(0xfb77afdfaf76fbfd),
    ULL(0xfbffffdffffeffff),
    ULL(0x79bbd7efd7ba7dfe),
    ULL(0xfbffffeffffeffff),
    ULL(0xbaddebf7ebdcbe7f),
    ULL(0xfbfffff7fffeffff),
    ULL(0xdbeef5fbf5eedfbf),
    ULL(0xfbfffffbfffefeff),
    ULL(0xebf7fafdfaf6efdf),
    ULL(0xfbfffffdfffefeff),
    ULL(0xf3fbfdfefdfaf7ef),
    ULL(0xfbfffffefffefeff),
    ULL(0xf3efdfbf7fbedfef),
    ULL(0xfbffffff7ffeffff),
    ULL(0xfbf7ef5fbf5eeff7),
    ULL(0xfbffffffbffeffff),
    ULL(0xf9fb77afdfae77fb),
    ULL(0xfbffffffdffeffff),
    ULL(0xfa7dbbd7efd6bb7d),
    ULL(0xfbffffffeffeffff),
    ULL(0x7bbeddebf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbbdfeef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdbeff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xebf7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebfdf),
    ULL(0xfbffffffff7effff),
    ULL(0xf9fbf7ef5fbe5fef),
    ULL(0xfbffffffffbeffff),
    ULL(0xfafdfb77afdeaf77),
    ULL(0xfbffffffffdeffff),
    ULL(0xfbfe7dbbd7eed7bb),
    ULL(0xfbffffffffeefeff),
    ULL(0xfb7fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfbfffffffffeffff),
    ULL(0xfbfffffffffeffff),
    ULL(0xf9fbf7efdfbe7fbf),
    ULL(0xfbfffffffffe7fff),
    ULL(0xfafdfbf7ef5ebf5f),
    ULL(0xfbfffffffffebfff),
    ULL(0xfbfefdfb77aedfaf),
    ULL(0xfbfffffffffedfff),
    ULL(0xfbfffe7dbbd6efd7),
    ULL(0xfbfffffffffeeeff),
    ULL(0xfbff7fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfafdfbf7efdebf7f),
    ULL(0xfbfffffffffeff7f),
    ULL(0xfbfefdfbf7ee5fbf),
    ULL(0xfbfffffffffeffbf),
    ULL(0xfbfffefdfb76afdf),
    ULL(0xfbfffffffffeffdf),
    ULL(0xfbfffffe7dbad7ef),
    ULL(0xfbfffffffffefeef),
    ULL(0xfbffff7fbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xfbff7fbfdeecf5f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7dbfdfeff7fafdfe),
    ULL(0x7dfffffffffeffff),
    ULL(0xbd5feff7fbfcfeff),
    ULL(0xbdfffffffffeffff),
    ULL(0xddaf77fbfdfeffff),
    ULL(0xddfffffffffeffff),
    ULL(0xedd7bb7dfefeffff),
    ULL(0xedfffffffffeffff),
    ULL(0xf5ebddbe7ffeffff),
    ULL(0xf5fffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbd7fbfdfeff6fbfd),
    ULL(0xfd7ffffffffeffff),
    ULL(0x5dbf5feff7fafdfe),
    ULL(0xfdbffffffffeffff),
    ULL(0xaddfaf77fbfcfeff),
    ULL(0xfddffffffffeffff),
    ULL(0xd5efd7bb7dfeffff),
    ULL(0xfdeffffffffeffff),
    ULL(0xe9f7ebddbe7effff),
    ULL(0xfdf7fffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xddbf7fbfdfeef7fb),
    ULL(0xfdff7ffffffeffff),
    ULL(0xed5fbf5feff6fbfd),
    ULL(0xfdffbffffffeffff),
    ULL(0x75afdfaf77fafdfe),
    ULL(0xfdffdffffffeffff),
    ULL(0xb9d7efd7bb7cfeff),
    ULL(0xfdffeffffffeffff),
    ULL(0xddebf7ebddbe7fff),
    ULL(0xfdfff7fffffeffff),
    ULL(0xecf5fbf5eedebf7f),
    ULL(0xfdfffbfffffeffff),
    ULL(0xf5fafdfaf7eedfbf),
    ULL(0xfdfffdfffffeffff),
    ULL(0xf9fdfefdfbf6efdf),
    ULL(0xfdfffefffffeffff),
    ULL(0xeddfbf7fbfdeeff7),
    ULL(0xfdffff7ffffeffff),
    ULL(0xf5ef5fbf5feef7fb),
    ULL(0xfdffffbffffeffff),
    ULL(0xf977afdfaf76fbfd),
    ULL(0xfdffffdffffeffff),
    ULL(0x7dbbd7efd7ba7dfe),
    ULL(0xfdffffeffffeffff),
    ULL(0xbcddebf7ebdcbe7f),
    ULL(0xfdfffff7fffeffff),
    ULL(0xddeef5fbf5eedfbf),
    ULL(0xfdfffffbfffefeff),
    ULL(0xedf7fafdfaf6efdf),
    ULL(0xfdfffffdfffefeff),
    ULL(0xf5fbfdfefdfaf7ef),
    ULL(0xfdfffffefffefeff),
    ULL(0xf5efdfbf7fbedfef),
    ULL(0xfdffffff7ffeffff),
    ULL(0xf9f7ef5fbf5eeff7),
    ULL(0xfdffffffbffeffff),
    ULL(0xfdfb77afdfae77fb),
    ULL(0xfdffffffdffeffff),
    ULL(0xfc7dbbd7efd6bb7d),
    ULL(0xfdffffffeffeffff),
    ULL(0x7dbeddebf7eaddbe),
    ULL(0xb85daed7e372be5d),
    ULL(0xbddfeef5fbf4eedf),
    ULL(0xa855aa55ab50ae5d),
    ULL(0xddeff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xedf7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xf9f7efdfbf7ebfdf),
    ULL(0xfdffffffff7effff),
    ULL(0xfdfbf7ef5fbe5fef),
    ULL(0xfdffffffffbeffff),
    ULL(0xfcfdfb77afdeaf77),
    ULL(0xfdffffffffdeffff),
    ULL(0xfdfe7dbbd7eed7bb),
    ULL(0xfdffffffffeefeff),
    ULL(0xfd7fbeddebf6ebdd),
    ULL(0xa855aa55ab52aa5d),
    ULL(0x381d8ec6e172b44c),
    ULL(0xa855aa55ab50aa5d),
    ULL(0xa855aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfdfffffffffeffff),
    ULL(0xfdfffffffffeffff),
    ULL(0xfdfbf7efdfbe7fbf),
    ULL(0xfdfffffffffe7fff),
    ULL(0xfcfdfbf7ef5ebf5f),
    ULL(0xfdfffffffffebfff),
    ULL(0xfdfefdfb77aedfaf),
    ULL(0xfdfffffffffedfff),
    ULL(0xfdfffe7dbbd6efd7),
    ULL(0xfdfffffffffeeeff),
    ULL(0xfdff7fbeddeaf6eb),
    ULL(0xa855aa55aa50a251),
    ULL(0xa855aa55aa54aa55),
    ULL(0xa855aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xa855aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfcfdfbf7efdebf7f),
    ULL(0xfdfffffffffeff7f),
    ULL(0xfdfefdfbf7ee5fbf),
    ULL(0xfdfffffffffeffbf),
    ULL(0xfdfffefdfb76afdf),
    ULL(0xfdfffffffffeffdf),
    ULL(0xfdfffffe7dbad7ef),
    ULL(0xfdfffffffffefeef),
    ULL(0xfdffff7fbedcebf7),
    ULL(0xa8d5ea75ba5caa53),
    ULL(0xfdff7fbfdeecf5f3),
    ULL(0xa8d5ea75ba5caa51),
    ULL(0xa855aa55aa54aa55),
    ULL(0xa855aa55aa54aa50),
    ULL(0x28158a45a250a854),
    ULL(0xa855aa55aa54aa54),
    ULL(0x7ebfdfeff7fafdfe),
    ULL(0x7efffffffffeffff),
    ULL(0xbe5feff7fbfcfeff),
    ULL(0xbefffffffffeffff),
    ULL(0xdeaf77fbfdfeffff),
    ULL(0xdefffffffffeffff),
    ULL(0xeed7bb7dfefeffff),
    ULL(0xeefffffffffeffff),
    ULL(0xf6ebddbe7ffeffff),
    ULL(0xf6fffffffffeffff),
    ULL(0xfaf5eedfbf7effff),
    ULL(0xfafffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbe7fbfdfeff6fbfd),
    ULL(0xfe7ffffffffeffff),
    ULL(0x5ebf5feff7fafdfe),
    ULL(0xfebffffffffeffff),
    ULL(0xaedfaf77fbfcfeff),
    ULL(0xfedffffffffeffff),
    ULL(0xd6efd7bb7dfeffff),
    ULL(0xfeeffffffffeffff),
    ULL(0xeaf7ebddbe7effff),
    ULL(0xfef7fffffffeffff),
    ULL(0xf4fbf5eedfbe7fff),
    ULL(0xfefbfffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdebf7fbfdfeef7fb),
    ULL(0xfeff7ffffffeffff),
    ULL(0xee5fbf5feff6fbfd),
    ULL(0xfeffbffffffeffff),
    ULL(0x76afdfaf77fafdfe),
    ULL(0xfeffdffffffeffff),
    ULL(0xbad7efd7bb7cfeff),
    ULL(0xfeffeffffffeffff),
    ULL(0xdcebf7ebddbe7fff),
    ULL(0xfefff7fffffeffff),
    ULL(0xeef5fbf5eedebf7f),
    ULL(0xfefffbfffffeffff),
    ULL(0xf6fafdfaf7eedfbf),
    ULL(0xfefffdfffffeffff),
    ULL(0xfafdfefdfbf6efdf),
    ULL(0xfefffefffffeffff),
    ULL(0xeedfbf7fbfdeeff7),
    ULL(0xfeffff7ffffeffff),
    ULL(0xf6ef5fbf5feef7fb),
    ULL(0xfeffffbffffeffff),
    ULL(0xfa77afdfaf76fbfd),
    ULL(0xfeffffdffffeffff),
    ULL(0x7cbbd7efd7ba7dfe),
    ULL(0xfeffffeffffeffff),
    ULL(0xbeddebf7ebdcbe7f),
    ULL(0xfefffff7fffeffff),
    ULL(0xdeeef5fbf5eedfbf),
    ULL(0xfefffffbfffefeff),
    ULL(0xeef7fafdfaf6efdf),
    ULL(0xfefffffdfffefeff),
    ULL(0xf6fbfdfefdfaf7ef),
    ULL(0xfefffffefffefeff),
    ULL(0xf6efdfbf7fbedfef),
    ULL(0xfeffffff7ffeffff),
    ULL(0xfaf7ef5fbf5eeff7),
    ULL(0xfeffffffbffeffff),
    ULL(0xfcfb77afdfae77fb),
    ULL(0xfeffffffdffeffff),
    ULL(0xfe7dbbd7efd6bb7d),
    ULL(0xfeffffffeffeffff),
    ULL(0x7ebeddebf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbedfeef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdeeff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeef7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfaf7efdfbf7ebfdf),
    ULL(0xfeffffffff7effff),
    ULL(0xfcfbf7ef5fbe5fef),
    ULL(0xfeffffffffbeffff),
    ULL(0xfefdfb77afdeaf77),
    ULL(0xfeffffffffdeffff),
    ULL(0xfefe7dbbd7eed7bb),
    ULL(0xfeffffffffeefeff),
    ULL(0xfe7fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefffffffffeffff),
    ULL(0xfefffffffffeffff),
    ULL(0xfcfbf7efdfbe7fbf),
    ULL(0xfefffffffffe7fff),
    ULL(0xfefdfbf7ef5ebf5f),
    ULL(0xfefffffffffebfff),
    ULL(0xfefefdfb77aedfaf),
    ULL(0xfefffffffffedfff),
    ULL(0xfefffe7dbbd6efd7),
    ULL(0xfefffffffffeeeff),
    ULL(0xfeff7fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdebf7f),
    ULL(0xfefffffffffeff7f),
    ULL(0xfefefdfbf7ee5fbf),
    ULL(0xfefffffffffeffbf),
    ULL(0xfefffefdfb76afdf),
    ULL(0xfefffffffffeffdf),
    ULL(0xfefffffe7dbad7ef),
    ULL(0xfefffffffffefeef),
    ULL(0xfeffff7fbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xfeff7fbfdeecf5f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdf2f77fbfdfeffff),
    ULL(0xdf7ffffffffeffff),
    ULL(0xef57bb7dfefeffff),
    ULL(0xef7ffffffffeffff),
    ULL(0xf76bddbe7ffeffff),
    ULL(0xf77ffffffffeffff),
    ULL(0xfb75eedfbf7effff),
    ULL(0xfb7ffffffffeffff),
    ULL(0xfd7af7efdfbe7fff),
    ULL(0xfd7ffffffffeffff),
    ULL(0xfe7dfbf7efdebf7f),
    ULL(0xfe7ffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaf5faf77fbfcfeff),
    ULL(0xff5ffffffffeffff),
    ULL(0xd76fd7bb7dfeffff),
    ULL(0xff6ffffffffeffff),
    ULL(0xeb77ebddbe7effff),
    ULL(0xff77fffffffeffff),
    ULL(0xf57bf5eedfbe7fff),
    ULL(0xff7bfffffffeffff),
    ULL(0xfa7dfaf7efdebf7f),
    ULL(0xff7dfffffffeffff),
    ULL(0xfd7efdfbf7eedfbf),
    ULL(0xff7efffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x772fdfaf77fafdfe),
    ULL(0xff7fdffffffeffff),
    ULL(0xbb57efd7bb7cfeff),
    ULL(0xff7feffffffeffff),
    ULL(0xdd6bf7ebddbe7fff),
    ULL(0xff7ff7fffffeffff),
    ULL(0xee75fbf5eedebf7f),
    ULL(0xff7ffbfffffeffff),
    ULL(0xf77afdfaf7eedfbf),
    ULL(0xff7ffdfffffeffff),
    ULL(0xfb7dfefdfbf6efdf),
    ULL(0xff7ffefffffeffff),
    ULL(0xef5fbf7fbfdeeff7),
    ULL(0xff7fff7ffffeffff),
    ULL(0xf76f5fbf5feef7fb),
    ULL(0xff7fffbffffeffff),
    ULL(0xfb77afdfaf76fbfd),
    ULL(0xff7fffdffffeffff),
    ULL(0x7d3bd7efd7ba7dfe),
    ULL(0xff7fffeffffeffff),
    ULL(0xbe5debf7ebdcbe7f),
    ULL(0xff7ffff7fffeffff),
    ULL(0xdf6ef5fbf5eedfbf),
    ULL(0xff7ffffbfffefeff),
    ULL(0xef77fafdfaf6efdf),
    ULL(0xff7ffffdfffefeff),
    ULL(0xf77bfdfefdfaf7ef),
    ULL(0xff7ffffefffefeff),
    ULL(0xf76fdfbf7fbedfef),
    ULL(0xff7fffff7ffeffff),
    ULL(0xfb77ef5fbf5eeff7),
    ULL(0xff7fffffbffeffff),
    ULL(0xfd7b77afdfae77fb),
    ULL(0xff7fffffdffeffff),
    ULL(0xfe7dbbd7efd6bb7d),
    ULL(0xff7fffffeffeffff),
    ULL(0x7f3eddebf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbf5feef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdf6ff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xef77fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfb77efdfbf7ebfdf),
    ULL(0xff7fffffff7effff),
    ULL(0xfd7bf7ef5fbe5fef),
    ULL(0xff7fffffffbeffff),
    ULL(0xfe7dfb77afdeaf77),
    ULL(0xff7fffffffdeffff),
    ULL(0xff7e7dbbd7eed7bb),
    ULL(0xff7fffffffeefeff),
    ULL(0xff7fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xff7ffffffffeffff),
    ULL(0xff7ffffffffeffff),
    ULL(0xfd7bf7efdfbe7fbf),
    ULL(0xff7ffffffffe7fff),
    ULL(0xfe7dfbf7ef5ebf5f),
    ULL(0xff7ffffffffebfff),
    ULL(0xff7efdfb77aedfaf),
    ULL(0xff7ffffffffedfff),
    ULL(0xff7ffe7dbbd6efd7),
    ULL(0xff7ffffffffeeeff),
    ULL(0xff7f7fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfe7dfbf7efdebf7f),
    ULL(0xff7ffffffffeff7f),
    ULL(0xff7efdfbf7ee5fbf),
    ULL(0xff7ffffffffeffbf),
    ULL(0xff7ffefdfb76afdf),
    ULL(0xff7ffffffffeffdf),
    ULL(0xff7ffffe7dbad7ef),
    ULL(0xff7ffffffffefeef),
    ULL(0xff7fff7fbedcebf7),
    ULL(0xaa55ea75ba5caa53),
    ULL(0xbf7f7fbfdeecf4f3),
    ULL(0xaa55ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xef97bb7dfefeffff),
    ULL(0xefbffffffffeffff),
    ULL(0xf7abddbe7ffeffff),
    ULL(0xf7bffffffffeffff),
    ULL(0xfbb5eedfbf7effff),
    ULL(0xfbbffffffffeffff),
    ULL(0xfdbaf7efdfbe7fff),
    ULL(0xfdbffffffffeffff),
    ULL(0xfebdfbf7efdebf7f),
    ULL(0xfebffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xd7afd7bb7dfeffff),
    ULL(0xffaffffffffeffff),
    ULL(0xebb7ebddbe7effff),
    ULL(0xffb7fffffffeffff),
    ULL(0xf5bbf5eedfbe7fff),
    ULL(0xffbbfffffffeffff),
    ULL(0xfabdfaf7efdebf7f),
    ULL(0xffbdfffffffeffff),
    ULL(0xfdbefdfbf7eedfbf),
    ULL(0xffbefffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbb97efd7bb7cfeff),
    ULL(0xffbfeffffffeffff),
    ULL(0xddabf7ebddbe7fff),
    ULL(0xffbff7fffffeffff),
    ULL(0xeeb5fbf5eedebf7f),
    ULL(0xffbffbfffffeffff),
    ULL(0xf7bafdfaf7eedfbf),
    ULL(0xffbffdfffffeffff),
    ULL(0xfbbdfefdfbf6efdf),
    ULL(0xffbffefffffeffff),
    ULL(0xef9fbf7fbfdeeff7),
    ULL(0xffbfff7ffffeffff),
    ULL(0xf7af5fbf5feef7fb),
    ULL(0xffbfffbffffeffff),
    ULL(0xfb37afdfaf76fbfd),
    ULL(0xffbfffdffffeffff),
    ULL(0xfdbbd7efd7ba7dfe),
    ULL(0xffbfffeffffeffff),
    ULL(0xbe9debf7ebdcbe7f),
    ULL(0xffbffff7fffeffff),
    ULL(0xdfaef5fbf5eedfbf),
    ULL(0xffbffffbfffefeff),
    ULL(0xefb7fafdfaf6efdf),
    ULL(0xffbffffdfffefeff),
    ULL(0xf7bbfdfefdfaf7ef),
    ULL(0xffbffffefffefeff),
    ULL(0xf7afdfbf7fbedfef),
    ULL(0xffbfffff7ffeffff),
    ULL(0xfbb7ef5fbf5eeff7),
    ULL(0xffbfffffbffeffff),
    ULL(0xfdbb77afdfae77fb),
    ULL(0xffbfffffdffeffff),
    ULL(0xfe3dbbd7efd6bb7d),
    ULL(0xffbfffffeffeffff),
    ULL(0xffbeddebf7eaddbe),
    ULL(0xba1daed7e372be5d),
    ULL(0xbf9feef5fbf4eedf),
    ULL(0x2a15aa55ab50ae5d),
    ULL(0xdfaff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xefb7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbb7efdfbf7ebfdf),
    ULL(0xffbfffffff7effff),
    ULL(0xfdbbf7ef5fbe5fef),
    ULL(0xffbfffffffbeffff),
    ULL(0xfebdfb77afdeaf77),
    ULL(0xffbfffffffdeffff),
    ULL(0xffbe7dbbd7eed7bb),
    ULL(0xffbfffffffeefeff),
    ULL(0xff3fbeddebf6ebdd),
    ULL(0xaa15aa55ab52aa5d),
    ULL(0xba1d8ec6e172b44c),
    ULL(0x2a15aa55ab50aa5d),
    ULL(0x2a15aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffbffffffffeffff),
    ULL(0xffbffffffffeffff),
    ULL(0xfdbbf7efdfbe7fbf),
    ULL(0xffbffffffffe7fff),
    ULL(0xfebdfbf7ef5ebf5f),
    ULL(0xffbffffffffebfff),
    ULL(0xffbefdfb77aedfaf),
    ULL(0xffbffffffffedfff),
    ULL(0xffbffe7dbbd6efd7),
    ULL(0xffbffffffffeeeff),
    ULL(0xffbf7fbeddeaf6eb),
    ULL(0xaa15aa55aa50a251),
    ULL(0xaa15aa55aa54aa55),
    ULL(0x2a15aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0x2a15aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfebdfbf7efdebf7f),
    ULL(0xffbffffffffeff7f),
    ULL(0xffbefdfbf7ee5fbf),
    ULL(0xffbffffffffeffbf),
    ULL(0xffbffefdfb76afdf),
    ULL(0xffbffffffffeffdf),
    ULL(0xffbffffe7dbad7ef),
    ULL(0xffbffffffffefeef),
    ULL(0xffbfff7fbedcebf7),
    ULL(0xaa95ea75ba5caa53),
    ULL(0xffbf7fbfdeecf4f3),
    ULL(0xaa95ea75ba5caa51),
    ULL(0xaa15aa55aa54aa55),
    ULL(0x2a15aa55aa54aa50),
    ULL(0xaa158a45a250a854),
    ULL(0x2a15aa55aa54aa54),
    ULL(0x7f9fdfeff7fafdfe),
    ULL(0x3fdfbfdfeff6fbfd),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7cbddbe7ffeffff),
    ULL(0xf7dffffffffeffff),
    ULL(0xfbd5eedfbf7effff),
    ULL(0xfbdffffffffeffff),
    ULL(0xfddaf7efdfbe7fff),
    ULL(0xfddffffffffeffff),
    ULL(0xfeddfbf7efdebf7f),
    ULL(0xfedffffffffeffff),
    ULL(0xbf5fbfdfeff6fbfd),
    ULL(0xff1ffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xebd7ebddbe7effff),
    ULL(0xffd7fffffffeffff),
    ULL(0xf5dbf5eedfbe7fff),
    ULL(0xffdbfffffffeffff),
    ULL(0xfaddfaf7efdebf7f),
    ULL(0xffddfffffffeffff),
    ULL(0xfddefdfbf7eedfbf),
    ULL(0xffdefffffffeffff),
    ULL(0xdf9f7fbfdfeef7fb),
    ULL(0xffdf7ffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xddcbf7ebddbe7fff),
    ULL(0xffdff7fffffeffff),
    ULL(0xeed5fbf5eedebf7f),
    ULL(0xffdffbfffffeffff),
    ULL(0xf7dafdfaf7eedfbf),
    ULL(0xffdffdfffffeffff),
    ULL(0xfbddfefdfbf6efdf),
    ULL(0xffdffefffffeffff),
    ULL(0xffdfbf7fbfdeeff7),
    ULL(0xffdfff7ffffeffff),
    ULL(0xf7cf5fbf5feef7fb),
    ULL(0xffdfffbffffeffff),
    ULL(0xfb57afdfaf76fbfd),
    ULL(0xffdfffdffffeffff),
    ULL(0x7d9bd7efd7ba7dfe),
    ULL(0xffdfffeffffeffff),
    ULL(0xfeddebf7ebdcbe7f),
    ULL(0xffdffff7fffeffff),
    ULL(0xdfcef5fbf5eedfbf),
    ULL(0xffdffffbfffefeff),
    ULL(0xefd7fafdfaf6efdf),
    ULL(0xffdffffdfffefeff),
    ULL(0xf7dbfdfefdfaf7ef),
    ULL(0xffdffffefffefeff),
    ULL(0xf7cfdfbf7fbedfef),
    ULL(0xffdfffff7ffeffff),
    ULL(0xfbd7ef5fbf5eeff7),
    ULL(0xffdfffffbffeffff),
    ULL(0xfddb77afdfae77fb),
    ULL(0xffdfffffdffeffff),
    ULL(0xfe5dbbd7efd6bb7d),
    ULL(0xffdfffffeffeffff),
    ULL(0x7f9eddebf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xffdfeef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfcff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xefd7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbd7efdfbf7ebfdf),
    ULL(0xffdfffffff7effff),
    ULL(0xfddbf7ef5fbe5fef),
    ULL(0xffdfffffffbeffff),
    ULL(0xfeddfb77afdeaf77),
    ULL(0xffdfffffffdeffff),
    ULL(0xffde7dbbd7eed7bb),
    ULL(0xffdfffffffeefeff),
    ULL(0xff5fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffdffffffffeffff),
    ULL(0xffdffffffffeffff),
    ULL(0xfddbf7efdfbe7fbf),
    ULL(0xffdffffffffe7fff),
    ULL(0xfeddfbf7ef5ebf5f),
    ULL(0xffdffffffffebfff),
    ULL(0xffdefdfb77aedfaf),
    ULL(0xffdffffffffedfff),
    ULL(0xffdffe7dbbd6efd7),
    ULL(0xffdffffffffeeeff),
    ULL(0xffdf7fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfeddfbf7efdebf7f),
    ULL(0xffdffffffffeff7f),
    ULL(0xffdefdfbf7ee5fbf),
    ULL(0xffdffffffffeffbf),
    ULL(0xffdffefdfb76afdf),
    ULL(0xffdffffffffeffdf),
    ULL(0xffdffffe7dbad7ef),
    ULL(0xffdffffffffefeef),
    ULL(0xffdfff7fbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xefdf7fbfdeecf5f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fafdfeff7fafdfe),
    ULL(0x7feffffffffeffff),
    ULL(0xbf4feff7fbfcfeff),
    ULL(0xbfeffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbe5eedfbf7effff),
    ULL(0xfbeffffffffeffff),
    ULL(0xfdeaf7efdfbe7fff),
    ULL(0xfdeffffffffeffff),
    ULL(0xfeedfbf7efdebf7f),
    ULL(0xfeeffffffffeffff),
    ULL(0xbf6fbfdfeff6fbfd),
    ULL(0xff6ffffffffeffff),
    ULL(0x5faf5feff7fafdfe),
    ULL(0xffaffffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf5ebf5eedfbe7fff),
    ULL(0xffebfffffffeffff),
    ULL(0xfaedfaf7efdebf7f),
    ULL(0xffedfffffffeffff),
    ULL(0xfdeefdfbf7eedfbf),
    ULL(0xffeefffffffeffff),
    ULL(0xdfaf7fbfdfeef7fb),
    ULL(0xffef7ffffffeffff),
    ULL(0xef4fbf5feff6fbfd),
    ULL(0xffefbffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeee5fbf5eedebf7f),
    ULL(0xffeffbfffffeffff),
    ULL(0xf7eafdfaf7eedfbf),
    ULL(0xffeffdfffffeffff),
    ULL(0xfbedfefdfbf6efdf),
    ULL(0xffeffefffffeffff),
    ULL(0xefcfbf7fbfdeeff7),
    ULL(0xffefff7ffffeffff),
    ULL(0xffef5fbf5feef7fb),
    ULL(0xffefffbffffeffff),
    ULL(0xfb67afdfaf76fbfd),
    ULL(0xffefffdffffeffff),
    ULL(0x7dabd7efd7ba7dfe),
    ULL(0xffefffeffffeffff),
    ULL(0xbecdebf7ebdcbe7f),
    ULL(0xffeffff7fffeffff),
    ULL(0xffeef5fbf5eedfbf),
    ULL(0xffeffffbfffefeff),
    ULL(0xefe7fafdfaf6efdf),
    ULL(0xffeffffdfffefeff),
    ULL(0xf7ebfdfefdfaf7ef),
    ULL(0xffeffffefffefeff),
    ULL(0xffefdfbf7fbedfef),
    ULL(0xffefffff7ffeffff),
    ULL(0xfbe7ef5fbf5eeff7),
    ULL(0xffefffffbffeffff),
    ULL(0xfdeb77afdfae77fb),
    ULL(0xffefffffdffeffff),
    ULL(0xfe6dbbd7efd6bb7d),
    ULL(0xffefffffeffeffff),
    ULL(0x7faeddebf7eaddbe),
    ULL(0xfa6dbedfe772be5d),
    ULL(0xbfcfeef5fbf4eedf),
    ULL(0xe265ba5d2b50ae5d),
    ULL(0xffeff7fafdfaf6ef),
    ULL(0x0000080400000204),
    ULL(0xefe7fbfdfefcfaf7),
    ULL(0x0000080402000204),
    ULL(0xfbe7efdfbf7ebfdf),
    ULL(0xffefffffff7effff),
    ULL(0xfdebf7ef5fbe5fef),
    ULL(0xffefffffffbeffff),
    ULL(0xfeedfb77afdeaf77),
    ULL(0xffefffffffdeffff),
    ULL(0xffee7dbbd7eed7bb),
    ULL(0xffefffffffeeffff),
    ULL(0xff6fbeddebf6ebdd),
    ULL(0xaa45aa55ab52aa5d),
    ULL(0x7a2d9ecee572b44c),
    ULL(0xa245aa552b50aa5d),
    ULL(0xa245aa552a54aa55),
    ULL(0x0000080402000204),
    ULL(0xffeffffffffeffff),
    ULL(0xffeffffffffeffff),
    ULL(0xfdebf7efdfbe7fbf),
    ULL(0xffeffffffffe7fff),
    ULL(0xfeedfbf7ef5ebf5f),
    ULL(0xffeffffffffebfff),
    ULL(0xffeefdfb77aedfaf),
    ULL(0xffeffffffffedfff),
    ULL(0xffeffe7dbbd6efd7),
    ULL(0xffeffffffffeefff),
    ULL(0xffef7fbeddeaf7eb),
    ULL(0xaa45aa55aa52a251),
    ULL(0xaa45aa55aa54ab55),
    ULL(0xa245aa552a50aa51),
    ULL(0x0000000000000000),
    ULL(0x0000080402000000),
    ULL(0xa245aa552a54aa55),
    ULL(0x0000080402000204),
    ULL(0xfeedfbf7efdebf7f),
    ULL(0xffeffffffffeff7f),
    ULL(0xffeefdfbf7ee5fbf),
    ULL(0xffeffffffffeffbf),
    ULL(0xffeffefdfb76afdf),
    ULL(0xffeffffffffeffdf),
    ULL(0xffeffffe7dbad7ef),
    ULL(0xffeffffffffeffef),
    ULL(0xffefff7fbedcebf7),
    ULL(0xaac5ea75ba5eab53),
    ULL(0xffef7fbfdeeef5f3),
    ULL(0xaac5ea75ba5cab51),
    ULL(0xaa45aa55aa54aa55),
    ULL(0xa245aa552a54aa50),
    ULL(0x2a058a45a250a854),
    ULL(0xa245aa552a54aa54),
    ULL(0x7fb7dfeff7fafdfe),
    ULL(0x7ff7fffffffeffff),
    ULL(0xbf57eff7fbfcfeff),
    ULL(0xbff7fffffffeffff),
    ULL(0xdfa777fbfdfeffff),
    ULL(0xdff7fffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfdf2f7efdfbe7fff),
    ULL(0xfdf7fffffffeffff),
    ULL(0xfef5fbf7efdebf7f),
    ULL(0xfef7fffffffeffff),
    ULL(0xbf77bfdfeff6fbfd),
    ULL(0xff77fffffffeffff),
    ULL(0x5fb75feff7fafdfe),
    ULL(0xffb7fffffffeffff),
    ULL(0xafd7af77fbfcfeff),
    ULL(0xffd7fffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfaf5faf7efdebf7f),
    ULL(0xfff5fffffffeffff),
    ULL(0xfdf6fdfbf7eedfbf),
    ULL(0xfff6fffffffeffff),
    ULL(0xdfb77fbfdfeef7fb),
    ULL(0xfff77ffffffeffff),
    ULL(0xef57bf5feff6fbfd),
    ULL(0xfff7bffffffeffff),
    ULL(0x77a7dfaf77fafdfe),
    ULL(0xfff7dffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7f2fdfaf7eedfbf),
    ULL(0xfff7fdfffffeffff),
    ULL(0xfbf5fefdfbf6efdf),
    ULL(0xfff7fefffffeffff),
    ULL(0xefd7bf7fbfdeeff7),
    ULL(0xfff7ff7ffffeffff),
    ULL(0xf7e75fbf5feef7fb),
    ULL(0xfff7ffbffffeffff),
    ULL(0xff77afdfaf76fbfd),
    ULL(0xfff7ffdffffeffff),
    ULL(0x7db3d7efd7ba7dfe),
    ULL(0xfff7ffeffffeffff),
    ULL(0xbed5ebf7ebdcbe7f),
    ULL(0xfff7fff7fffeffff),
    ULL(0xdfe6f5fbf5eedfbf),
    ULL(0xfff7fffbfffefeff),
    ULL(0xfff7fafdfaf6efdf),
    ULL(0xfff7fffdfffefeff),
    ULL(0xf7f3fdfefdfaf7ef),
    ULL(0xfff7fffefffefeff),
    ULL(0xf7e7dfbf7fbedfef),
    ULL(0xfff7ffff7ffeffff),
    ULL(0xfff7ef5fbf5eeff7),
    ULL(0xfff7ffffbffeffff),
    ULL(0xfdf377afdfae77fb),
    ULL(0xfff7ffffdffeffff),
    ULL(0xfe75bbd7efd6bb7d),
    ULL(0xfff7ffffeffeffff),
    ULL(0x7fb6ddebf7eaddbe),
    ULL(0xea75bedfe772be5d),
    ULL(0xbfd7eef5fbf4eedf),
    ULL(0xea75ba5dab50ae5d),
    ULL(0xdfe7f7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xfff7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfff7efdfbf7ebfdf),
    ULL(0xfff7ffffff7effff),
    ULL(0xfdf3f7ef5fbe5fef),
    ULL(0xfff7ffffffbeffff),
    ULL(0xfef5fb77afdeaf77),
    ULL(0xfff7ffffffdeffff),
    ULL(0xfff67dbbd7eed7bb),
    ULL(0xfff7ffffffeeffff),
    ULL(0xff77beddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x6a359ecee572b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfff7fffffffeffff),
    ULL(0xfff7fffffffeffff),
    ULL(0xfdf3f7efdfbe7fbf),
    ULL(0xfff7fffffffe7fff),
    ULL(0xfef5fbf7ef5ebf5f),
    ULL(0xfff7fffffffebfff),
    ULL(0xfff6fdfb77aedfaf),
    ULL(0xfff7fffffffedfff),
    ULL(0xfff7fe7dbbd6efd7),
    ULL(0xfff7fffffffeefff),
    ULL(0xfff77fbeddeaf7eb),
    ULL(0xaa55aa55aa52a251),
    ULL(0xaa55aa55aa54ab55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfef5fbf7efdebf7f),
    ULL(0xfff7fffffffeff7f),
    ULL(0xfff6fdfbf7ee5fbf),
    ULL(0xfff7fffffffeffbf),
    ULL(0xfff7fefdfb76afdf),
    ULL(0xfff7fffffffeffdf),
    ULL(0xfff7fffe7dbad7ef),
    ULL(0xfff7fffffffeffef),
    ULL(0xfff7ff7fbedcebf7),
    ULL(0xaad5ea75ba5eab53),
    ULL(0xfbf77fbfdeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbbdfeff7fafdfe),
    ULL(0x7ffbfffffffeffff),
    ULL(0xbf5beff7fbfcfeff),
    ULL(0xbffbfffffffeffff),
    ULL(0xdfab77fbfdfeffff),
    ULL(0xdffbfffffffeffff),
    ULL(0xefd3bb7dfefeffff),
    ULL(0xeffbfffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfef9fbf7efdebf7f),
    ULL(0xfcfbfdfbf7eedfbf),
    ULL(0xbf7bbfdfeff6fbfd),
    ULL(0xff7bfffffffeffff),
    ULL(0x5fbb5feff7fafdfe),
    ULL(0xffbbfffffffeffff),
    ULL(0xafdbaf77fbfcfeff),
    ULL(0xffdbfffffffeffff),
    ULL(0xd7ebd7bb7dfeffff),
    ULL(0xffebfffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfdfafdfbf7eedfbf),
    ULL(0xfff8fffffffeffff),
    ULL(0xdfbb7fbfdfeef7fb),
    ULL(0xfffb7ffffffeffff),
    ULL(0xef5bbf5feff6fbfd),
    ULL(0xfffbbffffffeffff),
    ULL(0x77abdfaf77fafdfe),
    ULL(0xfffbdffffffeffff),
    ULL(0xbbd3efd7bb7cfeff),
    ULL(0xfffbeffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbf9fefdfbf6efdf),
    ULL(0xfffbfefffffeffff),
    ULL(0xefdbbf7fbfdeeff7),
    ULL(0xfffbff7ffffeffff),
    ULL(0xf7eb5fbf5feef7fb),
    ULL(0xfffbffbffffeffff),
    ULL(0xfb73afdfaf76fbfd),
    ULL(0xfffbffdffffeffff),
    ULL(0x7fbbd7efd7ba7dfe),
    ULL(0xfffbffeffffeffff),
    ULL(0xbed9ebf7ebdcbe7f),
    ULL(0xfffbfff7fffeffff),
    ULL(0xdfeaf5fbf5eedfbf),
    ULL(0xfffbfffbfffefeff),
    ULL(0xeff3fafdfaf6efdf),
    ULL(0xfffbfffdfffefeff),
    ULL(0xfffbfdfefdfaf7ef),
    ULL(0xfffbfffefffefeff),
    ULL(0xf7ebdfbf7fbedfef),
    ULL(0xfffbffff7ffeffff),
    ULL(0xfbf3ef5fbf5eeff7),
    ULL(0xfffbffffbffeffff),
    ULL(0xfffb77afdfae77fb),
    ULL(0xfffbffffdffeffff),
    ULL(0xfe79bbd7efd6bb7d),
    ULL(0xfffbffffeffeffff),
    ULL(0x7fbaddebf7eaddbe),
    ULL(0xfa79bedfe772be5d),
    ULL(0xbfdbeef5fbf4eedf),
    ULL(0xe871ba5dab50ae5d),
    ULL(0xdfebf7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff3fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf3efdfbf7ebfdf),
    ULL(0xfffbffffff7effff),
    ULL(0xfffbf7ef5fbe5fef),
    ULL(0xfffbffffffbeffff),
    ULL(0xfef9fb77afdeaf77),
    ULL(0xfffbffffffdeffff),
    ULL(0xfffa7dbbd7eed7bb),
    ULL(0xfffbffffffeeffff),
    ULL(0xff7bbeddebf6ebdd),
    ULL(0xaa51aa55ab52aa5d),
    ULL(0x7a399ecee572b44c),
    ULL(0xa851aa55ab50aa5d),
    ULL(0xa851aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffbfffffffeffff),
    ULL(0xfffbfffffffeffff),
    ULL(0xfffbf7efdfbe7fbf),
    ULL(0xfffbfffffffe7fff),
    ULL(0xfef9fbf7ef5ebf5f),
    ULL(0xfffbfffffffebfff),
    ULL(0xfffafdfb77aedfaf),
    ULL(0xfffbfffffffedfff),
    ULL(0xfffbfe7dbbd6efd7),
    ULL(0xfffbfffffffeefff),
    ULL(0xfffb7fbeddeaf7eb),
    ULL(0xaa51aa55aa52a251),
    ULL(0xaa51aa55aa54ab55),
    ULL(0xa851aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xa851aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfef9fbf7efdebf7f),
    ULL(0xfffbfffffffeff7f),
    ULL(0xfffafdfbf7ee5fbf),
    ULL(0xfffbfffffffeffbf),
    ULL(0xfffbfefdfb76afdf),
    ULL(0xfffbfffffffeffdf),
    ULL(0xfffbfffe7dbad7ef),
    ULL(0xfffbfffffffeffef),
    ULL(0xfffbff7fbedcebf7),
    ULL(0xaad1ea75ba5eab53),
    ULL(0xfffb7fbfdeeef5f3),
    ULL(0xaad1ea75ba5cab51),
    ULL(0xaa51aa55aa54aa55),
    ULL(0xa851aa55aa54aa50),
    ULL(0x2a118a45a250a854),
    ULL(0xa851aa55aa54aa54),
    ULL(0x7fbddfeff7fafdfe),
    ULL(0x7ffdfffffffeffff),
    ULL(0xbf5deff7fbfcfeff),
    ULL(0xbffdfffffffeffff),
    ULL(0xdfad77fbfdfeffff),
    ULL(0xdffdfffffffeffff),
    ULL(0xefd5bb7dfefeffff),
    ULL(0xeffdfffffffeffff),
    ULL(0xf7e9ddbe7ffeffff),
    ULL(0xf7fdfffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbf7dbfdfeff6fbfd),
    ULL(0xff7dfffffffeffff),
    ULL(0x5fbd5feff7fafdfe),
    ULL(0xffbdfffffffeffff),
    ULL(0xafddaf77fbfcfeff),
    ULL(0xffddfffffffeffff),
    ULL(0xd7edd7bb7dfeffff),
    ULL(0xffedfffffffeffff),
    ULL(0xebf5ebddbe7effff),
    ULL(0xfff5fffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfbd7fbfdfeef7fb),
    ULL(0xfffd7ffffffeffff),
    ULL(0xef5dbf5feff6fbfd),
    ULL(0xfffdbffffffeffff),
    ULL(0x77addfaf77fafdfe),
    ULL(0xfffddffffffeffff),
    ULL(0xbbd5efd7bb7cfeff),
    ULL(0xfffdeffffffeffff),
    ULL(0xdde9f7ebddbe7fff),
    ULL(0xfffdf7fffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xefddbf7fbfdeeff7),
    ULL(0xfffdff7ffffeffff),
    ULL(0xf7ed5fbf5feef7fb),
    ULL(0xfffdffbffffeffff),
    ULL(0xfb75afdfaf76fbfd),
    ULL(0xfffdffdffffeffff),
    ULL(0x7db9d7efd7ba7dfe),
    ULL(0xfffdffeffffeffff),
    ULL(0xbfddebf7ebdcbe7f),
    ULL(0xfffdfff7fffeffff),
    ULL(0xdfecf5fbf5eedfbf),
    ULL(0xfffdfffbfffefeff),
    ULL(0xeff5fafdfaf6efdf),
    ULL(0xfffdfffdfffefeff),
    ULL(0xf7f9fdfefdfaf7ef),
    ULL(0xfffdfffefffefeff),
    ULL(0xf7eddfbf7fbedfef),
    ULL(0xfffdffff7ffeffff),
    ULL(0xfbf5ef5fbf5eeff7),
    ULL(0xfffdffffbffeffff),
    ULL(0xfdf977afdfae77fb),
    ULL(0xfffdffffdffeffff),
    ULL(0xff7dbbd7efd6bb7d),
    ULL(0xfffdffffeffeffff),
    ULL(0x7fbcddebf7eaddbe),
    ULL(0xfa7dbedfe772be5d),
    ULL(0xbfddeef5fbf4eedf),
    ULL(0xea75ba5dab50ae5d),
    ULL(0xdfedf7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff5fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf5efdfbf7ebfdf),
    ULL(0xfffdffffff7effff),
    ULL(0xfdf9f7ef5fbe5fef),
    ULL(0xfffdffffffbeffff),
    ULL(0xfffdfb77afdeaf77),
    ULL(0xfffdffffffdeffff),
    ULL(0xfffc7dbbd7eed7bb),
    ULL(0xfffdffffffeeffff),
    ULL(0xff7dbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x7a3d9ecee572b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffdfffffffeffff),
    ULL(0xfffdfffffffeffff),
    ULL(0xfdf9f7efdfbe7fbf),
    ULL(0xfffdfffffffe7fff),
    ULL(0xfffdfbf7ef5ebf5f),
    ULL(0xfffdfffffffebfff),
    ULL(0xfffcfdfb77aedfaf),
    ULL(0xfffdfffffffedfff),
    ULL(0xfffdfe7dbbd6efd7),
    ULL(0xfffdfffffffeefff),
    ULL(0xfffd7fbeddeaf7eb),
    ULL(0xaa55aa55aa52a251),
    ULL(0xaa55aa55aa54ab55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffdfbf7efdebf7f),
    ULL(0xfffdfffffffeff7f),
    ULL(0xfffcfdfbf7ee5fbf),
    ULL(0xfffdfffffffeffbf),
    ULL(0xfffdfefdfb76afdf),
    ULL(0xfffdfffffffeffdf),
    ULL(0xfffdfffe7dbad7ef),
    ULL(0xfffdfffffffeffef),
    ULL(0xfffdff7fbedcebf7),
    ULL(0xaad5ea75ba5eab53),
    ULL(0xfefd7fbfdeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbedfeff7fafdfe),
    ULL(0x7ffefffffffeffff),
    ULL(0xbf5eeff7fbfcfeff),
    ULL(0xbffefffffffeffff),
    ULL(0xdfae77fbfdfeffff),
    ULL(0xdffefffffffeffff),
    ULL(0xefd6bb7dfefeffff),
    ULL(0xeffefffffffeffff),
    ULL(0xf7eaddbe7ffeffff),
    ULL(0xf7fefffffffeffff),
    ULL(0xfbf4eedfbf7effff),
    ULL(0xfbfefffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbf7ebfdfeff6fbfd),
    ULL(0xff7efffffffeffff),
    ULL(0x5fbe5feff7fafdfe),
    ULL(0xffbefffffffeffff),
    ULL(0xafdeaf77fbfcfeff),
    ULL(0xffdefffffffeffff),
    ULL(0xd7eed7bb7dfeffff),
    ULL(0xffeefffffffeffff),
    ULL(0xebf6ebddbe7effff),
    ULL(0xfff6fffffffeffff),
    ULL(0xf5faf5eedfbe7fff),
    ULL(0xfffafffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfbe7fbfdfeef7fb),
    ULL(0xfffe7ffffffeffff),
    ULL(0xef5ebf5feff6fbfd),
    ULL(0xfffebffffffeffff),
    ULL(0x77aedfaf77fafdfe),
    ULL(0xfffedffffffeffff),
    ULL(0xbbd6efd7bb7cfeff),
    ULL(0xfffeeffffffeffff),
    ULL(0xddeaf7ebddbe7fff),
    ULL(0xfffef7fffffeffff),
    ULL(0xeef4fbf5eedebf7f),
    ULL(0xfffefbfffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xefdebf7fbfdeeff7),
    ULL(0xfffeff7ffffeffff),
    ULL(0xf7ee5fbf5feef7fb),
    ULL(0xfffeffbffffeffff),
    ULL(0xfb76afdfaf76fbfd),
    ULL(0xfffeffdffffeffff),
    ULL(0x7dbad7efd7ba7dfe),
    ULL(0xfffeffeffffeffff),
    ULL(0xbedcebf7ebdcbe7f),
    ULL(0xfffefff7fffeffff),
    ULL(0xdfeef5fbf5eedfbf),
    ULL(0xfffefffbfffefeff),
    ULL(0xeff6fafdfaf6efdf),
    ULL(0xfffefffdfffefeff),
    ULL(0xf7fafdfefdfaf7ef),
    ULL(0xfffefffefffefeff),
    ULL(0xf7eedfbf7fbedfef),
    ULL(0xfffeffff7ffeffff),
    ULL(0xfbf6ef5fbf5eeff7),
    ULL(0xfffeffffbffeffff),
    ULL(0xfdfa77afdfae77fb),
    ULL(0xfffeffffdffeffff),
    ULL(0xfe7cbbd7efd6bb7d),
    ULL(0xfffeffffeffeffff),
    ULL(0x7fbeddebf7eaddbe),
    ULL(0xfa7cbedfe772be5d),
    ULL(0xbfdeeef5fbf4eedf),
    ULL(0xea74ba5dab50ae5d),
    ULL(0xdfeef7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff6fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf6efdfbf7ebfdf),
    ULL(0xfffeffffff7effff),
    ULL(0xfdfaf7ef5fbe5fef),
    ULL(0xfffeffffffbeffff),
    ULL(0xfefcfb77afdeaf77),
    ULL(0xfffeffffffdeffff),
    ULL(0xfffe7dbbd7eed7bb),
    ULL(0xfffeffffffeeffff),
    ULL(0xff7ebeddebf6ebdd),
    ULL(0xaa54aa55ab52aa5d),
    ULL(0x7a3c9ecee572b44c),
    ULL(0xaa54aa55ab50aa5d),
    ULL(0xaa54aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffefffffffeffff),
    ULL(0xfffefffffffeffff),
    ULL(0xfdfaf7efdfbe7fbf),
    ULL(0xfffefffffffe7fff),
    ULL(0xfefcfbf7ef5ebf5f),
    ULL(0xfffefffffffebfff),
    ULL(0xfffefdfb77aedfaf),
    ULL(0xfffefffffffedfff),
    ULL(0xfffefe7dbbd6efd7),
    ULL(0xfffefffffffeefff),
    ULL(0xfffe7fbeddeaf7eb),
    ULL(0xaa54aa55aa52a251),
    ULL(0xaa54aa55aa54ab55),
    ULL(0xaa54aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa54aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefcfbf7efdebf7f),
    ULL(0xfffefffffffeff7f),
    ULL(0xfffefdfbf7ee5fbf),
    ULL(0xfffefffffffeffbf),
    ULL(0xfffefefdfb76afdf),
    ULL(0xfffefffffffeffdf),
    ULL(0xfffefffe7dbad7ef),
    ULL(0xfffefffffffeffef),
    ULL(0xfffeff7fbedcebf7),
    ULL(0xaad4ea75ba5eab53),
    ULL(0xfffe7fbfdeeef5f3),
    ULL(0xaad4ea75ba5cab51),
    ULL(0xaa54aa55aa54aa55),
    ULL(0xaa54aa55aa54aa50),
    ULL(0x2a148a45a250a854),
    ULL(0xaa54aa55aa54aa54),
    ULL(0x7fbf5feff7fafdfe),
    ULL(0x7f5f6ff7fbfcfeff),
    ULL(0xbf5f6ff7fbfcfeff),
    ULL(0xbfff7ffffffeffff),
    ULL(0xdfaf77fbfdfeffff),
    ULL(0xdfff7ffffffeffff),
    ULL(0xefd73b7dfefeffff),
    ULL(0xefff7ffffffeffff),
    ULL(0xf7eb5dbe7ffeffff),
    ULL(0xf7ff7ffffffeffff),
    ULL(0xfbf56edfbf7effff),
    ULL(0xfbff7ffffffeffff),
    ULL(0xfdfa77efdfbe7fff),
    ULL(0xfdff7ffffffeffff),
    ULL(0xfefd7bf7efdebf7f),
    ULL(0xfeff7ffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xafdf2f77fbfcfeff),
    ULL(0xffdf7ffffffeffff),
    ULL(0xd7ef57bb7dfeffff),
    ULL(0xffef7ffffffeffff),
    ULL(0xebf76bddbe7effff),
    ULL(0xfff77ffffffeffff),
    ULL(0xf5fb75eedfbe7fff),
    ULL(0xfffb7ffffffeffff),
    ULL(0xfafd7af7efdebf7f),
    ULL(0xfffd7ffffffeffff),
    ULL(0xfdfe7dfbf7eedfbf),
    ULL(0xfffe7ffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x77af5faf77fafdfe),
    ULL(0xffff5ffffffeffff),
    ULL(0xbbd76fd7bb7cfeff),
    ULL(0xffff6ffffffeffff),
    ULL(0xddeb77ebddbe7fff),
    ULL(0xffff77fffffeffff),
    ULL(0xeef57bf5eedebf7f),
    ULL(0xffff7bfffffeffff),
    ULL(0xf7fa7dfaf7eedfbf),
    ULL(0xffff7dfffffeffff),
    ULL(0xfbfd7efdfbf6efdf),
    ULL(0xffff7efffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfb772fdfaf76fbfd),
    ULL(0xffff7fdffffeffff),
    ULL(0x7dbb57efd7ba7dfe),
    ULL(0xffff7feffffeffff),
    ULL(0xbedd6bf7ebdcbe7f),
    ULL(0xffff7ff7fffeffff),
    ULL(0xdfee75fbf5eedfbf),
    ULL(0xffff7ffbfffefeff),
    ULL(0xeff77afdfaf6efdf),
    ULL(0xffff7ffdfffefeff),
    ULL(0xf7fb7dfefdfaf7ef),
    ULL(0xffff7ffefffefeff),
    ULL(0xf7ef5fbf7fbedfef),
    ULL(0xffff7fff7ffeffff),
    ULL(0xfbf76f5fbf5eeff7),
    ULL(0xffff7fffbffeffff),
    ULL(0xfdfb77afdfae77fb),
    ULL(0xffff7fffdffeffff),
    ULL(0xfe7d3bd7efd6bb7d),
    ULL(0xffff7fffeffeffff),
    ULL(0x7fbe5debf7eaddbe),
    ULL(0xba5d2ed7e372be5d),
    ULL(0xbfdf6ef5fbf4eedf),
    ULL(0xaa552a55ab50ae5d),
    ULL(0xdfef77fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff77bfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf76fdfbf7ebfdf),
    ULL(0xffff7fffff7effff),
    ULL(0xfdfb77ef5fbe5fef),
    ULL(0xffff7fffffbeffff),
    ULL(0xfefd7b77afdeaf77),
    ULL(0xffff7fffffdeffff),
    ULL(0xfffe7dbbd7eed7bb),
    ULL(0xffff7fffffeefeff),
    ULL(0xff7f3eddebf6ebdd),
    ULL(0xaa552a55ab52aa5d),
    ULL(0x3a1d0ec6e172b44c),
    ULL(0xaa552a55ab50aa5d),
    ULL(0xaa552a55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffff7ffffffeffff),
    ULL(0xffff7ffffffeffff),
    ULL(0xfdfb77efdfbe7fbf),
    ULL(0xffff7ffffffe7fff),
    ULL(0xfefd7bf7ef5ebf5f),
    ULL(0xffff7ffffffebfff),
    ULL(0xfffe7dfb77aedfaf),
    ULL(0xffff7ffffffedfff),
    ULL(0xffff7e7dbbd6efd7),
    ULL(0xffff7ffffffeeeff),
    ULL(0xffff7fbeddeaf6eb),
    ULL(0xaa552a55aa50a251),
    ULL(0xaa552a55aa54aa55),
    ULL(0xaa552a55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa552a55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefd7bf7efdebf7f),
    ULL(0xffff7ffffffeff7f),
    ULL(0xfffe7dfbf7ee5fbf),
    ULL(0xffff7ffffffeffbf),
    ULL(0xffff7efdfb76afdf),
    ULL(0xffff7ffffffeffdf),
    ULL(0xffff7ffe7dbad7ef),
    ULL(0xffff7ffffffefeef),
    ULL(0xffff7f7fbedcebf7),
    ULL(0xaad56a75ba5caa53),
    ULL(0xffff7fbfdeecf4f3),
    ULL(0xaad56a75ba5caa51),
    ULL(0xaa552a55aa54aa55),
    ULL(0xaa552a55aa54aa50),
    ULL(0x2a150a45a250a854),
    ULL(0xaa552a55aa54aa54),
    ULL(0x7fbf9feff7fafdfe),
    ULL(0x7f5faff7fbfcfeff),
    ULL(0xbf5faff7fbfcfeff),
    ULL(0xbfbfbffffffeffff),
    ULL(0xdfaf37fbfdfeffff),
    ULL(0xdfffbffffffeffff),
    ULL(0xefd7bbfdfefeffff),
    ULL(0xefffbffffffeffff),
    ULL(0xf7eb9dbe7ffeffff),
    ULL(0xf7ffbffffffeffff),
    ULL(0xfbf5aedfbf7effff),
    ULL(0xfbffbffffffeffff),
    ULL(0xfdfab7efdfbe7fff),
    ULL(0xfdffbffffffeffff),
    ULL(0xfefdbbf7efdebf7f),
    ULL(0xfeffbffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xd7ef97bb7dfeffff),
    ULL(0xffefbffffffeffff),
    ULL(0xebf7abddbe7effff),
    ULL(0xfff7bffffffeffff),
    ULL(0xf5fbb5eedfbe7fff),
    ULL(0xfffbbffffffeffff),
    ULL(0xfafdbaf7efdebf7f),
    ULL(0xfffdbffffffeffff),
    ULL(0xfdfebdfbf7eedfbf),
    ULL(0xfffebffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbbd7afd7bb7cfeff),
    ULL(0xffffaffffffeffff),
    ULL(0xddebb7ebddbe7fff),
    ULL(0xffffb7fffffeffff),
    ULL(0xeef5bbf5eedebf7f),
    ULL(0xffffbbfffffeffff),
    ULL(0xf7fabdfaf7eedfbf),
    ULL(0xffffbdfffffeffff),
    ULL(0xfbfdbefdfbf6efdf),
    ULL(0xffffbefffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7dbb97efd7ba7dfe),
    ULL(0xffffbfeffffeffff),
    ULL(0xbeddabf7ebdcbe7f),
    ULL(0xffffbff7fffeffff),
    ULL(0xdfeeb5fbf5eedfbf),
    ULL(0xffffbffbfffefeff),
    ULL(0xeff7bafdfaf6efdf),
    ULL(0xffffbffdfffefeff),
    ULL(0xf7fbbdfefdfaf7ef),
    ULL(0xffffbffefffefeff),
    ULL(0xf7ef9fbf7fbedfef),
    ULL(0xffffbfff7ffeffff),
    ULL(0xfbf7af5fbf5eeff7),
    ULL(0xffffbfffbffeffff),
    ULL(0xfdfb37afdfae77fb),
    ULL(0xffffbfffdffeffff),
    ULL(0xfefdbbd7efd6bb7d),
    ULL(0xffffbfffeffeffff),
    ULL(0x7fbe9debf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfaef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfefb7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7bbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7afdfbf7ebfdf),
    ULL(0xffffbfffff7effff),
    ULL(0xfdfbb7ef5fbe5fef),
    ULL(0xffffbfffffbeffff),
    ULL(0xfefdbb77afdeaf77),
    ULL(0xffffbfffffdeffff),
    ULL(0xfffe3dbbd7eed7bb),
    ULL(0xffffbfffffeefeff),
    ULL(0xffffbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffbffffffeffff),
    ULL(0xffffbffffffeffff),
    ULL(0xfdfbb7efdfbe7fbf),
    ULL(0xffffbffffffe7fff),
    ULL(0xfefdbbf7ef5ebf5f),
    ULL(0xffffbffffffebfff),
    ULL(0xfffebdfb77aedfaf),
    ULL(0xffffbffffffedfff),
    ULL(0xffffbe7dbbd6efd7),
    ULL(0xffffbffffffeeeff),
    ULL(0xffff3fbeddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdbbf7efdebf7f),
    ULL(0xffffbffffffeff7f),
    ULL(0xfffebdfbf7ee5fbf),
    ULL(0xffffbffffffeffbf),
    ULL(0xffffbefdfb76afdf),
    ULL(0xffffbffffffeffdf),
    ULL(0xffffbffe7dbad7ef),
    ULL(0xffffbffffffefeef),
    ULL(0xffffbf7fbedcebf7),
    ULL(0xaa55aa75ba5caa53),
    ULL(0xafdf3f3fdeecf4f3),
    ULL(0xaa55aa75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdffffffeffff),
    ULL(0x7fffdffffffeffff),
    ULL(0xbf5fcff7fbfcfeff),
    ULL(0xbfffdffffffeffff),
    ULL(0xdfaf57fbfdfeffff),
    ULL(0xdfdfdffffffeffff),
    ULL(0xefd79b7dfefeffff),
    ULL(0xefffdffffffeffff),
    ULL(0xf7ebddfefffeffff),
    ULL(0xf7ffdffffffeffff),
    ULL(0xfbf5cedfbf7effff),
    ULL(0xfbffdffffffeffff),
    ULL(0xfdfad7efdfbe7fff),
    ULL(0xfdffdffffffeffff),
    ULL(0xfefddbf7efdebf7f),
    ULL(0xfeffdffffffeffff),
    ULL(0xbf7f9fdfeff6fbfd),
    ULL(0xff7fdffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xebf7cbddbe7effff),
    ULL(0xfff7dffffffeffff),
    ULL(0xf5fbd5eedfbe7fff),
    ULL(0xfffbdffffffeffff),
    ULL(0xfafddaf7efdebf7f),
    ULL(0xfffddffffffeffff),
    ULL(0xfdfeddfbf7eedfbf),
    ULL(0xfffedffffffeffff),
    ULL(0xdfbf5fbfdfeef7fb),
    ULL(0xffff1ffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xddebd7ebddbe7fff),
    ULL(0xffffd7fffffeffff),
    ULL(0xeef5dbf5eedebf7f),
    ULL(0xffffdbfffffeffff),
    ULL(0xf7faddfaf7eedfbf),
    ULL(0xffffddfffffeffff),
    ULL(0xfbfddefdfbf6efdf),
    ULL(0xffffdefffffeffff),
    ULL(0xefdf9f7fbfdeeff7),
    ULL(0xffffdf7ffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbeddcbf7ebdcbe7f),
    ULL(0xffffdff7fffeffff),
    ULL(0xdfeed5fbf5eedfbf),
    ULL(0xffffdffbfffefeff),
    ULL(0xeff7dafdfaf6efdf),
    ULL(0xffffdffdfffefeff),
    ULL(0xf7fbddfefdfaf7ef),
    ULL(0xffffdffefffefeff),
    ULL(0xffffdfbf7fbedfef),
    ULL(0xffffdfff7ffeffff),
    ULL(0xfbf7cf5fbf5eeff7),
    ULL(0xffffdfffbffeffff),
    ULL(0xfdfb57afdfae77fb),
    ULL(0xffffdfffdffeffff),
    ULL(0xfe7d9bd7efd6bb7d),
    ULL(0xffffdfffeffeffff),
    ULL(0xfffeddebf7eaddbe),
    ULL(0xba5d8ed7e372be5d),
    ULL(0xbfdfcef5fbf4eedf),
    ULL(0x2a558a552b50ae5d),
    ULL(0xdfefd7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7dbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7cfdfbf7ebfdf),
    ULL(0xffffdfffff7effff),
    ULL(0xfdfbd7ef5fbe5fef),
    ULL(0xffffdfffffbeffff),
    ULL(0xfefddb77afdeaf77),
    ULL(0xffffdfffffdeffff),
    ULL(0xfffe5dbbd7eed7bb),
    ULL(0xffffdfffffeefeff),
    ULL(0xff7f9eddebf6ebdd),
    ULL(0xaa558a55ab52aa5d),
    ULL(0xba5d8ec6e172b44c),
    ULL(0x2a558a552b50aa5d),
    ULL(0x2a558a552a54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffdffffffeffff),
    ULL(0xffffdffffffeffff),
    ULL(0xfdfbd7efdfbe7fbf),
    ULL(0xffffdffffffe7fff),
    ULL(0xfefddbf7ef5ebf5f),
    ULL(0xffffdffffffebfff),
    ULL(0xfffeddfb77aedfaf),
    ULL(0xffffdffffffedfff),
    ULL(0xffffde7dbbd6efd7),
    ULL(0xffffdffffffeeeff),
    ULL(0xffff5fbeddeaf6eb),
    ULL(0xaa558a55aa50a251),
    ULL(0xaa558a55aa54aa55),
    ULL(0x2a558a552a50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0x2a558a552a54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefddbf7efdebf7f),
    ULL(0xffffdffffffeff7f),
    ULL(0xfffeddfbf7ee5fbf),
    ULL(0xffffdffffffeffbf),
    ULL(0xffffdefdfb76afdf),
    ULL(0xffffdffffffeffdf),
    ULL(0xffffdffe7dbad7ef),
    ULL(0xffffdffffffefeef),
    ULL(0xffffdf7fbedcebf7),
    ULL(0xaad5ca75ba5caa53),
    ULL(0xffff5fbfdeecf5f3),
    ULL(0xaad5ca75ba5caa51),
    ULL(0xaa558a55aa54aa55),
    ULL(0x2a558a552a54aa50),
    ULL(0xaa558a45a250a854),
    ULL(0x2a558a552a54aa54),
    ULL(0x7fbfcfeff7fafdfe),
    ULL(0x7fffeffffffeffff),
    ULL(0xbf5feffffffeffff),
    ULL(0xbfffeffffffeffff),
    ULL(0xdfaf67fbfdfeffff),
    ULL(0xdfffeffffffeffff),
    ULL(0xefd7ab7dfefeffff),
    ULL(0xefefeffffffeffff),
    ULL(0xf7ebcdbe7ffeffff),
    ULL(0xf7ffeffffffeffff),
    ULL(0xfbf5eefffffeffff),
    ULL(0xfbffeffffffeffff),
    ULL(0xfdfae7efdfbe7fff),
    ULL(0xfdffeffffffeffff),
    ULL(0xfefdebf7efdebf7f),
    ULL(0xfeffeffffffeffff),
    ULL(0xbf7fafdfeff6fbfd),
    ULL(0xff7feffffffeffff),
    ULL(0x5fbf4feff7fafdfe),
    ULL(0xffbfeffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf5fbe5eedfbe7fff),
    ULL(0xfffbeffffffeffff),
    ULL(0xfafdeaf7efdebf7f),
    ULL(0xfffdeffffffeffff),
    ULL(0xfdfeedfbf7eedfbf),
    ULL(0xfffeeffffffeffff),
    ULL(0xdfbf6fbfdfeef7fb),
    ULL(0xffff6ffffffeffff),
    ULL(0xef5faf5feff6fbfd),
    ULL(0xffffaffffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeef5ebf5eedebf7f),
    ULL(0xffffebfffffeffff),
    ULL(0xf7faedfaf7eedfbf),
    ULL(0xffffedfffffeffff),
    ULL(0xfbfdeefdfbf6efdf),
    ULL(0xffffeefffffeffff),
    ULL(0xefdfaf7fbfdeeff7),
    ULL(0xffffef7ffffeffff),
    ULL(0xf7ef4fbf5feef7fb),
    ULL(0xffffefbffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfeee5fbf5eedfbf),
    ULL(0xffffeffbfffefeff),
    ULL(0xeff7eafdfaf6efdf),
    ULL(0xffffeffdfffefeff),
    ULL(0xf7fbedfefdfaf7ef),
    ULL(0xffffeffefffefeff),
    ULL(0xf7efcfbf7fbedfef),
    ULL(0xffffefff7ffeffff),
    ULL(0xffffef5fbf5eeff7),
    ULL(0xffffefffbffeffff),
    ULL(0xfdfb67afdfae77fb),
    ULL(0xffffefffdffeffff),
    ULL(0xfe7dabd7efd6bb7d),
    ULL(0xffffefffeffeffff),
    ULL(0x7fbecdebf7eaddbe),
    ULL(0xfa7daedfe772be5d),
    ULL(0xffffeef5fbf4eedf),
    ULL(0xaa55aa5dab50ae5d),
    ULL(0xdfefe7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7ebfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xffffefdfbf7ebfdf),
    ULL(0xffffefffff7effff),
    ULL(0xfdfbe7ef5fbe5fef),
    ULL(0xffffefffffbeffff),
    ULL(0xfefdeb77afdeaf77),
    ULL(0xffffefffffdeffff),
    ULL(0xfffe6dbbd7eed7bb),
    ULL(0xffffefffffeeffff),
    ULL(0xff7faeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x7a3d8ecee572b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffeffffffeffff),
    ULL(0xffffeffffffeffff),
    ULL(0xfdfbe7efdfbe7fbf),
    ULL(0xffffeffffffe7fff),
    ULL(0xfefdebf7ef5ebf5f),
    ULL(0xffffeffffffebfff),
    ULL(0xfffeedfb77aedfaf),
    ULL(0xffffeffffffedfff),
    ULL(0xffffee7dbbd6efd7),
    ULL(0xffffeffffffeefff),
    ULL(0xffff6fbeddeaf7eb),
    ULL(0xaa55aa55aa52a251),
    ULL(0xaa55aa55aa54ab55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdebf7efdebf7f),
    ULL(0xffffeffffffeff7f),
    ULL(0xfffeedfbf7ee5fbf),
    ULL(0xffffeffffffeffbf),
    ULL(0xffffeefdfb76afdf),
    ULL(0xffffeffffffeffdf),
    ULL(0xffffeffe7dbad7ef),
    ULL(0xffffeffffffeffef),
    ULL(0xffffef7fbedcebf7),
    ULL(0xaad5ea75ba5eab53),
    ULL(0xfbf76fbfdeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfd7eff7fafdfe),
    ULL(0x7ffff7fffffeffff),
    ULL(0xbf5fe7f7fbfcfeff),
    ULL(0xbffff7fffffeffff),
    ULL(0xdfaf77fffffeffff),
    ULL(0xdffff7fffffeffff),
    ULL(0xefd7b37dfefeffff),
    ULL(0xeffff7fffffeffff),
    ULL(0xf7ebd5be7ffeffff),
    ULL(0xf7f7f7fffffeffff),
    ULL(0xfbf5e6dfbf7effff),
    ULL(0xfbfff7fffffeffff),
    ULL(0xfdfaf7fffffeffff),
    ULL(0xfdfff7fffffeffff),
    ULL(0xfefdf3f7efdebf7f),
    ULL(0xfefff7fffffeffff),
    ULL(0xbf7fb7dfeff6fbfd),
    ULL(0xff7ff7fffffeffff),
    ULL(0x5fbf57eff7fafdfe),
    ULL(0xffbff7fffffeffff),
    ULL(0xafdfa777fbfcfeff),
    ULL(0xffdff7fffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfafdf2f7efdebf7f),
    ULL(0xfffdf7fffffeffff),
    ULL(0xfdfef5fbf7eedfbf),
    ULL(0xfffef7fffffeffff),
    ULL(0xdfbf77bfdfeef7fb),
    ULL(0xffff77fffffeffff),
    ULL(0xef5fb75feff6fbfd),
    ULL(0xffffb7fffffeffff),
    ULL(0x77afd7af77fafdfe),
    ULL(0xffffd7fffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7faf5faf7eedfbf),
    ULL(0xfffff5fffffeffff),
    ULL(0xfbfdf6fdfbf6efdf),
    ULL(0xfffff6fffffeffff),
    ULL(0xefdfb77fbfdeeff7),
    ULL(0xfffff77ffffeffff),
    ULL(0xf7ef57bf5feef7fb),
    ULL(0xfffff7bffffeffff),
    ULL(0xfb77a7dfaf76fbfd),
    ULL(0xfffff7dffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeff7f2fdfaf6efdf),
    ULL(0xfffff7fdfffefeff),
    ULL(0xf7fbf5fefdfaf7ef),
    ULL(0xfffff7fefffefeff),
    ULL(0xf7efd7bf7fbedfef),
    ULL(0xfffff7ff7ffeffff),
    ULL(0xfbf7e75fbf5eeff7),
    ULL(0xfffff7ffbffeffff),
    ULL(0xffff77afdfae77fb),
    ULL(0xfffff7ffdffeffff),
    ULL(0xfe7db3d7efd6bb7d),
    ULL(0xfffff7ffeffeffff),
    ULL(0x7fbed5ebf7eaddbe),
    ULL(0xfffff7fff7fafffd),
    ULL(0xbfdfe6f5fbf4eedf),
    ULL(0xe071b25d2b102e5d),
    ULL(0xfffff7fafdfaf6ef),
    ULL(0x0000000400000204),
    ULL(0xeff7f3fdfefcfaf7),
    ULL(0x0000000402000204),
    ULL(0xfbf7e7dfbf7ebfdf),
    ULL(0xfffff7ffff7effff),
    ULL(0xfffff7ef5fbe5fef),
    ULL(0xfffff7ffffbeffff),
    ULL(0xfefdf377afdeaf77),
    ULL(0xfffff7ffffdeffff),
    ULL(0xfffe75bbd7eed7bb),
    ULL(0xfffff7ffffeeffff),
    ULL(0xff7fb6ddebf6ebdd),
    ULL(0xeaf5f27dbf52ab5d),
    ULL(0x7fbfd7eef5faf5ec),
    ULL(0xe071b25d2f102a5d),
    ULL(0xa051a2552a142a55),
    ULL(0x0000000402000204),
    ULL(0xfffff7fffffeffff),
    ULL(0xfffff7fffffeffff),
    ULL(0xfffff7efdfbe7fbf),
    ULL(0xfffff7fffffe7fff),
    ULL(0xfefdf3f7ef5ebf5f),
    ULL(0xfffff7fffffebfff),
    ULL(0xfffef5fb77aedfaf),
    ULL(0xfffff7fffffedfff),
    ULL(0xfffff67dbbd6efd7),
    ULL(0xfffff7fffffeefff),
    ULL(0xffff77beddeaf7eb),
    ULL(0xeaf5f27dbe5aa351),
    ULL(0xea75b25dae54ab55),
    ULL(0xa051a2552a102b51),
    ULL(0x0000000000000000),
    ULL(0x0000000402000000),
    ULL(0xa051a2552a142a55),
    ULL(0x0000000402000204),
    ULL(0xfefdf3f7efdebf7f),
    ULL(0xfffff7fffffeff7f),
    ULL(0xfffef5fbf7ee5fbf),
    ULL(0xfffff7fffffeffbf),
    ULL(0xfffff6fdfb76afdf),
    ULL(0xfffff7fffffeffdf),
    ULL(0xfffff7fe7dbad7ef),
    ULL(0xfffff7fffffeffef),
    ULL(0xfffff77fbedcebf7),
    ULL(0xeaf5f27dbe5eab53),
    ULL(0xffff77bfdeeef5f3),
    ULL(0xaad5e275ba5cab51),
    ULL(0xaa55a255aa54aa55),
    ULL(0xa051a2552a142a50),
    ULL(0x2a158245a250a854),
    ULL(0xa051a2552a142a54),
    ULL(0x7fbfdbeff7fafdfe),
    ULL(0x7ffffbfffffeffff),
    ULL(0xbf5febf7fbfcfeff),
    ULL(0xbffffbfffffeffff),
    ULL(0xdfaf73fbfdfeffff),
    ULL(0xdffffbfffffeffff),
    ULL(0xefd7bb7ffffeffff),
    ULL(0xeffffbfffffeffff),
    ULL(0xf7ebd9be7ffeffff),
    ULL(0xf7fffbfffffeffff),
    ULL(0xfbf5eadfbf7effff),
    ULL(0xfbfbfbfffffeffff),
    ULL(0xfdfaf3efdfbe7fff),
    ULL(0xfdfffbfffffeffff),
    ULL(0xfefdfbfffffeffff),
    ULL(0xfefffbfffffeffff),
    ULL(0xbf7fbbdfeff6fbfd),
    ULL(0xff7ffbfffffeffff),
    ULL(0x5fbf5beff7fafdfe),
    ULL(0xffbffbfffffeffff),
    ULL(0xafdfab77fbfcfeff),
    ULL(0xffdffbfffffeffff),
    ULL(0xd7efd3bb7dfeffff),
    ULL(0xffeffbfffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfdfef9fbf7eedfbf),
    ULL(0xfffefbfffffeffff),
    ULL(0xdfbf7bbfdfeef7fb),
    ULL(0xffff7bfffffeffff),
    ULL(0xef5fbb5feff6fbfd),
    ULL(0xffffbbfffffeffff),
    ULL(0x77afdbaf77fafdfe),
    ULL(0xffffdbfffffeffff),
    ULL(0xbbd7ebd7bb7cfeff),
    ULL(0xffffebfffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbfdfafdfbf6efdf),
    ULL(0xfffff8fffffeffff),
    ULL(0xefdfbb7fbfdeeff7),
    ULL(0xfffffb7ffffeffff),
    ULL(0xf7ef5bbf5feef7fb),
    ULL(0xfffffbbffffeffff),
    ULL(0xfb77abdfaf76fbfd),
    ULL(0xfffffbdffffeffff),
    ULL(0x7dbbd3efd7ba7dfe),
    ULL(0xfffffbeffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7fbf9fefdfaf7ef),
    ULL(0xfffffbfefffefeff),
    ULL(0xf7efdbbf7fbedfef),
    ULL(0xfffffbff7ffeffff),
    ULL(0xfbf7eb5fbf5eeff7),
    ULL(0xfffffbffbffeffff),
    ULL(0xfdfb73afdfae77fb),
    ULL(0xfffffbffdffeffff),
    ULL(0xff7fbbd7efd6bb7d),
    ULL(0xfffffbffeffeffff),
    ULL(0x7fbed9ebf7eaddbe),
    ULL(0xfefdfbfff7fafffd),
    ULL(0xbfdfeaf5fbf4eedf),
    ULL(0xea75ba5dab50ae5d),
    ULL(0xdfeff3fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xfffffbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7ebdfbf7ebfdf),
    ULL(0xfffffbffff7effff),
    ULL(0xfdfbf3ef5fbe5fef),
    ULL(0xfffffbffffbeffff),
    ULL(0xfffffb77afdeaf77),
    ULL(0xfffffbffffdeffff),
    ULL(0xfffe79bbd7eed7bb),
    ULL(0xfffffbffffeeffff),
    ULL(0xff7fbaddebf6ebdd),
    ULL(0xeaf5fa7dbf52ab5d),
    ULL(0x7ebddbeef5faf5ec),
    ULL(0xea75ba5daf50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffbfffffeffff),
    ULL(0xfffffbfffffeffff),
    ULL(0xfdfbf3efdfbe7fbf),
    ULL(0xfffffbfffffe7fff),
    ULL(0xfffffbf7ef5ebf5f),
    ULL(0xfffffbfffffebfff),
    ULL(0xfffef9fb77aedfaf),
    ULL(0xfffffbfffffedfff),
    ULL(0xfffffa7dbbd6efd7),
    ULL(0xfffffbfffffeefff),
    ULL(0xffff7bbeddeaf7eb),
    ULL(0xeaf5fa7dbe5aa351),
    ULL(0xea75ba5dae54ab55),
    ULL(0xaa55aa55aa50ab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffbf7efdebf7f),
    ULL(0xfffffbfffffeff7f),
    ULL(0xfffef9fbf7ee5fbf),
    ULL(0xfffffbfffffeffbf),
    ULL(0xfffffafdfb76afdf),
    ULL(0xfffffbfffffeffdf),
    ULL(0xfffffbfe7dbad7ef),
    ULL(0xfffffbfffffeffef),
    ULL(0xfffffb7fbedcebf7),
    ULL(0xeaf5fa7dbe5eab53),
    ULL(0xfefd7bbfdeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfddeff7fafdfe),
    ULL(0x7ffffdfffffeffff),
    ULL(0xbf5fedf7fbfcfeff),
    ULL(0xbffffdfffffeffff),
    ULL(0xdfaf75fbfdfeffff),
    ULL(0xdffffdfffffeffff),
    ULL(0xefd7b97dfefeffff),
    ULL(0xeffffdfffffeffff),
    ULL(0xf7ebddbf7ffeffff),
    ULL(0xf7fffdfffffeffff),
    ULL(0xfbf5ecdfbf7effff),
    ULL(0xfbfffdfffffeffff),
    ULL(0xfdfaf5efdfbe7fff),
    ULL(0xfdfdfdfffffeffff),
    ULL(0xfefdf9f7efdebf7f),
    ULL(0xfefaf5efdfbe7fff),
    ULL(0xbf7fbddfeff6fbfd),
    ULL(0xff7ffdfffffeffff),
    ULL(0x5fbf5deff7fafdfe),
    ULL(0xffbffdfffffeffff),
    ULL(0xafdfad77fbfcfeff),
    ULL(0xffdffdfffffeffff),
    ULL(0xd7efd5bb7dfeffff),
    ULL(0xffeffdfffffeffff),
    ULL(0xebf7e9ddbe7effff),
    ULL(0xfff7fdfffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfbf7dbfdfeef7fb),
    ULL(0xffff7dfffffeffff),
    ULL(0xef5fbd5feff6fbfd),
    ULL(0xffffbdfffffeffff),
    ULL(0x77afddaf77fafdfe),
    ULL(0xffffddfffffeffff),
    ULL(0xbbd7edd7bb7cfeff),
    ULL(0xffffedfffffeffff),
    ULL(0xddebf5ebddbe7fff),
    ULL(0xfffff5fffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xefdfbd7fbfdeeff7),
    ULL(0xfffffd7ffffeffff),
    ULL(0xf7ef5dbf5feef7fb),
    ULL(0xfffffdbffffeffff),
    ULL(0xfb77addfaf76fbfd),
    ULL(0xfffffddffffeffff),
    ULL(0x7dbbd5efd7ba7dfe),
    ULL(0xfffffdeffffeffff),
    ULL(0xbedde9f7ebdcbe7f),
    ULL(0xfffffdf7fffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7efddbf7fbedfef),
    ULL(0xfffffdff7ffeffff),
    ULL(0xfbf7ed5fbf5eeff7),
    ULL(0xfffffdffbffeffff),
    ULL(0xfdfb75afdfae77fb),
    ULL(0xfffffdffdffeffff),
    ULL(0xfe7db9d7efd6bb7d),
    ULL(0xfffffdffeffeffff),
    ULL(0x7fbfddebf7eaddbe),
    ULL(0xfffffdfff7fafffd),
    ULL(0xbfdfecf5fbf4eedf),
    ULL(0xea74b85dab50ae5d),
    ULL(0xdfeff5fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7f9fdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7eddfbf7ebfdf),
    ULL(0xfffffdffff7effff),
    ULL(0xfdfbf5ef5fbe5fef),
    ULL(0xfffffdffffbeffff),
    ULL(0xfefdf977afdeaf77),
    ULL(0xfffffdffffdeffff),
    ULL(0xffff7dbbd7eed7bb),
    ULL(0xfffffdffffeeffff),
    ULL(0xff7fbcddebf6ebdd),
    ULL(0xeaf5f87dbf52ab5d),
    ULL(0x7fbfddeef5faf5ec),
    ULL(0xea74b85daf50aa5d),
    ULL(0xaa54a855aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffdfffffeffff),
    ULL(0xfffffdfffffeffff),
    ULL(0xfdfbf5efdfbe7fbf),
    ULL(0xfffffdfffffe7fff),
    ULL(0xfefdf9f7ef5ebf5f),
    ULL(0xfffffdfffffebfff),
    ULL(0xfffffdfb77aedfaf),
    ULL(0xfffffdfffffedfff),
    ULL(0xfffffc7dbbd6efd7),
    ULL(0xfffffdfffffeefff),
    ULL(0xffff7dbeddeaf7eb),
    ULL(0xeaf5f87dbe5aa351),
    ULL(0xea75b85dae54ab55),
    ULL(0xaa54a855aa50ab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa54a855aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdf9f7efdebf7f),
    ULL(0xfffffdfffffeff7f),
    ULL(0xfffffdfbf7ee5fbf),
    ULL(0xfffffdfffffeffbf),
    ULL(0xfffffcfdfb76afdf),
    ULL(0xfffffdfffffeffdf),
    ULL(0xfffffdfe7dbad7ef),
    ULL(0xfffffdfffffeffef),
    ULL(0xfffffd7fbedcebf7),
    ULL(0xeaf5f87dbe5eab53),
    ULL(0xffff7dbfdeeef5f3),
    ULL(0xaad5e875ba5cab51),
    ULL(0xaa55a855aa54aa55),
    ULL(0xaa54a855aa54aa50),
    ULL(0x2a158845a250a854),
    ULL(0xaa54a855aa54aa54),
    ULL(0x7fbfdeeff7fafdfe),
    ULL(0x7ffffefffffeffff),
    ULL(0xbf5feef7fbfcfeff),
    ULL(0xbffffefffffeffff),
    ULL(0xdfaf76fbfdfeffff),
    ULL(0xdffffefffffeffff),
    ULL(0xefd7ba7dfefeffff),
    ULL(0xeffffefffffeffff),
    ULL(0xf7ebdcbe7ffeffff),
    ULL(0xf7fffefffffeffff),
    ULL(0xfbf5eedfbf7effff),
    ULL(0xfbfffefffffeffff),
    ULL(0xfdfaf6efdfbe7fff),
    ULL(0xfdfffefffffeffff),
    ULL(0xfefdfaf7efdebf7f),
    ULL(0xfefaf6efdfbe7fff),
    ULL(0xbf7fbedfeff6fbfd),
    ULL(0xff7ffefffffeffff),
    ULL(0x5fbf5eeff7fafdfe),
    ULL(0xffbffefffffeffff),
    ULL(0xafdfae77fbfcfeff),
    ULL(0xffdffefffffeffff),
    ULL(0xd7efd6bb7dfeffff),
    ULL(0xffeffefffffeffff),
    ULL(0xebf7eaddbe7effff),
    ULL(0xfff7fefffffeffff),
    ULL(0xf5fbf4eedfbe7fff),
    ULL(0xfffbfefffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfbf7ebfdfeef7fb),
    ULL(0xffff7efffffeffff),
    ULL(0xef5fbe5feff6fbfd),
    ULL(0xffffbefffffeffff),
    ULL(0x77afdeaf77fafdfe),
    ULL(0xffffdefffffeffff),
    ULL(0xbbd7eed7bb7cfeff),
    ULL(0xffffeefffffeffff),
    ULL(0xddebf6ebddbe7fff),
    ULL(0xfffff6fffffeffff),
    ULL(0xeef5faf5eedebf7f),
    ULL(0xfffffafffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xefdfbe7fbfdeeff7),
    ULL(0xfffffe7ffffeffff),
    ULL(0xf7ef5ebf5feef7fb),
    ULL(0xfffffebffffeffff),
    ULL(0xfb77aedfaf76fbfd),
    ULL(0xfffffedffffeffff),
    ULL(0x7dbbd6efd7ba7dfe),
    ULL(0xfffffeeffffeffff),
    ULL(0xbeddeaf7ebdcbe7f),
    ULL(0xfffffef7fffeffff),
    ULL(0xdfeef4fbf5eedfbf),
    ULL(0xfffffefbfffefeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7efdebf7fbedfef),
    ULL(0xfffffeff7ffeffff),
    ULL(0xfbf7ee5fbf5eeff7),
    ULL(0xfffffeffbffeffff),
    ULL(0xfdfb76afdfae77fb),
    ULL(0xfffffeffdffeffff),
    ULL(0xfe7dbad7efd6bb7d),
    ULL(0xfffffeffeffeffff),
    ULL(0x7fbedcebf7eaddbe),
    ULL(0xfffffefff7fafffd),
    ULL(0xbfdfeef5fbf4eedf),
    ULL(0xea75ba5dab50ae5d),
    ULL(0xdfeff6fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fafdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7eedfbf7ebfdf),
    ULL(0xfffffeffff7effff),
    ULL(0xfdfbf6ef5fbe5fef),
    ULL(0xfffffeffffbeffff),
    ULL(0xfefdfa77afdeaf77),
    ULL(0xfffffeffffdeffff),
    ULL(0xfffe7cbbd7eed7bb),
    ULL(0xfffffeffffeeffff),
    ULL(0xff7fbeddebf6ebdd),
    ULL(0xeaf5fa7dbf52ab5d),
    ULL(0x7fbfdeeef5faf5ec),
    ULL(0xea75ba5daf50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffefffffeffff),
    ULL(0xfffffefffffeffff),
    ULL(0xfdfbf6efdfbe7fbf),
    ULL(0xfffffefffffe7fff),
    ULL(0xfefdfaf7ef5ebf5f),
    ULL(0xfffffefffffebfff),
    ULL(0xfffefcfb77aedfaf),
    ULL(0xfffffefffffedfff),
    ULL(0xfffffe7dbbd6efd7),
    ULL(0xfffffefffffeefff),
    ULL(0xffff7ebeddeaf7eb),
    ULL(0xeaf5fa7dbe5aa351),
    ULL(0xea75ba5dae54ab55),
    ULL(0xaa55aa55aa50ab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfaf7efdebf7f),
    ULL(0xfffffefffffeff7f),
    ULL(0xfffefcfbf7ee5fbf),
    ULL(0xfffffefffffeffbf),
    ULL(0xfffffefdfb76afdf),
    ULL(0xfffffefffffeffdf),
    ULL(0xfffffefe7dbad7ef),
    ULL(0xfffffefffffeffef),
    ULL(0xfffffe7fbedcebf7),
    ULL(0xeaf5fa7dbe5eab53),
    ULL(0xffff7ebfdeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdf6ff7fafdfe),
    ULL(0x7fffff7ffffeffff),
    ULL(0xbf5fef77fbfcfeff),
    ULL(0xbfffff7ffffeffff),
    ULL(0xdfaf777bfdfeffff),
    ULL(0xdfffff7ffffeffff),
    ULL(0xefd7bb7dfefeffff),
    ULL(0xefffff7ffffeffff),
    ULL(0xf7ebdd3e7ffeffff),
    ULL(0xf7ffff7ffffeffff),
    ULL(0xfbf5ee5fbf7effff),
    ULL(0xfbffff7ffffeffff),
    ULL(0xfdfaf76fdfbe7fff),
    ULL(0xfdffff7ffffeffff),
    ULL(0xfefdfb77efdebf7f),
    ULL(0xfeffff7ffffeffff),
    ULL(0xbf7fbf5feff6fbfd),
    ULL(0xff7fff7ffffeffff),
    ULL(0x5fbf5f6ff7fafdfe),
    ULL(0xffbfff7ffffeffff),
    ULL(0xafdfaf77fbfcfeff),
    ULL(0xffdfff7ffffeffff),
    ULL(0xd7efd73b7dfeffff),
    ULL(0xffefff7ffffeffff),
    ULL(0xebf7eb5dbe7effff),
    ULL(0xfff7ff7ffffeffff),
    ULL(0xf5fbf56edfbe7fff),
    ULL(0xfffbff7ffffeffff),
    ULL(0xfafdfa77efdebf7f),
    ULL(0xfffdff7ffffeffff),
    ULL(0xfdfefd7bf7eedfbf),
    ULL(0xfffeff7ffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x77afdf2f77fafdfe),
    ULL(0xffffdf7ffffeffff),
    ULL(0xbbd7ef57bb7cfeff),
    ULL(0xffffef7ffffeffff),
    ULL(0xddebf76bddbe7fff),
    ULL(0xfffff77ffffeffff),
    ULL(0xeef5fb75eedebf7f),
    ULL(0xfffffb7ffffeffff),
    ULL(0xf7fafd7af7eedfbf),
    ULL(0xfffffd7ffffeffff),
    ULL(0xfbfdfe7dfbf6efdf),
    ULL(0xfffffe7ffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfb77af5faf76fbfd),
    ULL(0xffffff5ffffeffff),
    ULL(0x7dbbd76fd7ba7dfe),
    ULL(0xffffff6ffffeffff),
    ULL(0xbeddeb77ebdcbe7f),
    ULL(0xffffff77fffeffff),
    ULL(0xdfeef57bf5eedfbf),
    ULL(0xffffff7bfffefeff),
    ULL(0xeff7fa7dfaf6efdf),
    ULL(0xffffff7dfffefeff),
    ULL(0xf7fbfd7efdfaf7ef),
    ULL(0xffffff7efffefeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfdfb772fdfae77fb),
    ULL(0xffffff7fdffeffff),
    ULL(0xfe7dbb57efd6bb7d),
    ULL(0xffffff7feffeffff),
    ULL(0x7fbedd6bf7eaddbe),
    ULL(0xba5dae57e372be5d),
    ULL(0xbfdfee75fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff77afdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fb7dfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7ef5fbf7ebfdf),
    ULL(0xffffff7fff7effff),
    ULL(0xfdfbf76f5fbe5fef),
    ULL(0xffffff7fffbeffff),
    ULL(0xfefdfb77afdeaf77),
    ULL(0xffffff7fffdeffff),
    ULL(0xfffe7d3bd7eed7bb),
    ULL(0xffffff7fffeefeff),
    ULL(0xff7fbe5debf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8e46e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffff7ffffeffff),
    ULL(0xffffff7ffffeffff),
    ULL(0xfdfbf76fdfbe7fbf),
    ULL(0xffffff7ffffe7fff),
    ULL(0xfefdfb77ef5ebf5f),
    ULL(0xffffff7ffffebfff),
    ULL(0xfffefd7b77aedfaf),
    ULL(0xffffff7ffffedfff),
    ULL(0xfffffe7dbbd6efd7),
    ULL(0xffffff7ffffeeeff),
    ULL(0xffff7f3eddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfb77efdebf7f),
    ULL(0xffffff7ffffeff7f),
    ULL(0xfffefd7bf7ee5fbf),
    ULL(0xffffff7ffffeffbf),
    ULL(0xfffffe7dfb76afdf),
    ULL(0xffffff7ffffeffdf),
    ULL(0xffffff7e7dbad7ef),
    ULL(0xffffff7ffffefeef),
    ULL(0xffffff7fbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7f3fdeecf4f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfaff7fafdfe),
    ULL(0x7fffffbffffeffff),
    ULL(0xbf5fefb7fbfcfeff),
    ULL(0xbfffffbffffeffff),
    ULL(0xdfaf77bbfdfeffff),
    ULL(0xdfffffbffffeffff),
    ULL(0xefd7bb3dfefeffff),
    ULL(0xefffffbffffeffff),
    ULL(0xf7ebddbefffeffff),
    ULL(0xf7ffffbffffeffff),
    ULL(0xfbf5ee9fbf7effff),
    ULL(0xfbffffbffffeffff),
    ULL(0xfdfaf7afdfbe7fff),
    ULL(0xfdffffbffffeffff),
    ULL(0xfefdfbb7efdebf7f),
    ULL(0xfeffffbffffeffff),
    ULL(0xbf7fbf9feff6fbfd),
    ULL(0xff7fffbffffeffff),
    ULL(0x5fbf5faff7fafdfe),
    ULL(0xffbfffbffffeffff),
    ULL(0xafdfaf37fbfcfeff),
    ULL(0xffdfffbffffeffff),
    ULL(0xd7efd7bbfdfeffff),
    ULL(0xffefffbffffeffff),
    ULL(0xebf7eb9dbe7effff),
    ULL(0xfff7ffbffffeffff),
    ULL(0xf5fbf5aedfbe7fff),
    ULL(0xfffbffbffffeffff),
    ULL(0xfafdfab7efdebf7f),
    ULL(0xfffdffbffffeffff),
    ULL(0xfdfefdbbf7eedfbf),
    ULL(0xfffeffbffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbbd7ef97bb7cfeff),
    ULL(0xffffefbffffeffff),
    ULL(0xddebf7abddbe7fff),
    ULL(0xfffff7bffffeffff),
    ULL(0xeef5fbb5eedebf7f),
    ULL(0xfffffbbffffeffff),
    ULL(0xf7fafdbaf7eedfbf),
    ULL(0xfffffdbffffeffff),
    ULL(0xfbfdfebdfbf6efdf),
    ULL(0xfffffebffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7dbbd7afd7ba7dfe),
    ULL(0xffffffaffffeffff),
    ULL(0xbeddebb7ebdcbe7f),
    ULL(0xffffffb7fffeffff),
    ULL(0xdfeef5bbf5eedfbf),
    ULL(0xffffffbbfffefeff),
    ULL(0xeff7fabdfaf6efdf),
    ULL(0xffffffbdfffefeff),
    ULL(0xf7fbfdbefdfaf7ef),
    ULL(0xffffffbefffefeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfe7dbb97efd6bb7d),
    ULL(0xffffffbfeffeffff),
    ULL(0x7fbeddabf7eaddbe),
    ULL(0xba5dae97e372be5d),
    ULL(0xbfdfeeb5fbf4eedf),
    ULL(0xaa55aa152b50ae5d),
    ULL(0xdfeff7bafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbbdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7ef9fbf7ebfdf),
    ULL(0xffffffbfff7effff),
    ULL(0xfdfbf7af5fbe5fef),
    ULL(0xffffffbfffbeffff),
    ULL(0xfefdfb37afdeaf77),
    ULL(0xffffffbfffdeffff),
    ULL(0xfffefdbbd7eed7bb),
    ULL(0xffffffbfffeefeff),
    ULL(0xff7fbe9debf6ebdd),
    ULL(0xaa55aa15ab52aa5d),
    ULL(0x3a1d8e86e172b44c),
    ULL(0xaa55aa152b50aa5d),
    ULL(0xaa55aa152a54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffbffffeffff),
    ULL(0xffffffbffffeffff),
    ULL(0xfdfbf7afdfbe7fbf),
    ULL(0xffffffbffffe7fff),
    ULL(0xfefdfbb7ef5ebf5f),
    ULL(0xffffffbffffebfff),
    ULL(0xfffefdbb77aedfaf),
    ULL(0xffffffbffffedfff),
    ULL(0xfffffe3dbbd6efd7),
    ULL(0xffffffbffffeeeff),
    ULL(0xffffffbeddeaf6eb),
    ULL(0xaa55aa15aa50a251),
    ULL(0xaa55aa15aa54aa55),
    ULL(0xaa55aa152a50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa152a54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbb7efdebf7f),
    ULL(0xffffffbffffeff7f),
    ULL(0xfffefdbbf7ee5fbf),
    ULL(0xffffffbffffeffbf),
    ULL(0xfffffebdfb76afdf),
    ULL(0xffffffbffffeffdf),
    ULL(0xffffffbe7dbad7ef),
    ULL(0xffffffbffffefeef),
    ULL(0xffffff3fbedcebf7),
    ULL(0xaad5ea35ba5caa53),
    ULL(0xffffffbfdeecf4f3),
    ULL(0xaad5ea35ba5caa51),
    ULL(0xaa55aa15aa54aa55),
    ULL(0xaa55aa152a54aa50),
    ULL(0x2a158a05a250a854),
    ULL(0xaa55aa152a54aa54),
    ULL(0x7fbfdfcff7fafdfe),
    ULL(0x7fffffdffffeffff),
    ULL(0xbf5fefd7fbfcfeff),
    ULL(0xbfffffdffffeffff),
    ULL(0xdfaf77dbfdfeffff),
    ULL(0xdfffffdffffeffff),
    ULL(0xefd7bb5dfefeffff),
    ULL(0xefffffdffffeffff),
    ULL(0xf7ebdd9e7ffeffff),
    ULL(0xf7ffffdffffeffff),
    ULL(0xfbf5eedffffeffff),
    ULL(0xfbffffdffffeffff),
    ULL(0xfdfaf7cfdfbe7fff),
    ULL(0xfdffffdffffeffff),
    ULL(0xfefdfbd7efdebf7f),
    ULL(0xfeffffdffffeffff),
    ULL(0xbf7fbfdffffeffff),
    ULL(0xff7fffdffffeffff),
    ULL(0x5fbf5fcff7fafdfe),
    ULL(0xffbfffdffffeffff),
    ULL(0xafdfaf57fbfcfeff),
    ULL(0xffdfffdffffeffff),
    ULL(0xd7efd79b7dfeffff),
    ULL(0xffefffdffffeffff),
    ULL(0xebf7ebddfefeffff),
    ULL(0xfff7ffdffffeffff),
    ULL(0xf5fbf5cedfbe7fff),
    ULL(0xfffbffdffffeffff),
    ULL(0xfafdfad7efdebf7f),
    ULL(0xfffdffdffffeffff),
    ULL(0xfdfefddbf7eedfbf),
    ULL(0xfffeffdffffeffff),
    ULL(0xdfbf7f9fdfeef7fb),
    ULL(0xffff7fdffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xddebf7cbddbe7fff),
    ULL(0xfffff7dffffeffff),
    ULL(0xeef5fbd5eedebf7f),
    ULL(0xfffffbdffffeffff),
    ULL(0xf7fafddaf7eedfbf),
    ULL(0xfffffddffffeffff),
    ULL(0xfbfdfeddfbf6efdf),
    ULL(0xfffffedffffeffff),
    ULL(0xefdfbf5fbfdeeff7),
    ULL(0xffffff1ffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbeddebd7ebdcbe7f),
    ULL(0xffffffd7fffeffff),
    ULL(0xdfeef5dbf5eedfbf),
    ULL(0xffffffdbfffefeff),
    ULL(0xeff7faddfaf6efdf),
    ULL(0xffffffddfffefeff),
    ULL(0xf7fbfddefdfaf7ef),
    ULL(0xffffffdefffefeff),
    ULL(0xf7efdf9f7fbedfef),
    ULL(0xffffffdf7ffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbeddcbf7eaddbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfeed5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7dafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbddfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xffffffdfbf7ebfdf),
    ULL(0xffffffdfff7effff),
    ULL(0xfdfbf7cf5fbe5fef),
    ULL(0xffffffdfffbeffff),
    ULL(0xfefdfb57afdeaf77),
    ULL(0xffffffdfffdeffff),
    ULL(0xfffe7d9bd7eed7bb),
    ULL(0xffffffdfffeefeff),
    ULL(0xfffffeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffdffffeffff),
    ULL(0xffffffdffffeffff),
    ULL(0xfdfbf7cfdfbe7fbf),
    ULL(0xffffffdffffe7fff),
    ULL(0xfefdfbd7ef5ebf5f),
    ULL(0xffffffdffffebfff),
    ULL(0xfffefddb77aedfaf),
    ULL(0xffffffdffffedfff),
    ULL(0xfffffe5dbbd6efd7),
    ULL(0xffffffdffffeeeff),
    ULL(0xffff7f9eddeaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbd7efdebf7f),
    ULL(0xffffffdffffeff7f),
    ULL(0xfffefddbf7ee5fbf),
    ULL(0xffffffdffffeffbf),
    ULL(0xfffffeddfb76afdf),
    ULL(0xffffffdffffeffdf),
    ULL(0xffffffde7dbad7ef),
    ULL(0xffffffdffffefeef),
    ULL(0xffffff5fbedcebf7),
    ULL(0xaa55aa55ba5caa53),
    ULL(0xabd76f1f9e6cf5f3),
    ULL(0xaa55aa55ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeffffeffff),
    ULL(0x7fffffeffffeffff),
    ULL(0xbf5fefe7fbfcfeff),
    ULL(0xbfffffeffffeffff),
    ULL(0xdfaf77ebfdfeffff),
    ULL(0xdfffffeffffeffff),
    ULL(0xefd7bb6dfefeffff),
    ULL(0xefffffeffffeffff),
    ULL(0xf7ebddae7ffeffff),
    ULL(0xf7ffffeffffeffff),
    ULL(0xfbf5eecfbf7effff),
    ULL(0xfbffffeffffeffff),
    ULL(0xfdfaf7effffeffff),
    ULL(0xfdffffeffffeffff),
    ULL(0xfefdfbe7efdebf7f),
    ULL(0xfeffffeffffeffff),
    ULL(0xbf7fbfcfeff6fbfd),
    ULL(0xff7fffeffffeffff),
    ULL(0x5fbf5feffffeffff),
    ULL(0xffbfffeffffeffff),
    ULL(0xafdfaf67fbfcfeff),
    ULL(0xffdfffeffffeffff),
    ULL(0xd7efd7ab7dfeffff),
    ULL(0xffefffeffffeffff),
    ULL(0xebf7ebcdbe7effff),
    ULL(0xfff7ffeffffeffff),
    ULL(0xf5fbf5eefffeffff),
    ULL(0xfffbffeffffeffff),
    ULL(0xfafdfae7efdebf7f),
    ULL(0xfffdffeffffeffff),
    ULL(0xfdfefdebf7eedfbf),
    ULL(0xfffeffeffffeffff),
    ULL(0xdfbf7fafdfeef7fb),
    ULL(0xffff7feffffeffff),
    ULL(0xef5fbf4feff6fbfd),
    ULL(0xffffbfeffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeef5fbe5eedebf7f),
    ULL(0xfffffbeffffeffff),
    ULL(0xf7fafdeaf7eedfbf),
    ULL(0xfffffdeffffeffff),
    ULL(0xfbfdfeedfbf6efdf),
    ULL(0xfffffeeffffeffff),
    ULL(0xefdfbf6fbfdeeff7),
    ULL(0xffffff6ffffeffff),
    ULL(0xf7ef5faf5feef7fb),
    ULL(0xffffffaffffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfeef5ebf5eedfbf),
    ULL(0xffffffebfffefeff),
    ULL(0xeff7faedfaf6efdf),
    ULL(0xffffffedfffefeff),
    ULL(0xf7fbfdeefdfaf7ef),
    ULL(0xffffffeefffefeff),
    ULL(0xf7efdfaf7fbedfef),
    ULL(0xffffffef7ffeffff),
    ULL(0xfbf7ef4fbf5eeff7),
    ULL(0xffffffefbffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbfdfeee5fbf4eedf),
    ULL(0x6a75ba4dab102e5d),
    ULL(0xdfeff7eafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbedfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efcfbf7ebfdf),
    ULL(0xffffffefff7effff),
    ULL(0xffffffef5fbe5fef),
    ULL(0xffffffefffbeffff),
    ULL(0xfefdfb67afdeaf77),
    ULL(0xffffffefffdeffff),
    ULL(0xfffe7dabd7eed7bb),
    ULL(0xffffffefffeeffff),
    ULL(0xff7fbecdebf6ebdd),
    ULL(0xaa55aa45ab52aa5d),
    ULL(0xfa7dbecee572b44c),
    ULL(0x2a55aa45ab102a5d),
    ULL(0x2a55aa45aa142a55),
    ULL(0x2010080402000204),
    ULL(0xffffffeffffeffff),
    ULL(0xffffffeffffeffff),
    ULL(0xffffffefdfbe7fbf),
    ULL(0xffffffeffffe7fff),
    ULL(0xfefdfbe7ef5ebf5f),
    ULL(0xffffffeffffebfff),
    ULL(0xfffefdeb77aedfaf),
    ULL(0xffffffeffffedfff),
    ULL(0xfffffe6dbbd6efd7),
    ULL(0xffffffeffffeefff),
    ULL(0xffff7faeddeaf7eb),
    ULL(0xaa55aa45aa52a251),
    ULL(0xaa55aa45aa54ab55),
    ULL(0x2a55aa45aa102a51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0x2a55aa45aa142a55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbe7efdebf7f),
    ULL(0xffffffeffffeff7f),
    ULL(0xfffefdebf7ee5fbf),
    ULL(0xffffffeffffeffbf),
    ULL(0xfffffeedfb76afdf),
    ULL(0xffffffeffffeffdf),
    ULL(0xffffffee7dbad7ef),
    ULL(0xffffffeffffeffef),
    ULL(0xffffff6fbedcebf7),
    ULL(0xaad5ea65ba5eab53),
    ULL(0xffff7fafdeeef5f3),
    ULL(0xaad5ea65ba5cab51),
    ULL(0xaa55aa45aa54aa55),
    ULL(0x2a55aa45aa142a50),
    ULL(0xaa55aa45a250a854),
    ULL(0x2a55aa45aa142a54),
    ULL(0x7fbfdfe7f7fafdfe),
    ULL(0x7ffffff7fffeffff),
    ULL(0xbf5feff7fffeffff),
    ULL(0xbffffff7fffeffff),
    ULL(0xdfaf77f3fdfeffff),
    ULL(0xdffffff7fffeffff),
    ULL(0xefd7bb75fefeffff),
    ULL(0xeffffff7fffeffff),
    ULL(0xf7ebddb67ffeffff),
    ULL(0xf7fffff7fffeffff),
    ULL(0xfbf5eed7bf7effff),
    ULL(0xfbfffff7fffeffff),
    ULL(0xfdfaf7e7dfbe7fff),
    ULL(0xfdfffff7fffeffff),
    ULL(0xfefdfbf7fffeffff),
    ULL(0xfefffff7fffeffff),
    ULL(0xbf7fbfd7eff6fbfd),
    ULL(0xff7ffff7fffeffff),
    ULL(0x5fbf5fe7f7fafdfe),
    ULL(0xffbffff7fffeffff),
    ULL(0xafdfaf77fffeffff),
    ULL(0xffdffff7fffeffff),
    ULL(0xd7efd7b37dfeffff),
    ULL(0xffeffff7fffeffff),
    ULL(0xebf7ebd5be7effff),
    ULL(0xfff7fff7fffeffff),
    ULL(0xf5fbf5e6dfbe7fff),
    ULL(0xfffbfff7fffeffff),
    ULL(0xfafdfaf7fffeffff),
    ULL(0xfffdfff7fffeffff),
    ULL(0xfdfefdf3f7eedfbf),
    ULL(0xfffefff7fffeffff),
    ULL(0xdfbf7fb7dfeef7fb),
    ULL(0xffff7ff7fffeffff),
    ULL(0xef5fbf57eff6fbfd),
    ULL(0xffffbff7fffeffff),
    ULL(0x77afdfa777fafdfe),
    ULL(0xffffdff7fffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7fafdf2f7eedfbf),
    ULL(0xfffffdf7fffeffff),
    ULL(0xfbfdfef5fbf6efdf),
    ULL(0xfffffef7fffeffff),
    ULL(0xefdfbf77bfdeeff7),
    ULL(0xffffff77fffeffff),
    ULL(0xf7ef5fb75feef7fb),
    ULL(0xffffffb7fffeffff),
    ULL(0xfb77afd7af76fbfd),
    ULL(0xffffffd7fffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeff7faf5faf6efdf),
    ULL(0xfffffff5fffefeff),
    ULL(0xf7fbfdf6fdfaf7ef),
    ULL(0xfffffff6fffefeff),
    ULL(0xf7efdfb77fbedfef),
    ULL(0xfffffff77ffeffff),
    ULL(0xfbf7ef57bf5eeff7),
    ULL(0xfffffff7bffeffff),
    ULL(0xfdfb77a7dfae77fb),
    ULL(0xfffffff7dffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfeff7f2fdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbf5fefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efd7bf7ebfdf),
    ULL(0xfffffff7ff7effff),
    ULL(0xfdfbf7e75fbe5fef),
    ULL(0xfffffff7ffbeffff),
    ULL(0xffffff77afdeaf77),
    ULL(0xfffffff7ffdeffff),
    ULL(0xfffe7db3d7eed7bb),
    ULL(0xfffffff7ffeeffff),
    ULL(0xff7fbed5ebf6ebdd),
    ULL(0xaa55aa55af52ab5d),
    ULL(0x7a3d9fc6e57ab56c),
    ULL(0xaa55aa55af50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffff7fffeffff),
    ULL(0xfffffff7fffeffff),
    ULL(0xfdfbf7e7dfbe7fbf),
    ULL(0xfffffff7fffe7fff),
    ULL(0xfffffff7ef5ebf5f),
    ULL(0xfffffff7fffebfff),
    ULL(0xfffefdf377aedfaf),
    ULL(0xfffffff7fffedfff),
    ULL(0xfffffe75bbd6efd7),
    ULL(0xfffffff7fffeefff),
    ULL(0xffff7fb6ddeaf7eb),
    ULL(0xaa55aa55ae5aa351),
    ULL(0xaa55aa55ae54ab55),
    ULL(0xaa55aa55aa50ab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffff7efdebf7f),
    ULL(0xfffffff7fffeff7f),
    ULL(0xfffefdf3f7ee5fbf),
    ULL(0xfffffff7fffeffbf),
    ULL(0xfffffef5fb76afdf),
    ULL(0xfffffff7fffeffdf),
    ULL(0xfffffff67dbad7ef),
    ULL(0xfffffff7fffeffef),
    ULL(0xffffff77bedcebf7),
    ULL(0xaad5ea75be5eab53),
    ULL(0xfefd7bb7deeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfebf7fafdfe),
    ULL(0x7ffffffbfffeffff),
    ULL(0xbf5feff3fbfcfeff),
    ULL(0xbffffffbfffeffff),
    ULL(0xdfaf77fbfffeffff),
    ULL(0xdffffffbfffeffff),
    ULL(0xefd7bb79fefeffff),
    ULL(0xeffffffbfffeffff),
    ULL(0xf7ebddba7ffeffff),
    ULL(0xf7fffffbfffeffff),
    ULL(0xfbf5eedbbf7effff),
    ULL(0xfbfffffbfffeffff),
    ULL(0xfdfaf7ebdfbe7fff),
    ULL(0xfdfffffbfffeffff),
    ULL(0xfefdfbf3efdebf7f),
    ULL(0xfefffffbfffeffff),
    ULL(0xbf7fbfdbeff6fbfd),
    ULL(0xff7ffffbfffeffff),
    ULL(0x5fbf5febf7fafdfe),
    ULL(0xffbffffbfffeffff),
    ULL(0xafdfaf73fbfcfeff),
    ULL(0xffdffffbfffeffff),
    ULL(0xd7efd7bb7ffeffff),
    ULL(0xffeffffbfffeffff),
    ULL(0xebf7ebd9be7effff),
    ULL(0xfff7fffbfffeffff),
    ULL(0xf5fbf5eadfbe7fff),
    ULL(0xfffbfffbfffeffff),
    ULL(0xfafdfaf3efdebf7f),
    ULL(0xfffdfffbfffeffff),
    ULL(0xfdfefdfbfffeffff),
    ULL(0xfffefffbfffeffff),
    ULL(0xdfbf7fbbdfeef7fb),
    ULL(0xffff7ffbfffeffff),
    ULL(0xef5fbf5beff6fbfd),
    ULL(0xffffbffbfffeffff),
    ULL(0x77afdfab77fafdfe),
    ULL(0xffffdffbfffeffff),
    ULL(0xbbd7efd3bb7cfeff),
    ULL(0xffffeffbfffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbfdfef9fbf6efdf),
    ULL(0xfffffefbfffeffff),
    ULL(0xefdfbf7bbfdeeff7),
    ULL(0xffffff7bfffeffff),
    ULL(0xf7ef5fbb5feef7fb),
    ULL(0xffffffbbfffeffff),
    ULL(0xfb77afdbaf76fbfd),
    ULL(0xffffffdbfffeffff),
    ULL(0x7dbbd7ebd7ba7dfe),
    ULL(0xffffffebfffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7fbfdfafdfaf7ef),
    ULL(0xfffffff8fffefeff),
    ULL(0xf7efdfbb7fbedfef),
    ULL(0xfffffffb7ffeffff),
    ULL(0xfbf7ef5bbf5eeff7),
    ULL(0xfffffffbbffeffff),
    ULL(0xfdfb77abdfae77fb),
    ULL(0xfffffffbdffeffff),
    ULL(0xfe7dbbd3efd6bb7d),
    ULL(0xfffffffbeffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeff7fbf9fefcfaf7),
    ULL(0x0000000002000204),
    ULL(0xfbf7efdbbf7ebfdf),
    ULL(0xfffffffbff7effff),
    ULL(0xfdfbf7eb5fbe5fef),
    ULL(0xfffffffbffbeffff),
    ULL(0xfefdfb73afdeaf77),
    ULL(0xfffffffbffdeffff),
    ULL(0xffff7fbbd7eed7bb),
    ULL(0xfffffffbffeeffff),
    ULL(0xff7fbed9ebf6ebdd),
    ULL(0xeaf5fa79bf52ab5f),
    ULL(0x7fbfdfeaf5faf5ee),
    ULL(0xe070b8592f100b1d),
    ULL(0xa050a8512a140a15),
    ULL(0x0000000002000204),
    ULL(0xfffffffbfffeffff),
    ULL(0xfffffffbfffeffff),
    ULL(0xfdfbf7ebdfbe7fbf),
    ULL(0xfffffffbfffe7fff),
    ULL(0xfefdfbf3ef5ebf5f),
    ULL(0xfffffffbfffebfff),
    ULL(0xfffffffb77aedfaf),
    ULL(0xfffffffbfffedfff),
    ULL(0xfffffe79bbd6efd7),
    ULL(0xfffffffbfffeefff),
    ULL(0xffff7fbaddeaf7eb),
    ULL(0xeaf5fa79be5aa353),
    ULL(0xea75ba59ae54ab55),
    ULL(0xa050a8512a100b11),
    ULL(0x0000000000000000),
    ULL(0x0000000002000000),
    ULL(0xaa55aa51aa54aa55),
    ULL(0x0000000002000204),
    ULL(0xfefdfbf3efdebf7f),
    ULL(0xfffffffbfffeff7f),
    ULL(0xfffffffbf7ee5fbf),
    ULL(0xfffffffbfffeffbf),
    ULL(0xfffffef9fb76afdf),
    ULL(0xfffffffbfffeffdf),
    ULL(0xfffffffa7dbad7ef),
    ULL(0xfffffffbfffeffef),
    ULL(0xffffff7bbedcebf7),
    ULL(0xeaf5fa79be5eab53),
    ULL(0xffff7fbbdeeef5f3),
    ULL(0xaad5ea71ba5cab51),
    ULL(0xaa55aa51aa54aa55),
    ULL(0xaa55aa51aa54aa50),
    ULL(0x2a158a41a250a854),
    ULL(0xaa55aa51aa54aa54),
    ULL(0x7fbfdfedf7fafdfe),
    ULL(0x7ffffffdfffeffff),
    ULL(0xbf5feff5fbfcfeff),
    ULL(0xbffffffdfffeffff),
    ULL(0xdfaf77f9fdfeffff),
    ULL(0xdffffffdfffeffff),
    ULL(0xefd7bb7dfffeffff),
    ULL(0xeffffffdfffeffff),
    ULL(0xf7ebddbc7ffeffff),
    ULL(0xf7fffffdfffeffff),
    ULL(0xfbf5eeddbf7effff),
    ULL(0xfbfffffdfffeffff),
    ULL(0xfdfaf7eddfbe7fff),
    ULL(0xfdfffffdfffeffff),
    ULL(0xfefdfbf5efdebf7f),
    ULL(0xfefffffdfffeffff),
    ULL(0xbf7fbfddeff6fbfd),
    ULL(0xff7ffffdfffeffff),
    ULL(0x5fbf5fedf7fafdfe),
    ULL(0xffbffffdfffeffff),
    ULL(0xafdfaf75fbfcfeff),
    ULL(0xffdffffdfffeffff),
    ULL(0xd7efd7b97dfeffff),
    ULL(0xffeffffdfffeffff),
    ULL(0xebf7ebddbf7effff),
    ULL(0xfff7fffdfffeffff),
    ULL(0xf5fbf5ecdfbe7fff),
    ULL(0xfffbfffdfffeffff),
    ULL(0xfafdfaf5efdebf7f),
    ULL(0xfffdfffdfffeffff),
    ULL(0xfdfefdf9f7eedfbf),
    ULL(0xfffefffdfffeffff),
    ULL(0xdfbf7fbddfeef7fb),
    ULL(0xffff7ffdfffeffff),
    ULL(0xef5fbf5deff6fbfd),
    ULL(0xffffbffdfffeffff),
    ULL(0x77afdfad77fafdfe),
    ULL(0xffffdffdfffeffff),
    ULL(0xbbd7efd5bb7cfeff),
    ULL(0xffffeffdfffeffff),
    ULL(0xddebf7e9ddbe7fff),
    ULL(0xfffff7fdfffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xefdfbf7dbfdeeff7),
    ULL(0xffffff7dfffeffff),
    ULL(0xf7ef5fbd5feef7fb),
    ULL(0xffffffbdfffeffff),
    ULL(0xfb77afddaf76fbfd),
    ULL(0xffffffddfffeffff),
    ULL(0x7dbbd7edd7ba7dfe),
    ULL(0xffffffedfffeffff),
    ULL(0xbeddebf5ebdcbe7f),
    ULL(0xfffffff5fffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7efdfbd7fbedfef),
    ULL(0xfffffffd7ffeffff),
    ULL(0xfbf7ef5dbf5eeff7),
    ULL(0xfffffffdbffeffff),
    ULL(0xfdfb77addfae77fb),
    ULL(0xfffffffddffeffff),
    ULL(0xfe7dbbd5efd6bb7d),
    ULL(0xfffffffdeffeffff),
    ULL(0x7fbedde9f7eaddbe),
    ULL(0xfffffffdf7faffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbf7efddbf7ebfdf),
    ULL(0xfffffffdff7effff),
    ULL(0xfdfbf7ed5fbe5fef),
    ULL(0xfffffffdffbeffff),
    ULL(0xfefdfb75afdeaf77),
    ULL(0xfffffffdffdeffff),
    ULL(0xfffe7db9d7eed7bb),
    ULL(0xfffffffdffeeffff),
    ULL(0xff7fbfddebf6ebdd),
    ULL(0xeaf5fa7dbf52ab5f),
    ULL(0x7fbfdfecf5faf5ee),
    ULL(0xea75ba5daf50ab5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffdfffeffff),
    ULL(0xfffffffdfffeffff),
    ULL(0xfdfbf7eddfbe7fbf),
    ULL(0xfffffffdfffe7fff),
    ULL(0xfefdfbf5ef5ebf5f),
    ULL(0xfffffffdfffebfff),
    ULL(0xfffefdf977aedfaf),
    ULL(0xfffffffdfffedfff),
    ULL(0xffffff7dbbd6efd7),
    ULL(0xfffffffdfffeefff),
    ULL(0xffff7fbcddeaf7eb),
    ULL(0xeaf5fa7dbe5aa353),
    ULL(0xea75ba5dae54ab55),
    ULL(0xaa55aa55aa50ab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf5efdebf7f),
    ULL(0xfffffffdfffeff7f),
    ULL(0xfffefdf9f7ee5fbf),
    ULL(0xfffffffdfffeffbf),
    ULL(0xfffffffdfb76afdf),
    ULL(0xfffffffdfffeffdf),
    ULL(0xfffffffc7dbad7ef),
    ULL(0xfffffffdfffeffef),
    ULL(0xffffff7dbedcebf7),
    ULL(0xeaf5fa7dbe5eab53),
    ULL(0xffff7ebddeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeef7fafdfe),
    ULL(0x7ffffffefffeffff),
    ULL(0xbf5feff6fbfcfeff),
    ULL(0xbffffffefffeffff),
    ULL(0xdfaf77fafdfeffff),
    ULL(0xdffffffefffeffff),
    ULL(0xefd7bb7cfefeffff),
    ULL(0xeffffffefffeffff),
    ULL(0xf7ebddbe7ffeffff),
    ULL(0xf7fffffefffeffff),
    ULL(0xfbf5eedebf7effff),
    ULL(0xfbfffffefffeffff),
    ULL(0xfdfaf7eedfbe7fff),
    ULL(0xfdfffffefffeffff),
    ULL(0xfefdfbf6efdebf7f),
    ULL(0xfefffffefffeffff),
    ULL(0xbf7fbfdeeff6fbfd),
    ULL(0xff7ffffefffeffff),
    ULL(0x5fbf5feef7fafdfe),
    ULL(0xffbffffefffeffff),
    ULL(0xafdfaf76fbfcfeff),
    ULL(0xffdffffefffeffff),
    ULL(0xd7efd7ba7dfeffff),
    ULL(0xffeffffefffeffff),
    ULL(0xebf7ebdcbe7effff),
    ULL(0xfff7fffefffeffff),
    ULL(0xf5fbf5eedfbe7fff),
    ULL(0xfffbfffefffeffff),
    ULL(0xfafdfaf6efdebf7f),
    ULL(0xfffdfffefffeffff),
    ULL(0xfdfefdfaf7eedfbf),
    ULL(0xfffefffefffeffff),
    ULL(0xdfbf7fbedfeef7fb),
    ULL(0xffff7ffefffeffff),
    ULL(0xef5fbf5eeff6fbfd),
    ULL(0xffffbffefffeffff),
    ULL(0x77afdfae77fafdfe),
    ULL(0xffffdffefffeffff),
    ULL(0xbbd7efd6bb7cfeff),
    ULL(0xffffeffefffeffff),
    ULL(0xddebf7eaddbe7fff),
    ULL(0xfffff7fefffeffff),
    ULL(0xeef5fbf4eedebf7f),
    ULL(0xfffffbfefffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xefdfbf7ebfdeeff7),
    ULL(0xffffff7efffeffff),
    ULL(0xf7ef5fbe5feef7fb),
    ULL(0xffffffbefffeffff),
    ULL(0xfb77afdeaf76fbfd),
    ULL(0xffffffdefffeffff),
    ULL(0x7dbbd7eed7ba7dfe),
    ULL(0xffffffeefffeffff),
    ULL(0xbeddebf6ebdcbe7f),
    ULL(0xfffffff6fffeffff),
    ULL(0xdfeef5faf5eedfbf),
    ULL(0xfffffffafffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7efdfbe7fbedfef),
    ULL(0xfffffffe7ffeffff),
    ULL(0xfbf7ef5ebf5eeff7),
    ULL(0xfffffffebffeffff),
    ULL(0xfdfb77aedfae77fb),
    ULL(0xfffffffedffeffff),
    ULL(0xfe7dbbd6efd6bb7d),
    ULL(0xfffffffeeffeffff),
    ULL(0x7fbeddeaf7eaddbe),
    ULL(0xfffffffef7faffff),
    ULL(0xbfdfeef4fbf4eedf),
    ULL(0xea75ba5cab50af5d),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbf7efdebf7ebfdf),
    ULL(0xfffffffeff7effff),
    ULL(0xfdfbf7ee5fbe5fef),
    ULL(0xfffffffeffbeffff),
    ULL(0xfefdfb76afdeaf77),
    ULL(0xfffffffeffdeffff),
    ULL(0xfffe7dbad7eed7bb),
    ULL(0xfffffffeffeeffff),
    ULL(0xff7fbedcebf6ebdd),
    ULL(0xeaf5fa7cbf52ab5f),
    ULL(0x7fbfdfeef5faf5ee),
    ULL(0xea75ba5caf50ab5d),
    ULL(0xaa55aa54aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffefffeffff),
    ULL(0xfffffffefffeffff),
    ULL(0xfdfbf7eedfbe7fbf),
    ULL(0xfffffffefffe7fff),
    ULL(0xfefdfbf6ef5ebf5f),
    ULL(0xfffffffefffebfff),
    ULL(0xfffefdfa77aedfaf),
    ULL(0xfffffffefffedfff),
    ULL(0xfffffe7cbbd6efd7),
    ULL(0xfffffffefffeefff),
    ULL(0xffff7fbeddeaf7eb),
    ULL(0xeaf5fa7cbe5aa353),
    ULL(0xea75ba5cae54ab55),
    ULL(0xaa55aa54aa50ab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa54aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf6efdebf7f),
    ULL(0xfffffffefffeff7f),
    ULL(0xfffefdfaf7ee5fbf),
    ULL(0xfffffffefffeffbf),
    ULL(0xfffffefcfb76afdf),
    ULL(0xfffffffefffeffdf),
    ULL(0xfffffffe7dbad7ef),
    ULL(0xfffffffefffeffef),
    ULL(0xffffff7ebedcebf7),
    ULL(0xeaf5fa7cbe5eab53),
    ULL(0xffff7fbedeeef5f3),
    ULL(0xaad5ea74ba5cab51),
    ULL(0xaa55aa54aa54aa55),
    ULL(0xaa55aa54aa54aa50),
    ULL(0x2a158a44a250a854),
    ULL(0xaa55aa54aa54aa54),
    ULL(0x7fbfdfef77fafdfe),
    ULL(0x7fffffff7ffeffff),
    ULL(0xbf5feff77bfcfeff),
    ULL(0xbfffffff7ffeffff),
    ULL(0xdfaf77fb7dfeffff),
    ULL(0xdfffffff7ffeffff),
    ULL(0xefd7bb7d7efeffff),
    ULL(0xefffffff7ffeffff),
    ULL(0xf7ebddbe7ffeffff),
    ULL(0xf7ffffff7ffeffff),
    ULL(0xfbf5eedf3f7effff),
    ULL(0xfbffffff7ffeffff),
    ULL(0xfdfaf7ef5fbe7fff),
    ULL(0xfdffffff7ffeffff),
    ULL(0xfefdfbf76fdebf7f),
    ULL(0xfeffffff7ffeffff),
    ULL(0xbf7fbfdf6ff6fbfd),
    ULL(0xff7fffff7ffeffff),
    ULL(0x5fbf5fef77fafdfe),
    ULL(0xffbfffff7ffeffff),
    ULL(0xafdfaf777bfcfeff),
    ULL(0xffdfffff7ffeffff),
    ULL(0xd7efd7bb7dfeffff),
    ULL(0xffefffff7ffeffff),
    ULL(0xebf7ebdd3e7effff),
    ULL(0xfff7ffff7ffeffff),
    ULL(0xf5fbf5ee5fbe7fff),
    ULL(0xfffbffff7ffeffff),
    ULL(0xfafdfaf76fdebf7f),
    ULL(0xfffdffff7ffeffff),
    ULL(0xfdfefdfb77eedfbf),
    ULL(0xfffeffff7ffeffff),
    ULL(0xdfbf7fbf5feef7fb),
    ULL(0xffff7fff7ffeffff),
    ULL(0xef5fbf5f6ff6fbfd),
    ULL(0xffffbfff7ffeffff),
    ULL(0x77afdfaf77fafdfe),
    ULL(0xffffdfff7ffeffff),
    ULL(0xbbd7efd73b7cfeff),
    ULL(0xffffefff7ffeffff),
    ULL(0xddebf7eb5dbe7fff),
    ULL(0xfffff7ff7ffeffff),
    ULL(0xeef5fbf56edebf7f),
    ULL(0xfffffbff7ffeffff),
    ULL(0xf7fafdfa77eedfbf),
    ULL(0xfffffdff7ffeffff),
    ULL(0xfbfdfefd7bf6efdf),
    ULL(0xfffffeff7ffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfb77afdf2f76fbfd),
    ULL(0xffffffdf7ffeffff),
    ULL(0x7dbbd7ef57ba7dfe),
    ULL(0xffffffef7ffeffff),
    ULL(0xbeddebf76bdcbe7f),
    ULL(0xfffffff77ffeffff),
    ULL(0xdfeef5fb75eedfbf),
    ULL(0xfffffffb7ffefeff),
    ULL(0xeff7fafd7af6efdf),
    ULL(0xfffffffd7ffefeff),
    ULL(0xf7fbfdfe7dfaf7ef),
    ULL(0xfffffffe7ffefeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfdfb77af5fae77fb),
    ULL(0xffffffff5ffeffff),
    ULL(0xfe7dbbd76fd6bb7d),
    ULL(0xffffffff6ffeffff),
    ULL(0x7fbeddeb77eaddbe),
    ULL(0xba5daed76372be5d),
    ULL(0xbfdfeef57bf4eedf),
    ULL(0xaa55aa552b50ae5d),
    ULL(0xdfeff7fa7dfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfd7efcfaf7),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfb772fdeaf77),
    ULL(0xffffffff7fdeffff),
    ULL(0xfffe7dbb57eed7bb),
    ULL(0xffffffff7feefeff),
    ULL(0xff7fbedd6bf6ebdd),
    ULL(0xaa55aa552b52aa5d),
    ULL(0x3a1d8ec66172b44c),
    ULL(0xaa55aa552b50aa5d),
    ULL(0xaa55aa552a54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffff7ffeffff),
    ULL(0xffffffff7ffeffff),
    ULL(0xfdfbf7ef5fbe7fbf),
    ULL(0xffffffff7ffe7fff),
    ULL(0xfefdfbf76f5ebf5f),
    ULL(0xffffffff7ffebfff),
    ULL(0xfffefdfb77aedfaf),
    ULL(0xffffffff7ffedfff),
    ULL(0xfffffe7d3bd6efd7),
    ULL(0xffffffff7ffeeeff),
    ULL(0xffff7fbe5deaf6eb),
    ULL(0xaa55aa552a50a251),
    ULL(0xaa55aa552a54aa55),
    ULL(0xaa55aa552a50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa552a54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf76fdebf7f),
    ULL(0xffffffff7ffeff7f),
    ULL(0xfffefdfb77ee5fbf),
    ULL(0xffffffff7ffeffbf),
    ULL(0xfffffefd7b76afdf),
    ULL(0xffffffff7ffeffdf),
    ULL(0xfffffffe7dbad7ef),
    ULL(0xffffffff7ffefeef),
    ULL(0xffffff7f3edcebf7),
    ULL(0xaad5ea753a5caa53),
    ULL(0xffff7fbf5eecf4f3),
    ULL(0xaad5ea753a5caa51),
    ULL(0xaa55aa552a54aa55),
    ULL(0xaa55aa552a54aa50),
    ULL(0x2a158a452250a854),
    ULL(0xaa55aa552a54aa54),
    ULL(0x7fbfdfefb7fafdfe),
    ULL(0x7fffffffbffeffff),
    ULL(0xbf5feff7bbfcfeff),
    ULL(0xbfffffffbffeffff),
    ULL(0xdfaf77fbbdfeffff),
    ULL(0xdfffffffbffeffff),
    ULL(0xefd7bb7dbefeffff),
    ULL(0xefffffffbffeffff),
    ULL(0xf7ebddbe3ffeffff),
    ULL(0xf7ffffffbffeffff),
    ULL(0xfbf5eedfbffeffff),
    ULL(0xfbffffffbffeffff),
    ULL(0xfdfaf7ef9fbe7fff),
    ULL(0xfdffffffbffeffff),
    ULL(0xfefdfbf7afdebf7f),
    ULL(0xfeffffffbffeffff),
    ULL(0xbf7fbfdfaff6fbfd),
    ULL(0xff7fffffbffeffff),
    ULL(0x5fbf5fefb7fafdfe),
    ULL(0xffbfffffbffeffff),
    ULL(0xafdfaf77bbfcfeff),
    ULL(0xffdfffffbffeffff),
    ULL(0xd7efd7bb3dfeffff),
    ULL(0xffefffffbffeffff),
    ULL(0xebf7ebddbefeffff),
    ULL(0xfff7ffffbffeffff),
    ULL(0xf5fbf5ee9fbe7fff),
    ULL(0xfffbffffbffeffff),
    ULL(0xfafdfaf7afdebf7f),
    ULL(0xfffdffffbffeffff),
    ULL(0xfdfefdfbb7eedfbf),
    ULL(0xfffeffffbffeffff),
    ULL(0xdfbf7fbf9feef7fb),
    ULL(0xffff7fffbffeffff),
    ULL(0xef5fbf5faff6fbfd),
    ULL(0xffffbfffbffeffff),
    ULL(0x77afdfaf37fafdfe),
    ULL(0xffffdfffbffeffff),
    ULL(0xbbd7efd7bbfcfeff),
    ULL(0xffffefffbffeffff),
    ULL(0xddebf7eb9dbe7fff),
    ULL(0xfffff7ffbffeffff),
    ULL(0xeef5fbf5aedebf7f),
    ULL(0xfffffbffbffeffff),
    ULL(0xf7fafdfab7eedfbf),
    ULL(0xfffffdffbffeffff),
    ULL(0xfbfdfefdbbf6efdf),
    ULL(0xfffffeffbffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7dbbd7ef97ba7dfe),
    ULL(0xffffffefbffeffff),
    ULL(0xbeddebf7abdcbe7f),
    ULL(0xfffffff7bffeffff),
    ULL(0xdfeef5fbb5eedfbf),
    ULL(0xfffffffbbffefeff),
    ULL(0xeff7fafdbaf6efdf),
    ULL(0xfffffffdbffefeff),
    ULL(0xf7fbfdfebdfaf7ef),
    ULL(0xfffffffebffefeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfe7dbbd7afd6bb7d),
    ULL(0xffffffffaffeffff),
    ULL(0x7fbeddebb7eaddbe),
    ULL(0xba5dae57a372be5d),
    ULL(0xbfdfeef5bbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7fabdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdbefcfaf7),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffe7dbb97eed7bb),
    ULL(0xffffffffbfeefeff),
    ULL(0xff7fbeddabf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8e46a172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffffbffeffff),
    ULL(0xffffffffbffeffff),
    ULL(0xfdfbf7ef9fbe7fbf),
    ULL(0xffffffffbffe7fff),
    ULL(0xfefdfbf7af5ebf5f),
    ULL(0xffffffffbffebfff),
    ULL(0xfffefdfb37aedfaf),
    ULL(0xffffffffbffedfff),
    ULL(0xfffffefdbbd6efd7),
    ULL(0xffffffffbffeeeff),
    ULL(0xffff7fbe9deaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7afdebf7f),
    ULL(0xffffffffbffeff7f),
    ULL(0xfffefdfbb7ee5fbf),
    ULL(0xffffffffbffeffbf),
    ULL(0xfffffefdbb76afdf),
    ULL(0xffffffffbffeffdf),
    ULL(0xfffffffe3dbad7ef),
    ULL(0xffffffffbffefeef),
    ULL(0xffffffffbedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7fbf9e6cf4f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfefd7fafdfe),
    ULL(0x7fffffffdffeffff),
    ULL(0xbf5feff7dbfcfeff),
    ULL(0xbfffffffdffeffff),
    ULL(0xdfaf77fbddfeffff),
    ULL(0xdfffffffdffeffff),
    ULL(0xefd7bb7ddefeffff),
    ULL(0xefffffffdffeffff),
    ULL(0xf7ebddbe5ffeffff),
    ULL(0xf7ffffffdffeffff),
    ULL(0xfbf5eedf9f7effff),
    ULL(0xfbffffffdffeffff),
    ULL(0xfdfaf7efdffeffff),
    ULL(0xfdffffffdffeffff),
    ULL(0xfefdfbf7cfdebf7f),
    ULL(0xfeffffffdffeffff),
    ULL(0xbf7fbfdfcff6fbfd),
    ULL(0xff7fffffdffeffff),
    ULL(0x5fbf5fefd7fafdfe),
    ULL(0xffbfffffdffeffff),
    ULL(0xafdfaf77dbfcfeff),
    ULL(0xffdfffffdffeffff),
    ULL(0xd7efd7bb5dfeffff),
    ULL(0xffefffffdffeffff),
    ULL(0xebf7ebdd9e7effff),
    ULL(0xfff7ffffdffeffff),
    ULL(0xf5fbf5eedffeffff),
    ULL(0xfffbffffdffeffff),
    ULL(0xfafdfaf7cfdebf7f),
    ULL(0xfffdffffdffeffff),
    ULL(0xfdfefdfbd7eedfbf),
    ULL(0xfffeffffdffeffff),
    ULL(0xdfbf7fbfdffeffff),
    ULL(0xffff7fffdffeffff),
    ULL(0xef5fbf5fcff6fbfd),
    ULL(0xffffbfffdffeffff),
    ULL(0x77afdfaf57fafdfe),
    ULL(0xffffdfffdffeffff),
    ULL(0xbbd7efd79b7cfeff),
    ULL(0xffffefffdffeffff),
    ULL(0xddebf7ebddfeffff),
    ULL(0xfffff7ffdffeffff),
    ULL(0xeef5fbf5cedebf7f),
    ULL(0xfffffbffdffeffff),
    ULL(0xf7fafdfad7eedfbf),
    ULL(0xfffffdffdffeffff),
    ULL(0xfbfdfefddbf6efdf),
    ULL(0xfffffeffdffeffff),
    ULL(0xefdfbf7f9fdeeff7),
    ULL(0xffffff7fdffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbeddebf7cbdcbe7f),
    ULL(0xfffffff7dffeffff),
    ULL(0xdfeef5fbd5eedfbf),
    ULL(0xfffffffbdffefeff),
    ULL(0xeff7fafddaf6efdf),
    ULL(0xfffffffddffefeff),
    ULL(0xf7fbfdfeddfaf7ef),
    ULL(0xfffffffedffefeff),
    ULL(0xf7efdfbf5fbedfef),
    ULL(0xffffffff1ffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbeddebd7eaddbe),
    ULL(0xba5daed7c372be5d),
    ULL(0xbfdfeef5dbf4eedf),
    ULL(0xaa55aa558b102e5d),
    ULL(0xdfeff7faddfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfddefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdf9f7ebfdf),
    ULL(0xffffffffdf7effff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xff7fbeddcbf6ebdd),
    ULL(0xaa55aa558b52aa5d),
    ULL(0x3a1d8ec6c172b44c),
    ULL(0xaa55aa558b102a5d),
    ULL(0xaa55aa558a142a55),
    ULL(0x2010080402000204),
    ULL(0xffffffffdffeffff),
    ULL(0xffffffffdffeffff),
    ULL(0xffffffffdfbe7fbf),
    ULL(0xffffffffdffe7fff),
    ULL(0xfefdfbf7cf5ebf5f),
    ULL(0xffffffffdffebfff),
    ULL(0xfffefdfb57aedfaf),
    ULL(0xffffffffdffedfff),
    ULL(0xfffffe7d9bd6efd7),
    ULL(0xffffffffdffeeeff),
    ULL(0xfffffffeddeaf6eb),
    ULL(0xaa55aa558a50a251),
    ULL(0xaa55aa558a54aa55),
    ULL(0xaa55aa558a102a51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa558a142a55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7cfdebf7f),
    ULL(0xffffffffdffeff7f),
    ULL(0xfffefdfbd7ee5fbf),
    ULL(0xffffffffdffeffbf),
    ULL(0xfffffefddb76afdf),
    ULL(0xffffffffdffeffdf),
    ULL(0xfffffffe5dbad7ef),
    ULL(0xffffffffdffefeef),
    ULL(0xffffff7f9edcebf7),
    ULL(0xaad5ea759a5caa53),
    ULL(0xffffffffdeecf5f3),
    ULL(0xaad5ea759a5caa51),
    ULL(0xaa55aa558a54aa55),
    ULL(0xaa55aa558a142a50),
    ULL(0x2a158a458250a854),
    ULL(0xaa55aa558a142a54),
    ULL(0x7fbfdfefe7fafdfe),
    ULL(0x7fffffffeffeffff),
    ULL(0xbf5feff7ebfcfeff),
    ULL(0xbfffffffeffeffff),
    ULL(0xdfaf77fbedfeffff),
    ULL(0xdfffffffeffeffff),
    ULL(0xefd7bb7deefeffff),
    ULL(0xefffffffeffeffff),
    ULL(0xf7ebddbe6ffeffff),
    ULL(0xf7ffffffeffeffff),
    ULL(0xfbf5eedfaf7effff),
    ULL(0xfbffffffeffeffff),
    ULL(0xfdfaf7efcfbe7fff),
    ULL(0xfdffffffeffeffff),
    ULL(0xfefdfbf7effeffff),
    ULL(0xfeffffffeffeffff),
    ULL(0xbf7fbfdfeffeffff),
    ULL(0xff7fffffeffeffff),
    ULL(0x5fbf5fefe7fafdfe),
    ULL(0xffbfffffeffeffff),
    ULL(0xafdfaf77ebfcfeff),
    ULL(0xffdfffffeffeffff),
    ULL(0xd7efd7bb6dfeffff),
    ULL(0xffefffffeffeffff),
    ULL(0xebf7ebddae7effff),
    ULL(0xfff7ffffeffeffff),
    ULL(0xf5fbf5eecfbe7fff),
    ULL(0xfffbffffeffeffff),
    ULL(0xfafdfaf7effeffff),
    ULL(0xfffdffffeffeffff),
    ULL(0xfdfefdfbe7eedfbf),
    ULL(0xfffeffffeffeffff),
    ULL(0xdfbf7fbfcfeef7fb),
    ULL(0xffff7fffeffeffff),
    ULL(0xef5fbf5feffeffff),
    ULL(0xffffbfffeffeffff),
    ULL(0x77afdfaf67fafdfe),
    ULL(0xffffdfffeffeffff),
    ULL(0xbbd7efd7ab7cfeff),
    ULL(0xffffefffeffeffff),
    ULL(0xddebf7ebcdbe7fff),
    ULL(0xfffff7ffeffeffff),
    ULL(0xeef5fbf5eefeffff),
    ULL(0xfffffbffeffeffff),
    ULL(0xf7fafdfae7eedfbf),
    ULL(0xfffffdffeffeffff),
    ULL(0xfbfdfefdebf6efdf),
    ULL(0xfffffeffeffeffff),
    ULL(0xefdfbf7fafdeeff7),
    ULL(0xffffff7feffeffff),
    ULL(0xf7ef5fbf4feef7fb),
    ULL(0xffffffbfeffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfeef5fbe5eedfbf),
    ULL(0xfffffffbeffefeff),
    ULL(0xeff7fafdeaf6efdf),
    ULL(0xfffffffdeffefeff),
    ULL(0xf7fbfdfeedfaf7ef),
    ULL(0xfffffffeeffefeff),
    ULL(0xf7efdfbf6fbedfef),
    ULL(0xffffffff6ffeffff),
    ULL(0xfbf7ef5faf5eeff7),
    ULL(0xffffffffaffeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbfdfeef5ebf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7faedfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdeefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfaf7ebfdf),
    ULL(0xffffffffef7effff),
    ULL(0xfdfbf7ef4fbe5fef),
    ULL(0xffffffffefbeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x3a1d8ec6e572b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffffeffeffff),
    ULL(0xffffffffeffeffff),
    ULL(0xfdfbf7efcfbe7fbf),
    ULL(0xffffffffeffe7fff),
    ULL(0xffffffffef5ebf5f),
    ULL(0xffffffffeffebfff),
    ULL(0xfffefdfb67aedfaf),
    ULL(0xffffffffeffedfff),
    ULL(0xfffffe7dabd6efd7),
    ULL(0xffffffffeffeefff),
    ULL(0xffff7fbecdeaf7eb),
    ULL(0xaa55aa55aa52a251),
    ULL(0xaa55aa55aa54ab55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffffefdebf7f),
    ULL(0xffffffffeffeff7f),
    ULL(0xfffefdfbe7ee5fbf),
    ULL(0xffffffffeffeffbf),
    ULL(0xfffffefdeb76afdf),
    ULL(0xffffffffeffeffdf),
    ULL(0xfffffffe6dbad7ef),
    ULL(0xffffffffeffeffef),
    ULL(0xffffff7faedcebf7),
    ULL(0xaa55aa55aa5eab53),
    ULL(0xeaf57b3f8e4eb573),
    ULL(0xaa55aa55aa5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7feffff),
    ULL(0x7ffffffff7feffff),
    ULL(0xbf5feff7f3fcfeff),
    ULL(0xbffffffff7feffff),
    ULL(0xdfaf77fbf5feffff),
    ULL(0xdffffffff7feffff),
    ULL(0xefd7bb7df6feffff),
    ULL(0xeffffffff7feffff),
    ULL(0xf7ebddbe77feffff),
    ULL(0xf7fffffff7feffff),
    ULL(0xfbf5eedfb77effff),
    ULL(0xfbfffffff7feffff),
    ULL(0xfdfaf7efd7be7fff),
    ULL(0xfdfffffff7feffff),
    ULL(0xfefdfbf7e7debf7f),
    ULL(0xfefffffff7feffff),
    ULL(0xbf7fbfdfe7f6fbfd),
    ULL(0xff7ffffff7feffff),
    ULL(0x5fbf5feff7feffff),
    ULL(0xffbffffff7feffff),
    ULL(0xafdfaf77f3fcfeff),
    ULL(0xffdffffff7feffff),
    ULL(0xd7efd7bb75feffff),
    ULL(0xffeffffff7feffff),
    ULL(0xebf7ebddb67effff),
    ULL(0xfff7fffff7feffff),
    ULL(0xf5fbf5eed7be7fff),
    ULL(0xfffbfffff7feffff),
    ULL(0xfafdfaf7e7debf7f),
    ULL(0xfffdfffff7feffff),
    ULL(0xfdfefdfbf7feffff),
    ULL(0xfffefffff7feffff),
    ULL(0xdfbf7fbfd7eef7fb),
    ULL(0xffff7ffff7feffff),
    ULL(0xef5fbf5fe7f6fbfd),
    ULL(0xffffbffff7feffff),
    ULL(0x77afdfaf77feffff),
    ULL(0xffffdffff7feffff),
    ULL(0xbbd7efd7b37cfeff),
    ULL(0xffffeffff7feffff),
    ULL(0xddebf7ebd5be7fff),
    ULL(0xfffff7fff7feffff),
    ULL(0xeef5fbf5e6debf7f),
    ULL(0xfffffbfff7feffff),
    ULL(0xf7fafdfaf7feffff),
    ULL(0xfffffdfff7feffff),
    ULL(0xfbfdfefdf3f6efdf),
    ULL(0xfffffefff7feffff),
    ULL(0xefdfbf7fb7deeff7),
    ULL(0xffffff7ff7feffff),
    ULL(0xf7ef5fbf57eef7fb),
    ULL(0xffffffbff7feffff),
    ULL(0xfb77afdfa776fbfd),
    ULL(0xffffffdff7feffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeff7fafdf2f6efdf),
    ULL(0xfffffffdf7fefeff),
    ULL(0xf7fbfdfef5faf7ef),
    ULL(0xfffffffef7fefeff),
    ULL(0xf7efdfbf77bedfef),
    ULL(0xffffffff77feffff),
    ULL(0xfbf7ef5fb75eeff7),
    ULL(0xffffffffb7feffff),
    ULL(0xfdfb77afd7ae77fb),
    ULL(0xffffffffd7feffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfeff7faf5faf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdf6fcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfb77ebfdf),
    ULL(0xfffffffff77effff),
    ULL(0xfdfbf7ef57be5fef),
    ULL(0xfffffffff7beffff),
    ULL(0xfefdfb77a7deaf77),
    ULL(0xfffffffff7deffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2a55aa55a2548a15),
    ULL(0x2010080402000204),
    ULL(0xfffffffff7feffff),
    ULL(0xfffffffff7feffff),
    ULL(0xfdfbf7efd7be7fbf),
    ULL(0xfffffffff7fe7fff),
    ULL(0xfefdfbf7e75ebf5f),
    ULL(0xfffffffff7febfff),
    ULL(0xffffffff77aedfaf),
    ULL(0xfffffffff7fedfff),
    ULL(0xfffffe7db3d6efd7),
    ULL(0xfffffffff7feefff),
    ULL(0xffff7fbed5eaf7eb),
    ULL(0xeaf5fa7db65ea353),
    ULL(0xea75ba5da654ab55),
    ULL(0x2a55aa55a2548b11),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0x2a55aa55a2548a15),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7e7debf7f),
    ULL(0xfffffffff7feff7f),
    ULL(0xfffffffff7ee5fbf),
    ULL(0xfffffffff7feffbf),
    ULL(0xfffffefdf376afdf),
    ULL(0xfffffffff7feffdf),
    ULL(0xfffffffe75bad7ef),
    ULL(0xfffffffff7feffef),
    ULL(0xffffff7fb6dcebf7),
    ULL(0xeaf5fa7db65eab53),
    ULL(0xffff7fbfd6eef5f3),
    ULL(0xaad5ea75b25cab51),
    ULL(0xaa55aa55a254aa55),
    ULL(0x2a55aa55a2548a10),
    ULL(0xaa55aa55a250a854),
    ULL(0x2a55aa55a2548a14),
    ULL(0x7fbfdfeff3fafdfe),
    ULL(0x7ffffffffbfeffff),
    ULL(0xbf5feff7fbfeffff),
    ULL(0xbffffffffbfeffff),
    ULL(0xdfaf77fbf9feffff),
    ULL(0xdffffffffbfeffff),
    ULL(0xefd7bb7dfafeffff),
    ULL(0xeffffffffbfeffff),
    ULL(0xf7ebddbe7bfeffff),
    ULL(0xf7fffffffbfeffff),
    ULL(0xfbf5eedfbb7effff),
    ULL(0xfbfffffffbfeffff),
    ULL(0xfdfaf7efdbbe7fff),
    ULL(0xfdfffffffbfeffff),
    ULL(0xfefdfbf7ebdebf7f),
    ULL(0xfefffffffbfeffff),
    ULL(0xbf7fbfdfebf6fbfd),
    ULL(0xff7ffffffbfeffff),
    ULL(0x5fbf5feff3fafdfe),
    ULL(0xffbffffffbfeffff),
    ULL(0xafdfaf77fbfeffff),
    ULL(0xffdffffffbfeffff),
    ULL(0xd7efd7bb79feffff),
    ULL(0xffeffffffbfeffff),
    ULL(0xebf7ebddba7effff),
    ULL(0xfff7fffffbfeffff),
    ULL(0xf5fbf5eedbbe7fff),
    ULL(0xfffbfffffbfeffff),
    ULL(0xfafdfaf7ebdebf7f),
    ULL(0xfffdfffffbfeffff),
    ULL(0xfdfefdfbf3eedfbf),
    ULL(0xfffefffffbfeffff),
    ULL(0xdfbf7fbfdbeef7fb),
    ULL(0xffff7ffffbfeffff),
    ULL(0xef5fbf5febf6fbfd),
    ULL(0xffffbffffbfeffff),
    ULL(0x77afdfaf73fafdfe),
    ULL(0xffffdffffbfeffff),
    ULL(0xbbd7efd7bb7effff),
    ULL(0xffffeffffbfeffff),
    ULL(0xddebf7ebd9be7fff),
    ULL(0xfffff7fffbfeffff),
    ULL(0xeef5fbf5eadebf7f),
    ULL(0xfffffbfffbfeffff),
    ULL(0xf7fafdfaf3eedfbf),
    ULL(0xfffffdfffbfeffff),
    ULL(0xfbfdfefdfbfeffff),
    ULL(0xfffffefffbfeffff),
    ULL(0xefdfbf7fbbdeeff7),
    ULL(0xffffff7ffbfeffff),
    ULL(0xf7ef5fbf5beef7fb),
    ULL(0xffffffbffbfeffff),
    ULL(0xfb77afdfab76fbfd),
    ULL(0xffffffdffbfeffff),
    ULL(0x7dbbd7efd3ba7dfe),
    ULL(0xffffffeffbfeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7fbfdfef9faf7ef),
    ULL(0xfffffffefbfefeff),
    ULL(0xf7efdfbf7bbedfef),
    ULL(0xffffffff7bfeffff),
    ULL(0xfbf7ef5fbb5eeff7),
    ULL(0xffffffffbbfeffff),
    ULL(0xfdfb77afdbae77fb),
    ULL(0xffffffffdbfeffff),
    ULL(0xfe7dbbd7ebd6bb7d),
    ULL(0xffffffffebfeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeff7fbfdfafcfaf7),
    ULL(0x2010080400000204),
    ULL(0xfbf7efdfbb7ebfdf),
    ULL(0xfffffffffb7effff),
    ULL(0xfdfbf7ef5bbe5fef),
    ULL(0xfffffffffbbeffff),
    ULL(0xfefdfb77abdeaf77),
    ULL(0xfffffffffbdeffff),
    ULL(0xfffe7dbbd3eed7bb),
    ULL(0xfffffffffbeeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffbfeffff),
    ULL(0xfffffffffbfeffff),
    ULL(0xfdfbf7efdbbe7fbf),
    ULL(0xfffffffffbfe7fff),
    ULL(0xfefdfbf7eb5ebf5f),
    ULL(0xfffffffffbfebfff),
    ULL(0xfffefdfb73aedfaf),
    ULL(0xfffffffffbfedfff),
    ULL(0xffffff7fbbd6efd7),
    ULL(0xfffffffffbfeefff),
    ULL(0xffff7fbed9eaf7eb),
    ULL(0xfffffefdfafef3f3),
    ULL(0xff7fbeddeaf4fbf5),
    ULL(0xaad5ea75ba5cab51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7ebdebf7f),
    ULL(0xfffffffffbfeff7f),
    ULL(0xfffefdfbf3ee5fbf),
    ULL(0xfffffffffbfeffbf),
    ULL(0xfffffffffb76afdf),
    ULL(0xfffffffffbfeffdf),
    ULL(0xfffffffe79bad7ef),
    ULL(0xfffffffffbfeffef),
    ULL(0xffffff7fbadcebf7),
    ULL(0xfffffefdfafefbf3),
    ULL(0xffff7ebddaeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff5fafdfe),
    ULL(0x7ffffffffdfeffff),
    ULL(0xbf5feff7f9fcfeff),
    ULL(0xbffffffffdfeffff),
    ULL(0xdfaf77fbfdfeffff),
    ULL(0xdffffffffdfeffff),
    ULL(0xefd7bb7dfcfeffff),
    ULL(0xeffffffffdfeffff),
    ULL(0xf7ebddbe7dfeffff),
    ULL(0xf7fffffffdfeffff),
    ULL(0xfbf5eedfbd7effff),
    ULL(0xfbfffffffdfeffff),
    ULL(0xfdfaf7efddbe7fff),
    ULL(0xfdfffffffdfeffff),
    ULL(0xfefdfbf7eddebf7f),
    ULL(0xfefffffffdfeffff),
    ULL(0xbf7fbfdfedf6fbfd),
    ULL(0xff7ffffffdfeffff),
    ULL(0x5fbf5feff5fafdfe),
    ULL(0xffbffffffdfeffff),
    ULL(0xafdfaf77f9fcfeff),
    ULL(0xffdffffffdfeffff),
    ULL(0xd7efd7bb7dfeffff),
    ULL(0xffeffffffdfeffff),
    ULL(0xebf7ebddbc7effff),
    ULL(0xfff7fffffdfeffff),
    ULL(0xf5fbf5eeddbe7fff),
    ULL(0xfffbfffffdfeffff),
    ULL(0xfafdfaf7eddebf7f),
    ULL(0xfffdfffffdfeffff),
    ULL(0xfdfefdfbf5eedfbf),
    ULL(0xfffefffffdfeffff),
    ULL(0xdfbf7fbfddeef7fb),
    ULL(0xffff7ffffdfeffff),
    ULL(0xef5fbf5fedf6fbfd),
    ULL(0xffffbffffdfeffff),
    ULL(0x77afdfaf75fafdfe),
    ULL(0xffffdffffdfeffff),
    ULL(0xbbd7efd7b97cfeff),
    ULL(0xffffeffffdfeffff),
    ULL(0xddebf7ebddbe7fff),
    ULL(0xfffff7fffdfeffff),
    ULL(0xeef5fbf5ecdebf7f),
    ULL(0xfffffbfffdfeffff),
    ULL(0xf7fafdfaf5eedfbf),
    ULL(0xfffffdfffdfeffff),
    ULL(0xfbfdfefdf9f6efdf),
    ULL(0xfffffefffdfeffff),
    ULL(0xefdfbf7fbddeeff7),
    ULL(0xffffff7ffdfeffff),
    ULL(0xf7ef5fbf5deef7fb),
    ULL(0xffffffbffdfeffff),
    ULL(0xfb77afdfad76fbfd),
    ULL(0xffffffdffdfeffff),
    ULL(0x7dbbd7efd5ba7dfe),
    ULL(0xffffffeffdfeffff),
    ULL(0xbeddebf7e9dcbe7f),
    ULL(0xfffffff7fdfeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7efdfbf7dbedfef),
    ULL(0xffffffff7dfeffff),
    ULL(0xfbf7ef5fbd5eeff7),
    ULL(0xffffffffbdfeffff),
    ULL(0xfdfb77afddae77fb),
    ULL(0xffffffffddfeffff),
    ULL(0xfe7dbbd7edd6bb7d),
    ULL(0xffffffffedfeffff),
    ULL(0x7fbeddebf5eaddbe),
    ULL(0xfffffffff5feffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbf7efdfbd7ebfdf),
    ULL(0xfffffffffd7effff),
    ULL(0xfdfbf7ef5dbe5fef),
    ULL(0xfffffffffdbeffff),
    ULL(0xfefdfb77addeaf77),
    ULL(0xfffffffffddeffff),
    ULL(0xfffe7dbbd5eed7bb),
    ULL(0xfffffffffdeeffff),
    ULL(0xff7fbedde9f6ebdd),
    ULL(0xfffffffffdf6fbff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffdfeffff),
    ULL(0xfffffffffdfeffff),
    ULL(0xfdfbf7efddbe7fbf),
    ULL(0xfffffffffdfe7fff),
    ULL(0xfefdfbf7ed5ebf5f),
    ULL(0xfffffffffdfebfff),
    ULL(0xfffefdfb75aedfaf),
    ULL(0xfffffffffdfedfff),
    ULL(0xfffffe7db9d6efd7),
    ULL(0xfffffffffdfeefff),
    ULL(0xffff7fbfddeaf7eb),
    ULL(0xfffffffffcfef3f3),
    ULL(0xff7fbfdfecf4fbf5),
    ULL(0xaad5ea75b85cab51),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55a854a850),
    ULL(0xaa55aa55a854aa55),
    ULL(0xaa55aa55a854aa54),
    ULL(0xfefdfbf7eddebf7f),
    ULL(0xfffffffffdfeff7f),
    ULL(0xfffefdfbf5ee5fbf),
    ULL(0xfffffffffdfeffbf),
    ULL(0xfffffefdf976afdf),
    ULL(0xfffffffffdfeffdf),
    ULL(0xffffffff7dbad7ef),
    ULL(0xfffffffffdfeffef),
    ULL(0xffffff7fbcdcebf7),
    ULL(0xfffffffffcfefbf3),
    ULL(0xffff7fbfdceef5f3),
    ULL(0xaad5ea75b85cab51),
    ULL(0xaa55aa55a854aa55),
    ULL(0xaa55aa55a854aa50),
    ULL(0x2a158a45a050a854),
    ULL(0xaa55aa55a854aa54),
    ULL(0x7fbfdfeff6fafdfe),
    ULL(0x7ffffffffefeffff),
    ULL(0xbf5feff7fafcfeff),
    ULL(0xbffffffffefeffff),
    ULL(0xdfaf77fbfcfeffff),
    ULL(0xdffffffffefeffff),
    ULL(0xefd7bb7dfefeffff),
    ULL(0xeffffffffefeffff),
    ULL(0xf7ebddbe7efeffff),
    ULL(0xf7fffffffefeffff),
    ULL(0xfbf5eedfbe7effff),
    ULL(0xfbfffffffefeffff),
    ULL(0xfdfaf7efdebe7fff),
    ULL(0xfdfffffffefeffff),
    ULL(0xfefdfbf7eedebf7f),
    ULL(0xfefffffffefeffff),
    ULL(0xbf7fbfdfeef6fbfd),
    ULL(0xff7ffffffefeffff),
    ULL(0x5fbf5feff6fafdfe),
    ULL(0xffbffffffefeffff),
    ULL(0xafdfaf77fafcfeff),
    ULL(0xffdffffffefeffff),
    ULL(0xd7efd7bb7cfeffff),
    ULL(0xffeffffffefeffff),
    ULL(0xebf7ebddbe7effff),
    ULL(0xfff7fffffefeffff),
    ULL(0xf5fbf5eedebe7fff),
    ULL(0xfffbfffffefeffff),
    ULL(0xfafdfaf7eedebf7f),
    ULL(0xfffdfffffefeffff),
    ULL(0xfdfefdfbf6eedfbf),
    ULL(0xfffefffffefeffff),
    ULL(0xdfbf7fbfdeeef7fb),
    ULL(0xffff7ffffefeffff),
    ULL(0xef5fbf5feef6fbfd),
    ULL(0xffffbffffefeffff),
    ULL(0x77afdfaf76fafdfe),
    ULL(0xffffdffffefeffff),
    ULL(0xbbd7efd7ba7cfeff),
    ULL(0xffffeffffefeffff),
    ULL(0xddebf7ebdcbe7fff),
    ULL(0xfffff7fffefeffff),
    ULL(0xeef5fbf5eedebf7f),
    ULL(0xfffffbfffefeffff),
    ULL(0xf7fafdfaf6eedfbf),
    ULL(0xfffffdfffefeffff),
    ULL(0xfbfdfefdfaf6efdf),
    ULL(0xfffffefffefeffff),
    ULL(0xefdfbf7fbedeeff7),
    ULL(0xffffff7ffefeffff),
    ULL(0xf7ef5fbf5eeef7fb),
    ULL(0xffffffbffefeffff),
    ULL(0xfb77afdfae76fbfd),
    ULL(0xffffffdffefeffff),
    ULL(0x7dbbd7efd6ba7dfe),
    ULL(0xffffffeffefeffff),
    ULL(0xbeddebf7eadcbe7f),
    ULL(0xfffffff7fefeffff),
    ULL(0xdfeef5fbf4eedfbf),
    ULL(0xfffffffbfefeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xf7efdfbf7ebedfef),
    ULL(0xffffffff7efeffff),
    ULL(0xfbf7ef5fbe5eeff7),
    ULL(0xffffffffbefeffff),
    ULL(0xfdfb77afdeae77fb),
    ULL(0xffffffffdefeffff),
    ULL(0xfe7dbbd7eed6bb7d),
    ULL(0xffffffffeefeffff),
    ULL(0x7fbeddebf6eaddbe),
    ULL(0xfffffffff6faffff),
    ULL(0xbfdfeef5faf4eedf),
    ULL(0xfffffffffafaffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbf7efdfbe7ebfdf),
    ULL(0xfffffffffe7effff),
    ULL(0xfdfbf7ef5ebe5fef),
    ULL(0xfffffffffebeffff),
    ULL(0xfefdfb77aedeaf77),
    ULL(0xfffffffffedeffff),
    ULL(0xfffe7dbbd6eed7bb),
    ULL(0xfffffffffeeeffff),
    ULL(0xff7fbeddeaf6ebdd),
    ULL(0xfffffffffef2fbff),
    ULL(0x7fbfdfeef4faf5ee),
    ULL(0xfffffffffefafbff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffefeffff),
    ULL(0xfffffffffefeffff),
    ULL(0xfdfbf7efdebe7fbf),
    ULL(0xfffffffffefe7fff),
    ULL(0xfefdfbf7ee5ebf5f),
    ULL(0xfffffffffefebfff),
    ULL(0xfffefdfb76aedfaf),
    ULL(0xfffffffffefedfff),
    ULL(0xfffffe7dbad6efd7),
    ULL(0xfffffffffefeefff),
    ULL(0xffff7fbedceaf7eb),
    ULL(0xfffffffffefaf3f3),
    ULL(0xff7fbfdfeef4fbf5),
    ULL(0xaad5ea75ba58ab51),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa50a850),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa54),
    ULL(0xfefdfbf7eedebf7f),
    ULL(0xfffffffffefeff7f),
    ULL(0xfffefdfbf6ee5fbf),
    ULL(0xfffffffffefeffbf),
    ULL(0xfffffefdfa76afdf),
    ULL(0xfffffffffefeffdf),
    ULL(0xfffffffe7cbad7ef),
    ULL(0xfffffffffefeffef),
    ULL(0xffffff7fbedcebf7),
    ULL(0xfffffffffefefbf3),
    ULL(0xffff7fbfdeeef5f3),
    ULL(0xaad5ea75ba5cab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff77afdfe),
    ULL(0x7fffffffff7effff),
    ULL(0xbf5feff7fb7cfeff),
    ULL(0xbfffffffff7effff),
    ULL(0xdfaf77fbfd7effff),
    ULL(0xdfffffffff7effff),
    ULL(0xefd7bb7dfe7effff),
    ULL(0xefffffffff7effff),
    ULL(0xf7ebddbe7f7effff),
    ULL(0xf7ffffffff7effff),
    ULL(0xfbf5eedfbf7effff),
    ULL(0xfbffffffff7effff),
    ULL(0xfdfaf7efdf3e7fff),
    ULL(0xfdffffffff7effff),
    ULL(0xfefdfbf7ef5ebf7f),
    ULL(0xfeffffffff7effff),
    ULL(0xbf7fbfdfef76fbfd),
    ULL(0xff7fffffff7effff),
    ULL(0x5fbf5feff77afdfe),
    ULL(0xffbfffffff7effff),
    ULL(0xafdfaf77fb7cfeff),
    ULL(0xffdfffffff7effff),
    ULL(0xd7efd7bb7d7effff),
    ULL(0xffefffffff7effff),
    ULL(0xebf7ebddbe7effff),
    ULL(0xfff7ffffff7effff),
    ULL(0xf5fbf5eedf3e7fff),
    ULL(0xfffbffffff7effff),
    ULL(0xfafdfaf7ef5ebf7f),
    ULL(0xfffdffffff7effff),
    ULL(0xfdfefdfbf76edfbf),
    ULL(0xfffeffffff7effff),
    ULL(0xdfbf7fbfdf6ef7fb),
    ULL(0xffff7fffff7effff),
    ULL(0xef5fbf5fef76fbfd),
    ULL(0xffffbfffff7effff),
    ULL(0x77afdfaf777afdfe),
    ULL(0xffffdfffff7effff),
    ULL(0xbbd7efd7bb7cfeff),
    ULL(0xffffefffff7effff),
    ULL(0xddebf7ebdd3e7fff),
    ULL(0xfffff7ffff7effff),
    ULL(0xeef5fbf5ee5ebf7f),
    ULL(0xfffffbffff7effff),
    ULL(0xf7fafdfaf76edfbf),
    ULL(0xfffffdffff7effff),
    ULL(0xfbfdfefdfb76efdf),
    ULL(0xfffffeffff7effff),
    ULL(0xefdfbf7fbf5eeff7),
    ULL(0xffffff7fff7effff),
    ULL(0xf7ef5fbf5f6ef7fb),
    ULL(0xffffffbfff7effff),
    ULL(0xfb77afdfaf76fbfd),
    ULL(0xffffffdfff7effff),
    ULL(0x7dbbd7efd73a7dfe),
    ULL(0xffffffefff7effff),
    ULL(0xbeddebf7eb5cbe7f),
    ULL(0xfffffff7ff7effff),
    ULL(0xdfeef5fbf56edfbf),
    ULL(0xfffffffbff7efeff),
    ULL(0xeff7fafdfa76efdf),
    ULL(0xfffffffdff7efeff),
    ULL(0xf7fbfdfefd7af7ef),
    ULL(0xfffffffeff7efeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfdfb77afdf2e77fb),
    ULL(0xffffffffdf7effff),
    ULL(0xfe7dbbd7ef56bb7d),
    ULL(0xffffffffef7effff),
    ULL(0x7fbeddebf76addbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfeef5fb74eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7fafd7af6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfe7cfaf7),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfb77af5eaf77),
    ULL(0xffffffffff5effff),
    ULL(0xfffe7dbbd76ed7bb),
    ULL(0xffffffffff6efeff),
    ULL(0xff7fbeddeb76ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffffff7effff),
    ULL(0xffffffffff7effff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffefdfb772edfaf),
    ULL(0xffffffffff7edfff),
    ULL(0xfffffe7dbb56efd7),
    ULL(0xffffffffff7eeeff),
    ULL(0xffff7fbedd6af6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7ef5ebf7f),
    ULL(0xfffefdfbf76e5f7f),
    ULL(0xfffefdfbf76e5fbf),
    ULL(0xffffffffff7effbf),
    ULL(0xfffffefdfb76afdf),
    ULL(0xffffffffff7effdf),
    ULL(0xfffffffe7d3ad7ef),
    ULL(0xffffffffff7efeef),
    ULL(0xffffff7fbe5cebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7fbfde6cf4f3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7bafdfe),
    ULL(0x7fffffffffbeffff),
    ULL(0xbf5feff7fbbcfeff),
    ULL(0xbfffffffffbeffff),
    ULL(0xdfaf77fbfdbeffff),
    ULL(0xdfffffffffbeffff),
    ULL(0xefd7bb7dfebeffff),
    ULL(0xefffffffffbeffff),
    ULL(0xf7ebddbe7fbeffff),
    ULL(0xf7ffffffffbeffff),
    ULL(0xfbf5eedfbf3effff),
    ULL(0xfbffffffffbeffff),
    ULL(0xfdfaf7efdfbeffff),
    ULL(0xfdffffffffbeffff),
    ULL(0xfefdfbf7ef9ebf7f),
    ULL(0xfeffffffffbeffff),
    ULL(0xbf7fbfdfefb6fbfd),
    ULL(0xff7fffffffbeffff),
    ULL(0x5fbf5feff7bafdfe),
    ULL(0xffbfffffffbeffff),
    ULL(0xafdfaf77fbbcfeff),
    ULL(0xffdfffffffbeffff),
    ULL(0xd7efd7bb7dbeffff),
    ULL(0xffefffffffbeffff),
    ULL(0xebf7ebddbe3effff),
    ULL(0xfff7ffffffbeffff),
    ULL(0xf5fbf5eedfbeffff),
    ULL(0xfffbffffffbeffff),
    ULL(0xfafdfaf7ef9ebf7f),
    ULL(0xfffdffffffbeffff),
    ULL(0xfdfefdfbf7aedfbf),
    ULL(0xfffeffffffbeffff),
    ULL(0xdfbf7fbfdfaef7fb),
    ULL(0xffff7fffffbeffff),
    ULL(0xef5fbf5fefb6fbfd),
    ULL(0xffffbfffffbeffff),
    ULL(0x77afdfaf77bafdfe),
    ULL(0xffffdfffffbeffff),
    ULL(0xbbd7efd7bb3cfeff),
    ULL(0xffffefffffbeffff),
    ULL(0xddebf7ebddbeffff),
    ULL(0xfffff7ffffbeffff),
    ULL(0xeef5fbf5ee9ebf7f),
    ULL(0xfffffbffffbeffff),
    ULL(0xf7fafdfaf7aedfbf),
    ULL(0xfffffdffffbeffff),
    ULL(0xfbfdfefdfbb6efdf),
    ULL(0xfffffeffffbeffff),
    ULL(0xefdfbf7fbf9eeff7),
    ULL(0xffffff7fffbeffff),
    ULL(0xf7ef5fbf5faef7fb),
    ULL(0xffffffbfffbeffff),
    ULL(0xfb77afdfaf36fbfd),
    ULL(0xffffffdfffbeffff),
    ULL(0x7dbbd7efd7bafdfe),
    ULL(0xffffffefffbeffff),
    ULL(0xbeddebf7eb9cbe7f),
    ULL(0xfffffff7ffbeffff),
    ULL(0xdfeef5fbf5aedfbf),
    ULL(0xfffffffbffbefeff),
    ULL(0xeff7fafdfab6efdf),
    ULL(0xfffffffdffbefeff),
    ULL(0xf7fbfdfefdbaf7ef),
    ULL(0xfffffffeffbefeff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfe7dbbd7ef96bb7d),
    ULL(0xffffffffefbeffff),
    ULL(0x7fbeddebf7aaddbe),
    ULL(0xba5daed7e332be5d),
    ULL(0xbfdfeef5fbb4eedf),
    ULL(0xaa55aa55ab102e5d),
    ULL(0xdfeff7fafdbaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfebcfaf7),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffe7dbbd7aed7bb),
    ULL(0xffffffffffaefeff),
    ULL(0xff7fbeddebb6ebdd),
    ULL(0xaa55aa55ab12aa5d),
    ULL(0x3a1d8ec6e132b44c),
    ULL(0xaa55aa55ab102a5d),
    ULL(0xaa55aa55aa142a55),
    ULL(0x2010080402000204),
    ULL(0xffffffffffbeffff),
    ULL(0xffffffffffbeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffe7dbb96efd7),
    ULL(0xffffffffffbeeeff),
    ULL(0xffff7fbeddaaf6eb),
    ULL(0xaa55aa55aa10a251),
    ULL(0xaa55aa55aa14aa55),
    ULL(0xaa55aa55aa102a51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa142a55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7ef9ebf7f),
    ULL(0xfffefdfbf7ae5f7f),
    ULL(0xfffefdfbf7ae5fbf),
    ULL(0xffffffffffbebfbf),
    ULL(0xfffffefdfb36afdf),
    ULL(0xffffffffffbeffdf),
    ULL(0xfffffffefdbad7ef),
    ULL(0xffffffffffbefeef),
    ULL(0xffffff7fbe9cebf7),
    ULL(0xaad5ea75ba1caa53),
    ULL(0xffff7fbfdeacf4f3),
    ULL(0xaad5ea75ba1caa51),
    ULL(0xaa55aa55aa14aa55),
    ULL(0xaa55aa55aa142a50),
    ULL(0x2a158a45a210a854),
    ULL(0xaa55aa55aa142a54),
    ULL(0x7fbfdfeff7dafdfe),
    ULL(0x7fffffffffdeffff),
    ULL(0xbf5feff7fbdcfeff),
    ULL(0xbfffffffffdeffff),
    ULL(0xdfaf77fbfddeffff),
    ULL(0xdfffffffffdeffff),
    ULL(0xefd7bb7dfedeffff),
    ULL(0xefffffffffdeffff),
    ULL(0xf7ebddbe7fdeffff),
    ULL(0xf7ffffffffdeffff),
    ULL(0xfbf5eedfbf5effff),
    ULL(0xfbffffffffdeffff),
    ULL(0xfdfaf7efdf9e7fff),
    ULL(0xfdffffffffdeffff),
    ULL(0xfefdfbf7efdeffff),
    ULL(0xfeffffffffdeffff),
    ULL(0xbf7fbfdfefd6fbfd),
    ULL(0xff7fffffffdeffff),
    ULL(0x5fbf5feff7dafdfe),
    ULL(0xffbfffffffdeffff),
    ULL(0xafdfaf77fbdcfeff),
    ULL(0xffdfffffffdeffff),
    ULL(0xd7efd7bb7ddeffff),
    ULL(0xffefffffffdeffff),
    ULL(0xebf7ebddbe5effff),
    ULL(0xfff7ffffffdeffff),
    ULL(0xf5fbf5eedf9e7fff),
    ULL(0xfffbffffffdeffff),
    ULL(0xfafdfaf7efdeffff),
    ULL(0xfffdffffffdeffff),
    ULL(0xfdfefdfbf7cedfbf),
    ULL(0xfffeffffffdeffff),
    ULL(0xdfbf7fbfdfcef7fb),
    ULL(0xffff7fffffdeffff),
    ULL(0xef5fbf5fefd6fbfd),
    ULL(0xffffbfffffdeffff),
    ULL(0x77afdfaf77dafdfe),
    ULL(0xffffdfffffdeffff),
    ULL(0xbbd7efd7bb5cfeff),
    ULL(0xffffefffffdeffff),
    ULL(0xddebf7ebdd9e7fff),
    ULL(0xfffff7ffffdeffff),
    ULL(0xeef5fbf5eedeffff),
    ULL(0xfffffbffffdeffff),
    ULL(0xf7fafdfaf7cedfbf),
    ULL(0xfffffdffffdeffff),
    ULL(0xfbfdfefdfbd6efdf),
    ULL(0xfffffeffffdeffff),
    ULL(0xefdfbf7fbfdeffff),
    ULL(0xffffff7fffdeffff),
    ULL(0xf7ef5fbf5fcef7fb),
    ULL(0xffffffbfffdeffff),
    ULL(0xfb77afdfaf56fbfd),
    ULL(0xffffffdfffdeffff),
    ULL(0x7dbbd7efd79a7dfe),
    ULL(0xffffffefffdeffff),
    ULL(0xbeddebf7ebdcfeff),
    ULL(0xfffffff7ffdeffff),
    ULL(0xdfeef5fbf5cedfbf),
    ULL(0xfffffffbffdefeff),
    ULL(0xeff7fafdfad6efdf),
    ULL(0xfffffffdffdefeff),
    ULL(0xf7fbfdfefddaf7ef),
    ULL(0xfffffffeffdefeff),
    ULL(0xf7efdfbf7f9edfef),
    ULL(0xffffffff7fdeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbeddebf7caddbe),
    ULL(0xba5dae57a352be5d),
    ULL(0xbfdfeef5fbd4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7fafddaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfedcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf5ebfdf),
    ULL(0xffffffffff1effff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xff7fbeddebd6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8e46a152b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffffffdeffff),
    ULL(0xffffffffffdeffff),
    ULL(0xfdfbf7efdf9e7fbf),
    ULL(0xffffffffffde7fff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xffff7fbeddcaf6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xffffffffffdebf7f),
    ULL(0xffffffffffdeff7f),
    ULL(0xfffefdfbf7ce5fbf),
    ULL(0xffffffffffdeffbf),
    ULL(0xfffffefdfb56afdf),
    ULL(0xffffffffffdedfdf),
    ULL(0xfffffffe7d9ad7ef),
    ULL(0xffffffffffdefeef),
    ULL(0xfffffffffedcebf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7fbfdeccb573),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7eafdfe),
    ULL(0x7fffffffffeeffff),
    ULL(0xbf5feff7fbecfeff),
    ULL(0xbfffffffffeeffff),
    ULL(0xdfaf77fbfdeeffff),
    ULL(0xdfffffffffeeffff),
    ULL(0xefd7bb7dfeeeffff),
    ULL(0xefffffffffeeffff),
    ULL(0xf7ebddbe7feeffff),
    ULL(0xf7ffffffffeeffff),
    ULL(0xfbf5eedfbf6effff),
    ULL(0xfbffffffffeeffff),
    ULL(0xfdfaf7efdfae7fff),
    ULL(0xfdffffffffeeffff),
    ULL(0xfefdfbf7efcebf7f),
    ULL(0xfeffffffffeeffff),
    ULL(0xbf7fbfdfefe6fbfd),
    ULL(0xff7fffffffeeffff),
    ULL(0x5fbf5feff7eafdfe),
    ULL(0xffbfffffffeeffff),
    ULL(0xafdfaf77fbecfeff),
    ULL(0xffdfffffffeeffff),
    ULL(0xd7efd7bb7deeffff),
    ULL(0xffefffffffeeffff),
    ULL(0xebf7ebddbe6effff),
    ULL(0xfff7ffffffeeffff),
    ULL(0xf5fbf5eedfae7fff),
    ULL(0xfffbffffffeeffff),
    ULL(0xfafdfaf7efcebf7f),
    ULL(0xfffdffffffeeffff),
    ULL(0xfdfefdfbf7eeffff),
    ULL(0xfffeffffffeeffff),
    ULL(0xdfbf7fbfdfeeffff),
    ULL(0xffff7fffffeeffff),
    ULL(0xef5fbf5fefe6fbfd),
    ULL(0xffffbfffffeeffff),
    ULL(0x77afdfaf77eafdfe),
    ULL(0xffffdfffffeeffff),
    ULL(0xbbd7efd7bb6cfeff),
    ULL(0xffffefffffeeffff),
    ULL(0xddebf7ebddae7fff),
    ULL(0xfffff7ffffeeffff),
    ULL(0xeef5fbf5eecebf7f),
    ULL(0xfffffbffffeeffff),
    ULL(0xf7fafdfaf7eeffff),
    ULL(0xfffffdffffeeffff),
    ULL(0xfbfdfefdfbe6efdf),
    ULL(0xfffffeffffeeffff),
    ULL(0xefdfbf7fbfceeff7),
    ULL(0xffffff7fffeeffff),
    ULL(0xf7ef5fbf5feeffff),
    ULL(0xffffffbfffeeffff),
    ULL(0xfb77afdfaf66fbfd),
    ULL(0xffffffdfffeeffff),
    ULL(0x7dbbd7efd7aa7dfe),
    ULL(0xffffffefffeeffff),
    ULL(0xbeddebf7ebccbe7f),
    ULL(0xfffffff7ffeeffff),
    ULL(0xdfeef5fbf5eeffff),
    ULL(0xfffffffbffeefeff),
    ULL(0xeff7fafdfae6efdf),
    ULL(0xfffffffdffeefeff),
    ULL(0xf7fbfdfefdeaf7ef),
    ULL(0xfffffffeffeefeff),
    ULL(0xf7efdfbf7faedfef),
    ULL(0xffffffff7feeffff),
    ULL(0xfbf7ef5fbf4eeff7),
    ULL(0xffffffffbfeeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xbfdfeef5fbe4eedf),
    ULL(0xaa55aa55ab408e1d),
    ULL(0xdfeff7fafdeaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfeecfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf6ebfdf),
    ULL(0xffffffffff6effff),
    ULL(0xfdfbf7ef5fae5fef),
    ULL(0xffffffffffaeffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x3a1d8ec6e162b44c),
    ULL(0xaa55aa55ab408a1d),
    ULL(0xaa55aa55aa448a15),
    ULL(0x2010080402000204),
    ULL(0xffffffffffeeffff),
    ULL(0xffffffffffeeffff),
    ULL(0xfdfbf7efdfae7fbf),
    ULL(0xffffffffffee7fff),
    ULL(0xfefdfbf7ef4ebf5f),
    ULL(0xffffffffffeebfff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa44ab55),
    ULL(0xaa55aa55aa408a11),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa448a15),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efcebf7f),
    ULL(0xffffffffffeeff7f),
    ULL(0xffffffffffee5fbf),
    ULL(0xffffffffffeeffbf),
    ULL(0xfffffefdfb66afdf),
    ULL(0xffffffffffeeffdf),
    ULL(0xfffffffe7daad7ef),
    ULL(0xffffffffffeeefef),
    ULL(0xffffff7fbeccebf7),
    ULL(0xaad5ea75ba4eab53),
    ULL(0xfffffffffeeef5f3),
    ULL(0xaad5ea75ba4cab51),
    ULL(0xaa55aa55aa44aa55),
    ULL(0xaa55aa55aa448a10),
    ULL(0x2a158a45a240a854),
    ULL(0xaa55aa55aa448a14),
    ULL(0x7fbfdfeff7f2fdfe),
    ULL(0x7ffffffffff6ffff),
    ULL(0xbf5feff7fbf4feff),
    ULL(0xbffffffffff6ffff),
    ULL(0xdfaf77fbfdf6ffff),
    ULL(0xdffffffffff6ffff),
    ULL(0xefd7bb7dfef6ffff),
    ULL(0xeffffffffff6ffff),
    ULL(0xf7ebddbe7ff6ffff),
    ULL(0xf7fffffffff6ffff),
    ULL(0xfbf5eedfbf76ffff),
    ULL(0xfbfffffffff6ffff),
    ULL(0xfdfaf7efdfb67fff),
    ULL(0xfdfffffffff6ffff),
    ULL(0xfefdfbf7efd6bf7f),
    ULL(0xfefffffffff6ffff),
    ULL(0xbf7fbfdfeff6ffff),
    ULL(0xff7ffffffff6ffff),
    ULL(0x5fbf5feff7f2fdfe),
    ULL(0xffbffffffff6ffff),
    ULL(0xafdfaf77fbf4feff),
    ULL(0xffdffffffff6ffff),
    ULL(0xd7efd7bb7df6ffff),
    ULL(0xffeffffffff6ffff),
    ULL(0xebf7ebddbe76ffff),
    ULL(0xfff7fffffff6ffff),
    ULL(0xf5fbf5eedfb67fff),
    ULL(0xfffbfffffff6ffff),
    ULL(0xfafdfaf7efd6bf7f),
    ULL(0xfffdfffffff6ffff),
    ULL(0xfdfefdfbf7e6dfbf),
    ULL(0xfffefffffff6ffff),
    ULL(0xdfbf7fbfdfe6f7fb),
    ULL(0xffff7ffffff6ffff),
    ULL(0xef5fbf5feff6ffff),
    ULL(0xffffbffffff6ffff),
    ULL(0x77afdfaf77f2fdfe),
    ULL(0xffffdffffff6ffff),
    ULL(0xbbd7efd7bb74feff),
    ULL(0xffffeffffff6ffff),
    ULL(0xddebf7ebddb67fff),
    ULL(0xfffff7fffff6ffff),
    ULL(0xeef5fbf5eed6bf7f),
    ULL(0xfffffbfffff6ffff),
    ULL(0xf7fafdfaf7e6dfbf),
    ULL(0xfffffdfffff6ffff),
    ULL(0xfbfdfefdfbf6ffff),
    ULL(0xfffffefffff6ffff),
    ULL(0xefdfbf7fbfd6eff7),
    ULL(0xffffff7ffff6ffff),
    ULL(0xf7ef5fbf5fe6f7fb),
    ULL(0xffffffbffff6ffff),
    ULL(0xfb77afdfaf76ffff),
    ULL(0xffffffdffff6ffff),
    ULL(0x7dbbd7efd7b27dfe),
    ULL(0xffffffeffff6ffff),
    ULL(0xbeddebf7ebd4be7f),
    ULL(0xfffffff7fff6ffff),
    ULL(0xdfeef5fbf5e6dfbf),
    ULL(0xfffffffbfff6feff),
    ULL(0xeff7fafdfaf6ffff),
    ULL(0xfffffffdfff6feff),
    ULL(0xf7fbfdfefdf2f7ef),
    ULL(0xfffffffefff6feff),
    ULL(0xf7efdfbf7fb6dfef),
    ULL(0xffffffff7ff6ffff),
    ULL(0xfbf7ef5fbf56eff7),
    ULL(0xffffffffbff6ffff),
    ULL(0xfdfb77afdfa677fb),
    ULL(0xffffffffdff6ffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xdfeff7fafdf2f6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfef4faf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf76bfdf),
    ULL(0xffffffffff76ffff),
    ULL(0xfdfbf7ef5fb65fef),
    ULL(0xffffffffffb6ffff),
    ULL(0xfefdfb77afd6af77),
    ULL(0xffffffffffd6ffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffff6ffff),
    ULL(0xfffffffffff6ffff),
    ULL(0xfdfbf7efdfb67fbf),
    ULL(0xfffffffffff67fff),
    ULL(0xfefdfbf7ef56bf5f),
    ULL(0xfffffffffff6bfff),
    ULL(0xfffefdfb77a6dfaf),
    ULL(0xfffffffffff6dfff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efd6bf7f),
    ULL(0xfffffffffff6ff7f),
    ULL(0xfffefdfbf7e65fbf),
    ULL(0xfffffffffff6ffbf),
    ULL(0xffffffffff76afdf),
    ULL(0xfffffffffff6ffdf),
    ULL(0xfffffffe7db2d7ef),
    ULL(0xfffffffffff6ffef),
    ULL(0xffffff7fbed4ebf7),
    ULL(0xeaf5fa7dbe56a353),
    ULL(0xeaf57a3d9e46a153),
    ULL(0xaa55aa55aa54ab51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7faffff),
    ULL(0x7ffffffffffaffff),
    ULL(0xbf5feff7fbf8feff),
    ULL(0xbffffffffffaffff),
    ULL(0xdfaf77fbfdfaffff),
    ULL(0xdffffffffffaffff),
    ULL(0xefd7bb7dfefaffff),
    ULL(0xeffffffffffaffff),
    ULL(0xf7ebddbe7ffaffff),
    ULL(0xf7fffffffffaffff),
    ULL(0xfbf5eedfbf7affff),
    ULL(0xfbfffffffffaffff),
    ULL(0xfdfaf7efdfba7fff),
    ULL(0xfdfffffffffaffff),
    ULL(0xfefdfbf7efdabf7f),
    ULL(0xfefffffffffaffff),
    ULL(0xbf7fbfdfeff2fbfd),
    ULL(0xff7ffffffffaffff),
    ULL(0x5fbf5feff7faffff),
    ULL(0xffbffffffffaffff),
    ULL(0xafdfaf77fbf8feff),
    ULL(0xffdffffffffaffff),
    ULL(0xd7efd7bb7dfaffff),
    ULL(0xffeffffffffaffff),
    ULL(0xebf7ebddbe7affff),
    ULL(0xfff7fffffffaffff),
    ULL(0xf5fbf5eedfba7fff),
    ULL(0xfffbfffffffaffff),
    ULL(0xfafdfaf7efdabf7f),
    ULL(0xfffdfffffffaffff),
    ULL(0xfdfefdfbf7eadfbf),
    ULL(0xfffefffffffaffff),
    ULL(0xdfbf7fbfdfeaf7fb),
    ULL(0xffff7ffffffaffff),
    ULL(0xef5fbf5feff2fbfd),
    ULL(0xffffbffffffaffff),
    ULL(0x77afdfaf77faffff),
    ULL(0xffffdffffffaffff),
    ULL(0xbbd7efd7bb78feff),
    ULL(0xffffeffffffaffff),
    ULL(0xddebf7ebddba7fff),
    ULL(0xfffff7fffffaffff),
    ULL(0xeef5fbf5eedabf7f),
    ULL(0xfffffbfffffaffff),
    ULL(0xf7fafdfaf7eadfbf),
    ULL(0xfffffdfffffaffff),
    ULL(0xfbfdfefdfbf2efdf),
    ULL(0xfffffefffffaffff),
    ULL(0xefdfbf7fbfdaeff7),
    ULL(0xffffff7ffffaffff),
    ULL(0xf7ef5fbf5feaf7fb),
    ULL(0xffffffbffffaffff),
    ULL(0xfb77afdfaf72fbfd),
    ULL(0xffffffdffffaffff),
    ULL(0x7dbbd7efd7ba7fff),
    ULL(0xffffffeffffaffff),
    ULL(0xbeddebf7ebd8be7f),
    ULL(0xfffffff7fffaffff),
    ULL(0xdfeef5fbf5eadfbf),
    ULL(0xfffffffbfffaffff),
    ULL(0xeff7fafdfaf2efdf),
    ULL(0xfffffffdfffaffff),
    ULL(0xf7fbfdfefdfaffff),
    ULL(0xfffffffefffaffff),
    ULL(0xf7efdfbf7fbadfef),
    ULL(0xffffffff7ffaffff),
    ULL(0xfbf7ef5fbf5aeff7),
    ULL(0xffffffffbffaffff),
    ULL(0xfdfb77afdfaa77fb),
    ULL(0xffffffffdffaffff),
    ULL(0xfe7dbbd7efd2bb7d),
    ULL(0xffffffffeffaffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xeff7fbfdfef8fbf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7abfdf),
    ULL(0xffffffffff7affff),
    ULL(0xfdfbf7ef5fba5fef),
    ULL(0xffffffffffbaffff),
    ULL(0xfefdfb77afdaaf77),
    ULL(0xffffffffffdaffff),
    ULL(0xfffe7dbbd7ead7bb),
    ULL(0xffffffffffeaffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffffaffff),
    ULL(0xfffffffffffaffff),
    ULL(0xfdfbf7efdfba7fbf),
    ULL(0xfffffffffffa7fff),
    ULL(0xfefdfbf7ef5abf5f),
    ULL(0xfffffffffffabfff),
    ULL(0xfffefdfb77aadfaf),
    ULL(0xfffffffffffadfff),
    ULL(0xfffffe7dbbd2efd7),
    ULL(0xfffffffffffaefff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa50aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdabf7f),
    ULL(0xfffffffffffaff7f),
    ULL(0xfffefdfbf7ea5fbf),
    ULL(0xfffffffffffaffbf),
    ULL(0xfffffefdfb72afdf),
    ULL(0xfffffffffffaffdf),
    ULL(0xffffffff7fbad7ef),
    ULL(0xfffffffffffaffef),
    ULL(0xffffff7fbed8ebf7),
    ULL(0xfffffffffefafff7),
    ULL(0xffff7fbfdeeaf5fb),
    ULL(0xaad5ea75ba58ab51),
    ULL(0xaa55aa55aa50aa55),
    ULL(0xaa55aa55aa50aa54),
    ULL(0xaa55aa55aa50a854),
    ULL(0xaa55aa55aa50aa54),
    ULL(0x7fbfdfeff7f8fdfe),
    ULL(0x7ffffffffffcffff),
    ULL(0xbf5feff7fbfcffff),
    ULL(0xbffffffffffcffff),
    ULL(0xdfaf77fbfdfcffff),
    ULL(0xdffffffffffcffff),
    ULL(0xefd7bb7dfefcffff),
    ULL(0xeffffffffffcffff),
    ULL(0xf7ebddbe7ffcffff),
    ULL(0xf7fffffffffcffff),
    ULL(0xfbf5eedfbf7cffff),
    ULL(0xfbfffffffffcffff),
    ULL(0xfdfaf7efdfbc7fff),
    ULL(0xfdfffffffffcffff),
    ULL(0xfefdfbf7efdcbf7f),
    ULL(0xfefffffffffcffff),
    ULL(0xbf7fbfdfeff4fbfd),
    ULL(0xff7ffffffffcffff),
    ULL(0x5fbf5feff7f8fdfe),
    ULL(0xffbffffffffcffff),
    ULL(0xafdfaf77fbfcffff),
    ULL(0xffdffffffffcffff),
    ULL(0xd7efd7bb7dfcffff),
    ULL(0xffeffffffffcffff),
    ULL(0xebf7ebddbe7cffff),
    ULL(0xfff7fffffffcffff),
    ULL(0xf5fbf5eedfbc7fff),
    ULL(0xfffbfffffffcffff),
    ULL(0xfafdfaf7efdcbf7f),
    ULL(0xfffdfffffffcffff),
    ULL(0xfdfefdfbf7ecdfbf),
    ULL(0xfffefffffffcffff),
    ULL(0xdfbf7fbfdfecf7fb),
    ULL(0xffff7ffffffcffff),
    ULL(0xef5fbf5feff4fbfd),
    ULL(0xffffbffffffcffff),
    ULL(0x77afdfaf77f8fdfe),
    ULL(0xffffdffffffcffff),
    ULL(0xbbd7efd7bb7cffff),
    ULL(0xffffeffffffcffff),
    ULL(0xddebf7ebddbc7fff),
    ULL(0xfffff7fffffcffff),
    ULL(0xeef5fbf5eedcbf7f),
    ULL(0xfffffbfffffcffff),
    ULL(0xf7fafdfaf7ecdfbf),
    ULL(0xfffffdfffffcffff),
    ULL(0xfbfdfefdfbf4efdf),
    ULL(0xfffffefffffcffff),
    ULL(0xefdfbf7fbfdceff7),
    ULL(0xffffff7ffffcffff),
    ULL(0xf7ef5fbf5fecf7fb),
    ULL(0xffffffbffffcffff),
    ULL(0xfb77afdfaf74fbfd),
    ULL(0xffffffdffffcffff),
    ULL(0x7dbbd7efd7b87dfe),
    ULL(0xffffffeffffcffff),
    ULL(0xbeddebf7ebdcbf7f),
    ULL(0xfffffff7fffcffff),
    ULL(0xdfeef5fbf5ecdfbf),
    ULL(0xfffffffbfffcffff),
    ULL(0xeff7fafdfaf4efdf),
    ULL(0xfffffffdfffcffff),
    ULL(0xf7fbfdfefdf8f7ef),
    ULL(0xfffffffefffcffff),
    ULL(0xf7efdfbf7fbcdfef),
    ULL(0xffffffff7ffcffff),
    ULL(0xfbf7ef5fbf5ceff7),
    ULL(0xffffffffbffcffff),
    ULL(0xfdfb77afdfac77fb),
    ULL(0xffffffffdffcffff),
    ULL(0xfe7dbbd7efd4bb7d),
    ULL(0xffffffffeffcffff),
    ULL(0x7fbeddebf7e8ddbe),
    ULL(0xfffffffff7fcffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfbf7efdfbf7cbfdf),
    ULL(0xffffffffff7cffff),
    ULL(0xfdfbf7ef5fbc5fef),
    ULL(0xffffffffffbcffff),
    ULL(0xfefdfb77afdcaf77),
    ULL(0xffffffffffdcffff),
    ULL(0xfffe7dbbd7ecd7bb),
    ULL(0xffffffffffecffff),
    ULL(0xff7fbeddebf4ebdd),
    ULL(0xfffffffffff4ffff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffffcffff),
    ULL(0xfffffffffffcffff),
    ULL(0xfdfbf7efdfbc7fbf),
    ULL(0xfffffffffffc7fff),
    ULL(0xfefdfbf7ef5cbf5f),
    ULL(0xfffffffffffcbfff),
    ULL(0xfffefdfb77acdfaf),
    ULL(0xfffffffffffcdfff),
    ULL(0xfffffe7dbbd4efd7),
    ULL(0xfffffffffffcefff),
    ULL(0xffff7fbedde8f7eb),
    ULL(0xfffffffffffcf7ff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfbf7efdcbf7f),
    ULL(0xfffffffffffcff7f),
    ULL(0xfffefdfbf7ec5fbf),
    ULL(0xfffffffffffcffbf),
    ULL(0xfffffefdfb74afdf),
    ULL(0xfffffffffffcffdf),
    ULL(0xfffffffe7db8d7ef),
    ULL(0xfffffffffffcffef),
    ULL(0xffffff7fbfdcebf7),
    ULL(0xfffffffffffcfff7),
    ULL(0xffff7fbfdfecf5fb),
    ULL(0xaad5ea75ba5caf51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54a854),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbfdfeff7fa7dfe),
    ULL(0x7ffffffffffe7fff),
    ULL(0xbf5feff7fbfc7eff),
    ULL(0xbffffffffffe7fff),
    ULL(0xdfaf77fbfdfe7fff),
    ULL(0xdffffffffffe7fff),
    ULL(0xefd7bb7dfefe7fff),
    ULL(0xeffffffffffe7fff),
    ULL(0xf7ebddbe7ffe7fff),
    ULL(0xf7fffffffffe7fff),
    ULL(0xfbf5eedfbf7e7fff),
    ULL(0xfbfffffffffe7fff),
    ULL(0xfdfaf7efdfbe7fff),
    ULL(0xfdfffffffffe7fff),
    ULL(0xfefdfbf7efde3f7f),
    ULL(0xfefffffffffe7fff),
    ULL(0xbf7fbfdfeff67bfd),
    ULL(0xff7ffffffffe7fff),
    ULL(0x5fbf5feff7fa7dfe),
    ULL(0xffbffffffffe7fff),
    ULL(0xafdfaf77fbfc7eff),
    ULL(0xffdffffffffe7fff),
    ULL(0xd7efd7bb7dfe7fff),
    ULL(0xffeffffffffe7fff),
    ULL(0xebf7ebddbe7e7fff),
    ULL(0xfff7fffffffe7fff),
    ULL(0xf5fbf5eedfbe7fff),
    ULL(0xfffbfffffffe7fff),
    ULL(0xfafdfaf7efde3f7f),
    ULL(0xfffdfffffffe7fff),
    ULL(0xfdfefdfbf7ee5fbf),
    ULL(0xfffefffffffe7fff),
    ULL(0xdfbf7fbfdfee77fb),
    ULL(0xffff7ffffffe7fff),
    ULL(0xef5fbf5feff67bfd),
    ULL(0xffffbffffffe7fff),
    ULL(0x77afdfaf77fa7dfe),
    ULL(0xffffdffffffe7fff),
    ULL(0xbbd7efd7bb7c7eff),
    ULL(0xffffeffffffe7fff),
    ULL(0xddebf7ebddbe7fff),
    ULL(0xfffff7fffffe7fff),
    ULL(0xeef5fbf5eede3f7f),
    ULL(0xfffffbfffffe7fff),
    ULL(0xf7fafdfaf7ee5fbf),
    ULL(0xfffffdfffffe7fff),
    ULL(0xfbfdfefdfbf66fdf),
    ULL(0xfffffefffffe7fff),
    ULL(0xefdfbf7fbfde6ff7),
    ULL(0xffffff7ffffe7fff),
    ULL(0xf7ef5fbf5fee77fb),
    ULL(0xffffffbffffe7fff),
    ULL(0xfb77afdfaf767bfd),
    ULL(0xffffffdffffe7fff),
    ULL(0x7dbbd7efd7ba7dfe),
    ULL(0xffffffeffffe7fff),
    ULL(0xbeddebf7ebdc3e7f),
    ULL(0xfffffff7fffe7fff),
    ULL(0xdfeef5fbf5ee5fbf),
    ULL(0xfffffffbfffe7eff),
    ULL(0xeff7fafdfaf66fdf),
    ULL(0xfffffffdfffe7eff),
    ULL(0xf7fbfdfefdfa77ef),
    ULL(0xfffffffefffe7eff),
    ULL(0xf7efdfbf7fbe5fef),
    ULL(0xffffffff7ffe7fff),
    ULL(0xfbf7ef5fbf5e6ff7),
    ULL(0xffffffffbffe7fff),
    ULL(0xfdfb77afdfae77fb),
    ULL(0xffffffffdffe7fff),
    ULL(0xfe7dbbd7efd63b7d),
    ULL(0xffffffffeffe7fff),
    ULL(0x7fbeddebf7ea5dbe),
    ULL(0xba5daed7e3723e5d),
    ULL(0xbfdfeef5fbf46edf),
    ULL(0xaa55aa55ab502e5d),
    ULL(0xdfeff7fafdfa76ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefc7af7),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfb77afde2f77),
    ULL(0xffffffffffde7fff),
    ULL(0xfffe7dbbd7ee57bb),
    ULL(0xffffffffffee7eff),
    ULL(0xff7fbeddebf66bdd),
    ULL(0xaa55aa55ab522a5d),
    ULL(0x3a1d8ec6e172344c),
    ULL(0xaa55aa55ab502a5d),
    ULL(0xaa55aa55aa542a55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffe7fff),
    ULL(0xfffffffffffe7fff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffefdfb77ae5faf),
    ULL(0xfffffffffffe5fff),
    ULL(0xfffffe7dbbd66fd7),
    ULL(0xfffffffffffe6eff),
    ULL(0xffff7fbeddea76eb),
    ULL(0xaa55aa55aa502251),
    ULL(0xaa55aa55aa542a55),
    ULL(0xaa55aa55aa502a51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa542a55),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffefdfb762fdf),
    ULL(0xfffffffffffe7fdf),
    ULL(0xfffffffe7dba57ef),
    ULL(0xfffffffffffe7eef),
    ULL(0xffffff7fbedc6bf7),
    ULL(0xaad5ea75ba5c2a53),
    ULL(0xffff7fbfdeec74f3),
    ULL(0xaad5ea75ba5c2a51),
    ULL(0xaa55aa55aa542a55),
    ULL(0xaa55aa55aa542a50),
    ULL(0x2a158a45a2502854),
    ULL(0xaa55aa55aa542a54),
    ULL(0x7fbfdfeff7fabdfe),
    ULL(0x7ffffffffffebfff),
    ULL(0xbf5feff7fbfcbeff),
    ULL(0xbffffffffffebfff),
    ULL(0xdfaf77fbfdfebfff),
    ULL(0xdffffffffffebfff),
    ULL(0xefd7bb7dfefebfff),
    ULL(0xeffffffffffebfff),
    ULL(0xf7ebddbe7ffebfff),
    ULL(0xf7fffffffffebfff),
    ULL(0xfbf5eedfbf7ebfff),
    ULL(0xfbfffffffffebfff),
    ULL(0xfdfaf7efdfbe3fff),
    ULL(0xfdfffffffffebfff),
    ULL(0xfefdfbf7efdebfff),
    ULL(0xfefffffffffebfff),
    ULL(0xbf7fbfdfeff6bbfd),
    ULL(0xff7ffffffffebfff),
    ULL(0x5fbf5feff7fabdfe),
    ULL(0xffbffffffffebfff),
    ULL(0xafdfaf77fbfcbeff),
    ULL(0xffdffffffffebfff),
    ULL(0xd7efd7bb7dfebfff),
    ULL(0xffeffffffffebfff),
    ULL(0xebf7ebddbe7ebfff),
    ULL(0xfff7fffffffebfff),
    ULL(0xf5fbf5eedfbe3fff),
    ULL(0xfffbfffffffebfff),
    ULL(0xfafdfaf7efdebfff),
    ULL(0xfffdfffffffebfff),
    ULL(0xfdfefdfbf7ee9fbf),
    ULL(0xfffefffffffebfff),
    ULL(0xdfbf7fbfdfeeb7fb),
    ULL(0xffff7ffffffebfff),
    ULL(0xef5fbf5feff6bbfd),
    ULL(0xffffbffffffebfff),
    ULL(0x77afdfaf77fabdfe),
    ULL(0xffffdffffffebfff),
    ULL(0xbbd7efd7bb7cbeff),
    ULL(0xffffeffffffebfff),
    ULL(0xddebf7ebddbe3fff),
    ULL(0xfffff7fffffebfff),
    ULL(0xeef5fbf5eedebfff),
    ULL(0xfffffbfffffebfff),
    ULL(0xf7fafdfaf7ee9fbf),
    ULL(0xfffffdfffffebfff),
    ULL(0xfbfdfefdfbf6afdf),
    ULL(0xfffffefffffebfff),
    ULL(0xefdfbf7fbfdeaff7),
    ULL(0xffffff7ffffebfff),
    ULL(0xf7ef5fbf5feeb7fb),
    ULL(0xffffffbffffebfff),
    ULL(0xfb77afdfaf76bbfd),
    ULL(0xffffffdffffebfff),
    ULL(0x7dbbd7efd7ba3dfe),
    ULL(0xffffffeffffebfff),
    ULL(0xbeddebf7ebdcbeff),
    ULL(0xfffffff7fffebfff),
    ULL(0xdfeef5fbf5ee9fbf),
    ULL(0xfffffffbfffebeff),
    ULL(0xeff7fafdfaf6afdf),
    ULL(0xfffffffdfffebeff),
    ULL(0xf7fbfdfefdfab7ef),
    ULL(0xfffffffefffebeff),
    ULL(0xf7efdfbf7fbe9fef),
    ULL(0xffffffff7ffebfff),
    ULL(0xfbf7ef5fbf5eaff7),
    ULL(0xffffffffbffebfff),
    ULL(0xfdfb77afdfae37fb),
    ULL(0xffffffffdffebfff),
    ULL(0xfe7dbbd7efd6bbfd),
    ULL(0xffffffffeffebfff),
    ULL(0x7fbeddebf7ea9dbe),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfeef5fbf4aedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7fafdfab6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcbaf7),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffe7dbbd7ee97bb),
    ULL(0xffffffffffeebeff),
    ULL(0xff7fbeddebf6abdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffebfff),
    ULL(0xfffffffffffebfff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffe7dbbd6afd7),
    ULL(0xfffffffffffeaeff),
    ULL(0xffff7fbeddeab6eb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffe7dba97ef),
    ULL(0xfffffffffffebeef),
    ULL(0xffffff7fbedcabf7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7fbfdeecb473),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7faddfe),
    ULL(0x7ffffffffffedfff),
    ULL(0xbf5feff7fbfcdeff),
    ULL(0xbffffffffffedfff),
    ULL(0xdfaf77fbfdfedfff),
    ULL(0xdffffffffffedfff),
    ULL(0xefd7bb7dfefedfff),
    ULL(0xeffffffffffedfff),
    ULL(0xf7ebddbe7ffedfff),
    ULL(0xf7fffffffffedfff),
    ULL(0xfbf5eedfbf7edfff),
    ULL(0xfbfffffffffedfff),
    ULL(0xfdfaf7efdfbe5fff),
    ULL(0xfdfffffffffedfff),
    ULL(0xfefdfbf7efde9f7f),
    ULL(0xfefffffffffedfff),
    ULL(0xbf7fbfdfeff6dbfd),
    ULL(0xff7ffffffffedfff),
    ULL(0x5fbf5feff7faddfe),
    ULL(0xffbffffffffedfff),
    ULL(0xafdfaf77fbfcdeff),
    ULL(0xffdffffffffedfff),
    ULL(0xd7efd7bb7dfedfff),
    ULL(0xffeffffffffedfff),
    ULL(0xebf7ebddbe7edfff),
    ULL(0xfff7fffffffedfff),
    ULL(0xf5fbf5eedfbe5fff),
    ULL(0xfffbfffffffedfff),
    ULL(0xfafdfaf7efde9f7f),
    ULL(0xfffdfffffffedfff),
    ULL(0xfdfefdfbf7eedfff),
    ULL(0xfffefffffffedfff),
    ULL(0xdfbf7fbfdfeed7fb),
    ULL(0xffff7ffffffedfff),
    ULL(0xef5fbf5feff6dbfd),
    ULL(0xffffbffffffedfff),
    ULL(0x77afdfaf77faddfe),
    ULL(0xffffdffffffedfff),
    ULL(0xbbd7efd7bb7cdeff),
    ULL(0xffffeffffffedfff),
    ULL(0xddebf7ebddbe5fff),
    ULL(0xfffff7fffffedfff),
    ULL(0xeef5fbf5eede9f7f),
    ULL(0xfffffbfffffedfff),
    ULL(0xf7fafdfaf7eedfff),
    ULL(0xfffffdfffffedfff),
    ULL(0xfbfdfefdfbf6cfdf),
    ULL(0xfffffefffffedfff),
    ULL(0xefdfbf7fbfdecff7),
    ULL(0xffffff7ffffedfff),
    ULL(0xf7ef5fbf5feed7fb),
    ULL(0xffffffbffffedfff),
    ULL(0xfb77afdfaf76dbfd),
    ULL(0xffffffdffffedfff),
    ULL(0x7dbbd7efd7ba5dfe),
    ULL(0xffffffeffffedfff),
    ULL(0xbeddebf7ebdc9e7f),
    ULL(0xfffffff7fffedfff),
    ULL(0xdfeef5fbf5eedfff),
    ULL(0xfffffffbfffedeff),
    ULL(0xeff7fafdfaf6cfdf),
    ULL(0xfffffffdfffedeff),
    ULL(0xf7fbfdfefdfad7ef),
    ULL(0xfffffffefffedeff),
    ULL(0xf7efdfbf7fbedfff),
    ULL(0xffffffff7ffedfff),
    ULL(0xfbf7ef5fbf5ecff7),
    ULL(0xffffffffbffedfff),
    ULL(0xfdfb77afdfae57fb),
    ULL(0xffffffffdffedfff),
    ULL(0xfe7dbbd7efd69b7d),
    ULL(0xffffffffeffedfff),
    ULL(0x7fbeddebf7eaddfe),
    ULL(0xba5daed7e3729e5d),
    ULL(0xbfdfeef5fbf4cedf),
    ULL(0xaa55aa55ab508e1d),
    ULL(0xdfeff7fafdfad6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcdaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7e9fdf),
    ULL(0xffffffffff7edfff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xff7fbeddebf6cbdd),
    ULL(0xaa55aa55ab528a5d),
    ULL(0x3a1d8ec6e172944c),
    ULL(0xaa55aa55ab508a1d),
    ULL(0xaa55aa55aa548a15),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffedfff),
    ULL(0xfffffffffffedfff),
    ULL(0xfdfbf7efdfbe5fbf),
    ULL(0xfffffffffffe1fff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xffff7fbeddead6eb),
    ULL(0xaa55aa55aa508251),
    ULL(0xaa55aa55aa548a55),
    ULL(0xaa55aa55aa508a11),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa548a15),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efde9f7f),
    ULL(0xfdfbf7efdfbedf3f),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xffffff7fbedccbf7),
    ULL(0xaad5ea75ba5c8a53),
    ULL(0xffff7fbfdeecd5f3),
    ULL(0xaad5ea75ba5c8a51),
    ULL(0xaa55aa55aa548a55),
    ULL(0xaa55aa55aa548a10),
    ULL(0x2a158a45a2508854),
    ULL(0xaa55aa55aa548a14),
    ULL(0x7fbfdfeff7faedfe),
    ULL(0x7ffffffffffeefff),
    ULL(0xbf5feff7fbfceeff),
    ULL(0xbffffffffffeefff),
    ULL(0xdfaf77fbfdfeefff),
    ULL(0xdffffffffffeefff),
    ULL(0xefd7bb7dfefeefff),
    ULL(0xeffffffffffeefff),
    ULL(0xf7ebddbe7ffeefff),
    ULL(0xf7fffffffffeefff),
    ULL(0xfbf5eedfbf7eefff),
    ULL(0xfbfffffffffeefff),
    ULL(0xfdfaf7efdfbe6fff),
    ULL(0xfdfffffffffeefff),
    ULL(0xfefdfbf7efdeaf7f),
    ULL(0xfefffffffffeefff),
    ULL(0xbf7fbfdfeff6ebfd),
    ULL(0xff7ffffffffeefff),
    ULL(0x5fbf5feff7faedfe),
    ULL(0xffbffffffffeefff),
    ULL(0xafdfaf77fbfceeff),
    ULL(0xffdffffffffeefff),
    ULL(0xd7efd7bb7dfeefff),
    ULL(0xffeffffffffeefff),
    ULL(0xebf7ebddbe7eefff),
    ULL(0xfff7fffffffeefff),
    ULL(0xf5fbf5eedfbe6fff),
    ULL(0xfffbfffffffeefff),
    ULL(0xfafdfaf7efdeaf7f),
    ULL(0xfffdfffffffeefff),
    ULL(0xfdfefdfbf7eecfbf),
    ULL(0xfffefffffffeefff),
    ULL(0xdfbf7fbfdfeee7fb),
    ULL(0xffff7ffffffeefff),
    ULL(0xef5fbf5feff6ebfd),
    ULL(0xffffbffffffeefff),
    ULL(0x77afdfaf77faedfe),
    ULL(0xffffdffffffeefff),
    ULL(0xbbd7efd7bb7ceeff),
    ULL(0xffffeffffffeefff),
    ULL(0xddebf7ebddbe6fff),
    ULL(0xfffff7fffffeefff),
    ULL(0xeef5fbf5eedeaf7f),
    ULL(0xfffffbfffffeefff),
    ULL(0xf7fafdfaf7eecfbf),
    ULL(0xfffffdfffffeefff),
    ULL(0xfbfdfefdfbf6efff),
    ULL(0xfffffefffffeefff),
    ULL(0xefdfbf7fbfdeefff),
    ULL(0xffffff7ffffeefff),
    ULL(0xf7ef5fbf5feee7fb),
    ULL(0xffffffbffffeefff),
    ULL(0xfb77afdfaf76ebfd),
    ULL(0xffffffdffffeefff),
    ULL(0x7dbbd7efd7ba6dfe),
    ULL(0xffffffeffffeefff),
    ULL(0xbeddebf7ebdcae7f),
    ULL(0xfffffff7fffeefff),
    ULL(0xdfeef5fbf5eecfbf),
    ULL(0xfffffffbfffeeeff),
    ULL(0xeff7fafdfaf6efff),
    ULL(0xfffffffdfffeeeff),
    ULL(0xf7fbfdfefdfae7ef),
    ULL(0xfffffffefffeeeff),
    ULL(0xf7efdfbf7fbecfef),
    ULL(0xffffffff7ffeefff),
    ULL(0xfbf7ef5fbf5eefff),
    ULL(0xffffffffbffeefff),
    ULL(0xfdfb77afdfae67fb),
    ULL(0xffffffffdffeefff),
    ULL(0xfe7dbbd7efd6ab7d),
    ULL(0xffffffffeffeefff),
    ULL(0x7fbeddebf7eacdbe),
    ULL(0xfa7dbe5fa752ae5d),
    ULL(0xbfdfeef5fbf4eeff),
    ULL(0xea75ba5dab50ae5d),
    ULL(0xdfeff7fafdfae6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefceaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7eafdf),
    ULL(0xffffffffff7eefff),
    ULL(0xfdfbf7ef5fbe4fef),
    ULL(0xffffffffffbeefff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7a3d9e4ea552a44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffeefff),
    ULL(0xfffffffffffeefff),
    ULL(0xfdfbf7efdfbe6fbf),
    ULL(0xfffffffffffe6fff),
    ULL(0xfefdfbf7ef5eaf5f),
    ULL(0xfffffffffffeafff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdeaf7f),
    ULL(0xfffffffffffeef7f),
    ULL(0xfffefdfbf7ee4fbf),
    ULL(0xfffffffffffeefbf),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaad56a359a4ca151),
    ULL(0xaa55aa55aa54aa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7faf5fe),
    ULL(0x7ffffffffffef7ff),
    ULL(0xbf5feff7fbfcf6ff),
    ULL(0xbffffffffffef7ff),
    ULL(0xdfaf77fbfdfef7ff),
    ULL(0xdffffffffffef7ff),
    ULL(0xefd7bb7dfefef7ff),
    ULL(0xeffffffffffef7ff),
    ULL(0xf7ebddbe7ffef7ff),
    ULL(0xf7fffffffffef7ff),
    ULL(0xfbf5eedfbf7ef7ff),
    ULL(0xfbfffffffffef7ff),
    ULL(0xfdfaf7efdfbe77ff),
    ULL(0xfdfffffffffef7ff),
    ULL(0xfefdfbf7efdeb77f),
    ULL(0xfefffffffffef7ff),
    ULL(0xbf7fbfdfeff6f3fd),
    ULL(0xff7ffffffffef7ff),
    ULL(0x5fbf5feff7faf5fe),
    ULL(0xffbffffffffef7ff),
    ULL(0xafdfaf77fbfcf6ff),
    ULL(0xffdffffffffef7ff),
    ULL(0xd7efd7bb7dfef7ff),
    ULL(0xffeffffffffef7ff),
    ULL(0xebf7ebddbe7ef7ff),
    ULL(0xfff7fffffffef7ff),
    ULL(0xf5fbf5eedfbe77ff),
    ULL(0xfffbfffffffef7ff),
    ULL(0xfafdfaf7efdeb77f),
    ULL(0xfffdfffffffef7ff),
    ULL(0xfdfefdfbf7eed7bf),
    ULL(0xfffefffffffef7ff),
    ULL(0xdfbf7fbfdfeef7ff),
    ULL(0xffff7ffffffef7ff),
    ULL(0xef5fbf5feff6f3fd),
    ULL(0xffffbffffffef7ff),
    ULL(0x77afdfaf77faf5fe),
    ULL(0xffffdffffffef7ff),
    ULL(0xbbd7efd7bb7cf6ff),
    ULL(0xffffeffffffef7ff),
    ULL(0xddebf7ebddbe77ff),
    ULL(0xfffff7fffffef7ff),
    ULL(0xeef5fbf5eedeb77f),
    ULL(0xfffffbfffffef7ff),
    ULL(0xf7fafdfaf7eed7bf),
    ULL(0xfffffdfffffef7ff),
    ULL(0xfbfdfefdfbf6e7df),
    ULL(0xfffffefffffef7ff),
    ULL(0xefdfbf7fbfdee7f7),
    ULL(0xffffff7ffffef7ff),
    ULL(0xf7ef5fbf5feef7ff),
    ULL(0xffffffbffffef7ff),
    ULL(0xfb77afdfaf76f3fd),
    ULL(0xffffffdffffef7ff),
    ULL(0x7dbbd7efd7ba75fe),
    ULL(0xffffffeffffef7ff),
    ULL(0xbeddebf7ebdcb67f),
    ULL(0xfffffff7fffef7ff),
    ULL(0xdfeef5fbf5eed7bf),
    ULL(0xfffffffbfffef6ff),
    ULL(0xeff7fafdfaf6e7df),
    ULL(0xfffffffdfffef6ff),
    ULL(0xf7fbfdfefdfaf7ff),
    ULL(0xfffffffefffef6ff),
    ULL(0xf7efdfbf7fbed7ef),
    ULL(0xffffffff7ffef7ff),
    ULL(0xfbf7ef5fbf5ee7f7),
    ULL(0xffffffffbffef7ff),
    ULL(0xfdfb77afdfae77ff),
    ULL(0xffffffffdffef7ff),
    ULL(0xfe7dbbd7efd6b37d),
    ULL(0xffffffffeffef7ff),
    ULL(0x7fbeddebf7ead5be),
    ULL(0xfffffffff7fef7ff),
    ULL(0xbfdfeef5fbf4e6df),
    ULL(0xea75ba5dab54a64d),
    ULL(0xdfeff7fafdfaf6ff),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcf2f7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7eb7df),
    ULL(0xffffffffff7ef7ff),
    ULL(0xfdfbf7ef5fbe57ef),
    ULL(0xffffffffffbef7ff),
    ULL(0xfefdfb77afdea777),
    ULL(0xffffffffffdef7ff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54a245),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffef7ff),
    ULL(0xfffffffffffef7ff),
    ULL(0xfdfbf7efdfbe77bf),
    ULL(0xfffffffffffe77ff),
    ULL(0xfefdfbf7ef5eb75f),
    ULL(0xfffffffffffeb7ff),
    ULL(0xfffefdfb77aed7af),
    ULL(0xfffffffffffed7ff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2010080402000004),
    ULL(0xaa55aa55aa54a245),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdeb77f),
    ULL(0xfffffffffffef77f),
    ULL(0xfffefdfbf7ee57bf),
    ULL(0xfffffffffffef7bf),
    ULL(0xfffffefdfb76a7df),
    ULL(0xfffffffffffef7df),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54a255),
    ULL(0xaa55aa55aa54a244),
    ULL(0x2a158a45a250a054),
    ULL(0xaa55aa55aa54a244),
    ULL(0x7fbfdfeff7faf9fe),
    ULL(0x7ffffffffffefbff),
    ULL(0xbf5feff7fbfcfaff),
    ULL(0xbffffffffffefbff),
    ULL(0xdfaf77fbfdfefbff),
    ULL(0xdffffffffffefbff),
    ULL(0xefd7bb7dfefefbff),
    ULL(0xeffffffffffefbff),
    ULL(0xf7ebddbe7ffefbff),
    ULL(0xf7fffffffffefbff),
    ULL(0xfbf5eedfbf7efbff),
    ULL(0xfbfffffffffefbff),
    ULL(0xfdfaf7efdfbe7bff),
    ULL(0xfdfffffffffefbff),
    ULL(0xfefdfbf7efdebb7f),
    ULL(0xfefffffffffefbff),
    ULL(0xbf7fbfdfeff6fbff),
    ULL(0xff7ffffffffefbff),
    ULL(0x5fbf5feff7faf9fe),
    ULL(0xffbffffffffefbff),
    ULL(0xafdfaf77fbfcfaff),
    ULL(0xffdffffffffefbff),
    ULL(0xd7efd7bb7dfefbff),
    ULL(0xffeffffffffefbff),
    ULL(0xebf7ebddbe7efbff),
    ULL(0xfff7fffffffefbff),
    ULL(0xf5fbf5eedfbe7bff),
    ULL(0xfffbfffffffefbff),
    ULL(0xfafdfaf7efdebb7f),
    ULL(0xfffdfffffffefbff),
    ULL(0xfdfefdfbf7eedbbf),
    ULL(0xfffefffffffefbff),
    ULL(0xdfbf7fbfdfeef3fb),
    ULL(0xffff7ffffffefbff),
    ULL(0xef5fbf5feff6fbff),
    ULL(0xffffbffffffefbff),
    ULL(0x77afdfaf77faf9fe),
    ULL(0xffffdffffffefbff),
    ULL(0xbbd7efd7bb7cfaff),
    ULL(0xffffeffffffefbff),
    ULL(0xddebf7ebddbe7bff),
    ULL(0xfffff7fffffefbff),
    ULL(0xeef5fbf5eedebb7f),
    ULL(0xfffffbfffffefbff),
    ULL(0xf7fafdfaf7eedbbf),
    ULL(0xfffffdfffffefbff),
    ULL(0xfbfdfefdfbf6ebdf),
    ULL(0xfffffefffffefbff),
    ULL(0xefdfbf7fbfdeebf7),
    ULL(0xffffff7ffffefbff),
    ULL(0xf7ef5fbf5feef3fb),
    ULL(0xffffffbffffefbff),
    ULL(0xfb77afdfaf76fbff),
    ULL(0xffffffdffffefbff),
    ULL(0x7dbbd7efd7ba79fe),
    ULL(0xffffffeffffefbff),
    ULL(0xbeddebf7ebdcba7f),
    ULL(0xfffffff7fffefbff),
    ULL(0xdfeef5fbf5eedbbf),
    ULL(0xfffffffbfffefbff),
    ULL(0xeff7fafdfaf6ebdf),
    ULL(0xfffffffdfffefbff),
    ULL(0xf7fbfdfefdfaf3ef),
    ULL(0xfffffffefffefbff),
    ULL(0xf7efdfbf7fbedbef),
    ULL(0xffffffff7ffefbff),
    ULL(0xfbf7ef5fbf5eebf7),
    ULL(0xffffffffbffefbff),
    ULL(0xfdfb77afdfae73fb),
    ULL(0xffffffffdffefbff),
    ULL(0xfe7dbbd7efd6bb7f),
    ULL(0xffffffffeffefbff),
    ULL(0x7fbeddebf7ead9be),
    ULL(0xfffffffff7fefbff),
    ULL(0xbfdfeef5fbf4eadf),
    ULL(0xfffffffffbfefbff),
    ULL(0xdfeff7fafdfaf3ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfbff),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebbdf),
    ULL(0xffffffffff7efbff),
    ULL(0xfdfbf7ef5fbe5bef),
    ULL(0xffffffffffbefbff),
    ULL(0xfefdfb77afdeab77),
    ULL(0xffffffffffdefbff),
    ULL(0xfffe7dbbd7eed3bb),
    ULL(0xffffffffffeefbff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffffefbff),
    ULL(0xfffffffffffefbff),
    ULL(0xfdfbf7efdfbe7bbf),
    ULL(0xfffffffffffe7bff),
    ULL(0xfefdfbf7ef5ebb5f),
    ULL(0xfffffffffffebbff),
    ULL(0xfffefdfb77aedbaf),
    ULL(0xfffffffffffedbff),
    ULL(0xfffffe7dbbd6ebd7),
    ULL(0xfffffffffffeebff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2a55aa55aa54aa54),
    ULL(0x2010080402000004),
    ULL(0xfefdfbf7efdebb7f),
    ULL(0xfffffffffffefb7f),
    ULL(0xfffefdfbf7ee5bbf),
    ULL(0xfffffffffffefbbf),
    ULL(0xfffffefdfb76abdf),
    ULL(0xfffffffffffefbdf),
    ULL(0xfffffffe7dbad3ef),
    ULL(0xfffffffffffefbef),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2a158a45a250a854),
    ULL(0x2a55aa55aa54aa54),
    ULL(0x7fbfdfeff7fafdff),
    ULL(0x7ffffffffffefdff),
    ULL(0xbf5feff7fbfcfcff),
    ULL(0xbffffffffffefdff),
    ULL(0xdfaf77fbfdfefdff),
    ULL(0xdffffffffffefdff),
    ULL(0xefd7bb7dfefefdff),
    ULL(0xeffffffffffefdff),
    ULL(0xf7ebddbe7ffefdff),
    ULL(0xf7fffffffffefdff),
    ULL(0xfbf5eedfbf7efdff),
    ULL(0xfbfffffffffefdff),
    ULL(0xfdfaf7efdfbe7dff),
    ULL(0xfdfffffffffefdff),
    ULL(0xfefdfbf7efdebd7f),
    ULL(0xfefffffffffefdff),
    ULL(0xbf7fbfdfeff6f9fd),
    ULL(0xff7ffffffffefdff),
    ULL(0x5fbf5feff7fafdff),
    ULL(0xffbffffffffefdff),
    ULL(0xafdfaf77fbfcfcff),
    ULL(0xffdffffffffefdff),
    ULL(0xd7efd7bb7dfefdff),
    ULL(0xffeffffffffefdff),
    ULL(0xebf7ebddbe7efdff),
    ULL(0xfff7fffffffefdff),
    ULL(0xf5fbf5eedfbe7dff),
    ULL(0xfffbfffffffefdff),
    ULL(0xfafdfaf7efdebd7f),
    ULL(0xfffdfffffffefdff),
    ULL(0xfdfefdfbf7eeddbf),
    ULL(0xfffefffffffefdff),
    ULL(0xdfbf7fbfdfeef5fb),
    ULL(0xffff7ffffffefdff),
    ULL(0xef5fbf5feff6f9fd),
    ULL(0xffffbffffffefdff),
    ULL(0x77afdfaf77fafdff),
    ULL(0xffffdffffffefdff),
    ULL(0xbbd7efd7bb7cfcff),
    ULL(0xffffeffffffefdff),
    ULL(0xddebf7ebddbe7dff),
    ULL(0xfffff7fffffefdff),
    ULL(0xeef5fbf5eedebd7f),
    ULL(0xfffffbfffffefdff),
    ULL(0xf7fafdfaf7eeddbf),
    ULL(0xfffffdfffffefdff),
    ULL(0xfbfdfefdfbf6eddf),
    ULL(0xfffffefffffefdff),
    ULL(0xefdfbf7fbfdeedf7),
    ULL(0xffffff7ffffefdff),
    ULL(0xf7ef5fbf5feef5fb),
    ULL(0xffffffbffffefdff),
    ULL(0xfb77afdfaf76f9fd),
    ULL(0xffffffdffffefdff),
    ULL(0x7dbbd7efd7ba7dff),
    ULL(0xffffffeffffefdff),
    ULL(0xbeddebf7ebdcbc7f),
    ULL(0xfffffff7fffefdff),
    ULL(0xdfeef5fbf5eeddbf),
    ULL(0xfffffffbfffefdff),
    ULL(0xeff7fafdfaf6eddf),
    ULL(0xfffffffdfffefdff),
    ULL(0xf7fbfdfefdfaf5ef),
    ULL(0xfffffffefffefdff),
    ULL(0xf7efdfbf7fbeddef),
    ULL(0xffffffff7ffefdff),
    ULL(0xfbf7ef5fbf5eedf7),
    ULL(0xffffffffbffefdff),
    ULL(0xfdfb77afdfae75fb),
    ULL(0xffffffffdffefdff),
    ULL(0xfe7dbbd7efd6b97d),
    ULL(0xffffffffeffefdff),
    ULL(0x7fbeddebf7eaddbf),
    ULL(0xfffffffff7fefdff),
    ULL(0xbfdfeef5fbf4ecdf),
    ULL(0xfffffffffbfefdff),
    ULL(0xdfeff7fafdfaf5ef),
    ULL(0xfffffffffdfefdff),
    ULL(0xeff7fbfdfefcf9f7),
    ULL(0xfffffffffefefdff),
    ULL(0xfbf7efdfbf7ebddf),
    ULL(0xffffffffff7efdff),
    ULL(0xfdfbf7ef5fbe5def),
    ULL(0xffffffffffbefdff),
    ULL(0xfefdfb77afdead77),
    ULL(0xffffffffffdefdff),
    ULL(0xfffe7dbbd7eed5bb),
    ULL(0xffffffffffeefdff),
    ULL(0xff7fbeddebf6e9dd),
    ULL(0xfffffffffff6fdff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffffefdff),
    ULL(0xfffffffffffefdff),
    ULL(0xfdfbf7efdfbe7dbf),
    ULL(0xfffffffffffe7dff),
    ULL(0xfefdfbf7ef5ebd5f),
    ULL(0xfffffffffffebdff),
    ULL(0xfffefdfb77aeddaf),
    ULL(0xfffffffffffeddff),
    ULL(0xfffffe7dbbd6edd7),
    ULL(0xfffffffffffeedff),
    ULL(0xffff7fbeddeaf5eb),
    ULL(0xfffffffffffef5ff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfbf7efdebd7f),
    ULL(0xfffffffffffefd7f),
    ULL(0xfffefdfbf7ee5dbf),
    ULL(0xfffffffffffefdbf),
    ULL(0xfffffefdfb76addf),
    ULL(0xfffffffffffefddf),
    ULL(0xfffffffe7dbad5ef),
    ULL(0xfffffffffffefdef),
    ULL(0xffffff7fbedce9f7),
    ULL(0xfffffffffffefdf7),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbfdfeff7fafcfe),
    ULL(0x7ffffffffffefeff),
    ULL(0xbf5feff7fbfcfeff),
    ULL(0xbffffffffffefeff),
    ULL(0xdfaf77fbfdfefeff),
    ULL(0xdffffffffffefeff),
    ULL(0xefd7bb7dfefefeff),
    ULL(0xeffffffffffefeff),
    ULL(0xf7ebddbe7ffefeff),
    ULL(0xf7fffffffffefeff),
    ULL(0xfbf5eedfbf7efeff),
    ULL(0xfbfffffffffefeff),
    ULL(0xfdfaf7efdfbe7eff),
    ULL(0xfdfffffffffefeff),
    ULL(0xfefdfbf7efdebe7f),
    ULL(0xfefffffffffefeff),
    ULL(0xbf7fbfdfeff6fafd),
    ULL(0xff7ffffffffefeff),
    ULL(0x5fbf5feff7fafcfe),
    ULL(0xffbffffffffefeff),
    ULL(0xafdfaf77fbfcfeff),
    ULL(0xffdffffffffefeff),
    ULL(0xd7efd7bb7dfefeff),
    ULL(0xffeffffffffefeff),
    ULL(0xebf7ebddbe7efeff),
    ULL(0xfff7fffffffefeff),
    ULL(0xf5fbf5eedfbe7eff),
    ULL(0xfffbfffffffefeff),
    ULL(0xfafdfaf7efdebe7f),
    ULL(0xfffdfffffffefeff),
    ULL(0xfdfefdfbf7eedebf),
    ULL(0xfffefffffffefeff),
    ULL(0xdfbf7fbfdfeef6fb),
    ULL(0xffff7ffffffefeff),
    ULL(0xef5fbf5feff6fafd),
    ULL(0xffffbffffffefeff),
    ULL(0x77afdfaf77fafcfe),
    ULL(0xffffdffffffefeff),
    ULL(0xbbd7efd7bb7cfeff),
    ULL(0xffffeffffffefeff),
    ULL(0xddebf7ebddbe7eff),
    ULL(0xfffff7fffffefeff),
    ULL(0xeef5fbf5eedebe7f),
    ULL(0xfffffbfffffefeff),
    ULL(0xf7fafdfaf7eedebf),
    ULL(0xfffffdfffffefeff),
    ULL(0xfbfdfefdfbf6eedf),
    ULL(0xfffffefffffefeff),
    ULL(0xefdfbf7fbfdeeef7),
    ULL(0xffffff7ffffefeff),
    ULL(0xf7ef5fbf5feef6fb),
    ULL(0xffffffbffffefeff),
    ULL(0xfb77afdfaf76fafd),
    ULL(0xffffffdffffefeff),
    ULL(0x7dbbd7efd7ba7cfe),
    ULL(0xffffffeffffefeff),
    ULL(0xbeddebf7ebdcbe7f),
    ULL(0xfffffff7fffefeff),
    ULL(0xdfeef5fbf5eedebf),
    ULL(0xfffffffbfffefeff),
    ULL(0xeff7fafdfaf6eedf),
    ULL(0xfffffffdfffefeff),
    ULL(0xf7fbfdfefdfaf6ef),
    ULL(0xfffffffefffefeff),
    ULL(0xf7efdfbf7fbedeef),
    ULL(0xffffffff7ffefeff),
    ULL(0xfbf7ef5fbf5eeef7),
    ULL(0xffffffffbffefeff),
    ULL(0xfdfb77afdfae76fb),
    ULL(0xffffffffdffefeff),
    ULL(0xfe7dbbd7efd6ba7d),
    ULL(0xffffffffeffefeff),
    ULL(0x7fbeddebf7eadcbe),
    ULL(0xfffffffff7fefeff),
    ULL(0xbfdfeef5fbf4eedf),
    ULL(0xfffffffffbfefeff),
    ULL(0xdfeff7fafdfaf6ef),
    ULL(0xfffffffffdfefeff),
    ULL(0xeff7fbfdfefcfaf7),
    ULL(0xfffffffffefefeff),
    ULL(0xfbf7efdfbf7ebedf),
    ULL(0xffffffffff7efeff),
    ULL(0xfdfbf7ef5fbe5eef),
    ULL(0xffffffffffbefeff),
    ULL(0xfefdfb77afdeae77),
    ULL(0xffffffffffdefeff),
    ULL(0xfffe7dbbd7eed6bb),
    ULL(0xffffffffffeefeff),
    ULL(0xff7fbeddebf6eadd),
    ULL(0xfffffffffff6faff),
    ULL(0x7fbfdfeef5faf4ee),
    ULL(0xfffffffffffafaff),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffffffefeff),
    ULL(0xfffffffffffefeff),
    ULL(0xfdfbf7efdfbe7ebf),
    ULL(0xfffffffffffe7eff),
    ULL(0xfefdfbf7ef5ebe5f),
    ULL(0xfffffffffffebeff),
    ULL(0xfffefdfb77aedeaf),
    ULL(0xfffffffffffedeff),
    ULL(0xfffffe7dbbd6eed7),
    ULL(0xfffffffffffeeeff),
    ULL(0xffff7fbeddeaf6eb),
    ULL(0xfffffffffffef2fb),
    ULL(0xff7fbfdfeef4faf5),
    ULL(0xfffffffffffefafb),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfbf7efdebe7f),
    ULL(0xfffffffffffefe7f),
    ULL(0xfffefdfbf7ee5ebf),
    ULL(0xfffffffffffefebf),
    ULL(0xfffffefdfb76aedf),
    ULL(0xfffffffffffefedf),
    ULL(0xfffffffe7dbad6ef),
    ULL(0xfffffffffffefeef),
    ULL(0xffffff7fbedceaf7),
    ULL(0xfffffffffffefaf3),
    ULL(0xffff7fbfdfeef4fb),
    ULL(0xfffffffffffefafb),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbfdfeff7fafd7e),
    ULL(0x7ffffffffffeff7f),
    ULL(0xbf5feff7fbfcfe7f),
    ULL(0xbffffffffffeff7f),
    ULL(0xdfaf77fbfdfeff7f),
    ULL(0xdffffffffffeff7f),
    ULL(0xefd7bb7dfefeff7f),
    ULL(0xeffffffffffeff7f),
    ULL(0xf7ebddbe7ffeff7f),
    ULL(0xf7fffffffffeff7f),
    ULL(0xfbf5eedfbf7eff7f),
    ULL(0xfbfffffffffeff7f),
    ULL(0xfdfaf7efdfbe7f7f),
    ULL(0xfdfffffffffeff7f),
    ULL(0xfefdfbf7efdebf7f),
    ULL(0xfefffffffffeff7f),
    ULL(0xbf7fbfdfeff6fb7d),
    ULL(0xff7ffffffffeff7f),
    ULL(0x5fbf5feff7fafd7e),
    ULL(0xffbffffffffeff7f),
    ULL(0xafdfaf77fbfcfe7f),
    ULL(0xffdffffffffeff7f),
    ULL(0xd7efd7bb7dfeff7f),
    ULL(0xffeffffffffeff7f),
    ULL(0xebf7ebddbe7eff7f),
    ULL(0xfff7fffffffeff7f),
    ULL(0xf5fbf5eedfbe7f7f),
    ULL(0xfffbfffffffeff7f),
    ULL(0xfafdfaf7efdebf7f),
    ULL(0xfffdfffffffeff7f),
    ULL(0xfdfefdfbf7eedf3f),
    ULL(0xfffefffffffeff7f),
    ULL(0xdfbf7fbfdfeef77b),
    ULL(0xffff7ffffffeff7f),
    ULL(0xef5fbf5feff6fb7d),
    ULL(0xffffbffffffeff7f),
    ULL(0x77afdfaf77fafd7e),
    ULL(0xffffdffffffeff7f),
    ULL(0xbbd7efd7bb7cfe7f),
    ULL(0xffffeffffffeff7f),
    ULL(0xddebf7ebddbe7f7f),
    ULL(0xfffff7fffffeff7f),
    ULL(0xeef5fbf5eedebf7f),
    ULL(0xfffffbfffffeff7f),
    ULL(0xf7fafdfaf7eedf3f),
    ULL(0xfffffdfffffeff7f),
    ULL(0xfbfdfefdfbf6ef5f),
    ULL(0xfffffefffffeff7f),
    ULL(0xefdfbf7fbfdeef77),
    ULL(0xffffff7ffffeff7f),
    ULL(0xf7ef5fbf5feef77b),
    ULL(0xffffffbffffeff7f),
    ULL(0xfb77afdfaf76fb7d),
    ULL(0xffffffdffffeff7f),
    ULL(0x7dbbd7efd7ba7d7e),
    ULL(0xffffffeffffeff7f),
    ULL(0xbeddebf7ebdcbe7f),
    ULL(0xfffffff7fffeff7f),
    ULL(0xdfeef5fbf5eedf3f),
    ULL(0xfffffffbfffefe7f),
    ULL(0xeff7fafdfaf6ef5f),
    ULL(0xfffffffdfffefe7f),
    ULL(0xf7fbfdfefdfaf76f),
    ULL(0xfffffffefffefe7f),
    ULL(0xf7efdfbf7fbedf6f),
    ULL(0xffffffff7ffeff7f),
    ULL(0xfbf7ef5fbf5eef77),
    ULL(0xffffffffbffeff7f),
    ULL(0xfdfb77afdfae777b),
    ULL(0xffffffffdffeff7f),
    ULL(0xfe7dbbd7efd6bb7d),
    ULL(0xffffffffeffeff7f),
    ULL(0x7fbeddebf7eadd3e),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfeef5fbf4ee5f),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7fafdfaf66f),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfa77),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebf5f),
    ULL(0xffffffffff7eff7f),
    ULL(0xfdfbf7ef5fbe5f6f),
    ULL(0xffffffffffbeff7f),
    ULL(0xfefdfb77afdeaf77),
    ULL(0xffffffffffdeff7f),
    ULL(0xfffe7dbbd7eed73b),
    ULL(0xffffffffffeefe7f),
    ULL(0xff7fbeddebf6eb5d),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffeff7f),
    ULL(0xfffffffffffeff7f),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffefdfb77aedf2f),
    ULL(0xfffffffffffedf7f),
    ULL(0xfffffe7dbbd6ef57),
    ULL(0xfffffffffffeee7f),
    ULL(0xffff7fbeddeaf66b),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffefdfb76af5f),
    ULL(0xfffffffffffeff5f),
    ULL(0xfffffffe7dbad76f),
    ULL(0xfffffffffffefe6f),
    ULL(0xffffff7fbedceb77),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7fbfdeecf473),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7fafdbe),
    ULL(0x7ffffffffffeffbf),
    ULL(0xbf5feff7fbfcfebf),
    ULL(0xbffffffffffeffbf),
    ULL(0xdfaf77fbfdfeffbf),
    ULL(0xdffffffffffeffbf),
    ULL(0xefd7bb7dfefeffbf),
    ULL(0xeffffffffffeffbf),
    ULL(0xf7ebddbe7ffeffbf),
    ULL(0xf7fffffffffeffbf),
    ULL(0xfbf5eedfbf7effbf),
    ULL(0xfbfffffffffeffbf),
    ULL(0xfdfaf7efdfbe7fbf),
    ULL(0xfdfffffffffeffbf),
    ULL(0xfefdfbf7efdebf3f),
    ULL(0xfefffffffffeffbf),
    ULL(0xbf7fbfdfeff6fbbd),
    ULL(0xff7ffffffffeffbf),
    ULL(0x5fbf5feff7fafdbe),
    ULL(0xffbffffffffeffbf),
    ULL(0xafdfaf77fbfcfebf),
    ULL(0xffdffffffffeffbf),
    ULL(0xd7efd7bb7dfeffbf),
    ULL(0xffeffffffffeffbf),
    ULL(0xebf7ebddbe7effbf),
    ULL(0xfff7fffffffeffbf),
    ULL(0xf5fbf5eedfbe7fbf),
    ULL(0xfffbfffffffeffbf),
    ULL(0xfafdfaf7efdebf3f),
    ULL(0xfffdfffffffeffbf),
    ULL(0xfdfefdfbf7eedfbf),
    ULL(0xfffefffffffeffbf),
    ULL(0xdfbf7fbfdfeef7bb),
    ULL(0xffff7ffffffeffbf),
    ULL(0xef5fbf5feff6fbbd),
    ULL(0xffffbffffffeffbf),
    ULL(0x77afdfaf77fafdbe),
    ULL(0xffffdffffffeffbf),
    ULL(0xbbd7efd7bb7cfebf),
    ULL(0xffffeffffffeffbf),
    ULL(0xddebf7ebddbe7fbf),
    ULL(0xfffff7fffffeffbf),
    ULL(0xeef5fbf5eedebf3f),
    ULL(0xfffffbfffffeffbf),
    ULL(0xf7fafdfaf7eedfbf),
    ULL(0xfffffdfffffeffbf),
    ULL(0xfbfdfefdfbf6ef9f),
    ULL(0xfffffefffffeffbf),
    ULL(0xefdfbf7fbfdeefb7),
    ULL(0xffffff7ffffeffbf),
    ULL(0xf7ef5fbf5feef7bb),
    ULL(0xffffffbffffeffbf),
    ULL(0xfb77afdfaf76fbbd),
    ULL(0xffffffdffffeffbf),
    ULL(0x7dbbd7efd7ba7dbe),
    ULL(0xffffffeffffeffbf),
    ULL(0xbeddebf7ebdcbe3f),
    ULL(0xfffffff7fffeffbf),
    ULL(0xdfeef5fbf5eedfbf),
    ULL(0xfffffffbfffefebf),
    ULL(0xeff7fafdfaf6ef9f),
    ULL(0xfffffffdfffefebf),
    ULL(0xf7fbfdfefdfaf7af),
    ULL(0xfffffffefffefebf),
    ULL(0xf7efdfbf7fbedfaf),
    ULL(0xffffffff7ffeffbf),
    ULL(0xfbf7ef5fbf5eefb7),
    ULL(0xffffffffbffeffbf),
    ULL(0xfdfb77afdfae77bb),
    ULL(0xffffffffdffeffbf),
    ULL(0xfe7dbbd7efd6bb3d),
    ULL(0xffffffffeffeffbf),
    ULL(0x7fbeddebf7eaddbe),
    ULL(0xba5daed7e372be1d),
    ULL(0xbfdfeef5fbf4ee9f),
    ULL(0xaa55aa55ab50ae1d),
    ULL(0xdfeff7fafdfaf6af),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfab7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebf9f),
    ULL(0xffffffffff7effbf),
    ULL(0xfdfbf7ef5fbe5faf),
    ULL(0xffffffffffbeffbf),
    ULL(0xfefdfb77afdeaf37),
    ULL(0xffffffffffdeffbf),
    ULL(0xfffe7dbbd7eed7bb),
    ULL(0xffffffffffeefebf),
    ULL(0xff7fbeddebf6eb9d),
    ULL(0xaa55aa55ab52aa1d),
    ULL(0x3a1d8ec6e172b40c),
    ULL(0xaa55aa55ab50aa1d),
    ULL(0xaa55aa55aa54aa15),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffeffbf),
    ULL(0xfffffffffffeffbf),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffe7dbbd6ef97),
    ULL(0xfffffffffffeeebf),
    ULL(0xffff7fbeddeaf6ab),
    ULL(0xaa55aa55aa50a211),
    ULL(0xaa55aa55aa54aa15),
    ULL(0xaa55aa55aa50aa11),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa15),
    ULL(0x2010080402000204),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfffffffe7dbad7af),
    ULL(0xfffffffffffefeaf),
    ULL(0xffffff7fbedcebb7),
    ULL(0xaad5ea75ba5caa13),
    ULL(0xffff7fbfdeecf4b3),
    ULL(0xaad5ea75ba5caa11),
    ULL(0xaa55aa55aa54aa15),
    ULL(0xaa55aa55aa54aa10),
    ULL(0x2a158a45a250a814),
    ULL(0xaa55aa55aa54aa14),
    ULL(0x7fbfdfeff7fafdde),
    ULL(0x7ffffffffffeffdf),
    ULL(0xbf5feff7fbfcfedf),
    ULL(0xbffffffffffeffdf),
    ULL(0xdfaf77fbfdfeffdf),
    ULL(0xdffffffffffeffdf),
    ULL(0xefd7bb7dfefeffdf),
    ULL(0xeffffffffffeffdf),
    ULL(0xf7ebddbe7ffeffdf),
    ULL(0xf7fffffffffeffdf),
    ULL(0xfbf5eedfbf7effdf),
    ULL(0xfbfffffffffeffdf),
    ULL(0xfdfaf7efdfbe7fdf),
    ULL(0xfdfffffffffeffdf),
    ULL(0xfefdfbf7efdebf5f),
    ULL(0xfefffffffffeffdf),
    ULL(0xbf7fbfdfeff6fbdd),
    ULL(0xff7ffffffffeffdf),
    ULL(0x5fbf5feff7fafdde),
    ULL(0xffbffffffffeffdf),
    ULL(0xafdfaf77fbfcfedf),
    ULL(0xffdffffffffeffdf),
    ULL(0xd7efd7bb7dfeffdf),
    ULL(0xffeffffffffeffdf),
    ULL(0xebf7ebddbe7effdf),
    ULL(0xfff7fffffffeffdf),
    ULL(0xf5fbf5eedfbe7fdf),
    ULL(0xfffbfffffffeffdf),
    ULL(0xfafdfaf7efdebf5f),
    ULL(0xfffdfffffffeffdf),
    ULL(0xfdfefdfbf7eedf9f),
    ULL(0xfffefffffffeffdf),
    ULL(0xdfbf7fbfdfeef7db),
    ULL(0xffff7ffffffeffdf),
    ULL(0xef5fbf5feff6fbdd),
    ULL(0xffffbffffffeffdf),
    ULL(0x77afdfaf77fafdde),
    ULL(0xffffdffffffeffdf),
    ULL(0xbbd7efd7bb7cfedf),
    ULL(0xffffeffffffeffdf),
    ULL(0xddebf7ebddbe7fdf),
    ULL(0xfffff7fffffeffdf),
    ULL(0xeef5fbf5eedebf5f),
    ULL(0xfffffbfffffeffdf),
    ULL(0xf7fafdfaf7eedf9f),
    ULL(0xfffffdfffffeffdf),
    ULL(0xfbfdfefdfbf6efdf),
    ULL(0xfffffefffffeffdf),
    ULL(0xefdfbf7fbfdeefd7),
    ULL(0xffffff7ffffeffdf),
    ULL(0xf7ef5fbf5feef7db),
    ULL(0xffffffbffffeffdf),
    ULL(0xfb77afdfaf76fbdd),
    ULL(0xffffffdffffeffdf),
    ULL(0x7dbbd7efd7ba7dde),
    ULL(0xffffffeffffeffdf),
    ULL(0xbeddebf7ebdcbe5f),
    ULL(0xfffffff7fffeffdf),
    ULL(0xdfeef5fbf5eedf9f),
    ULL(0xfffffffbfffefedf),
    ULL(0xeff7fafdfaf6efdf),
    ULL(0xfffffffdfffefedf),
    ULL(0xf7fbfdfefdfaf7cf),
    ULL(0xfffffffefffefedf),
    ULL(0xf7efdfbf7fbedfcf),
    ULL(0xffffffff7ffeffdf),
    ULL(0xfbf7ef5fbf5eefd7),
    ULL(0xffffffffbffeffdf),
    ULL(0xfdfb77afdfae77db),
    ULL(0xffffffffdffeffdf),
    ULL(0xfe7dbbd7efd6bb5d),
    ULL(0xffffffffeffeffdf),
    ULL(0x7fbeddebf7eadd9e),
    ULL(0xba5daed7e372be5d),
    ULL(0xbfdfeef5fbf4eedf),
    ULL(0xaa55aa55ab50ae5d),
    ULL(0xdfeff7fafdfaf6cf),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfad7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebfdf),
    ULL(0xffffffffff7effdf),
    ULL(0xfdfbf7ef5fbe5fcf),
    ULL(0xffffffffffbeffdf),
    ULL(0xfefdfb77afdeaf57),
    ULL(0xffffffffffdeffdf),
    ULL(0xfffe7dbbd7eed79b),
    ULL(0xffffffffffeefedf),
    ULL(0xff7fbeddebf6ebdd),
    ULL(0xaa55aa55ab52aa5d),
    ULL(0x3a1d8ec6e172b44c),
    ULL(0xaa55aa55ab50aa5d),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffeffdf),
    ULL(0xfffffffffffeffdf),
    ULL(0xfdfbf7efdfbe7f9f),
    ULL(0xfffffffffffe7fdf),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xffff7fbeddeaf6cb),
    ULL(0xaa55aa55aa50a251),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa50aa51),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdebf5f),
    ULL(0xfdfbf7efdfbeff1f),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xffffff7fbedcebd7),
    ULL(0xaad5ea75ba5caa53),
    ULL(0xffff7fbfdeecf4d3),
    ULL(0xaad5ea75ba5caa51),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7fafdee),
    ULL(0x7ffffffffffeffef),
    ULL(0xbf5feff7fbfcfeef),
    ULL(0xbffffffffffeffef),
    ULL(0xdfaf77fbfdfeffef),
    ULL(0xdffffffffffeffef),
    ULL(0xefd7bb7dfefeffef),
    ULL(0xeffffffffffeffef),
    ULL(0xf7ebddbe7ffeffef),
    ULL(0xf7fffffffffeffef),
    ULL(0xfbf5eedfbf7effef),
    ULL(0xfbfffffffffeffef),
    ULL(0xfdfaf7efdfbe7fef),
    ULL(0xfdfffffffffeffef),
    ULL(0xfefdfbf7efdebf6f),
    ULL(0xfefffffffffeffef),
    ULL(0xbf7fbfdfeff6fbed),
    ULL(0xff7ffffffffeffef),
    ULL(0x5fbf5feff7fafdee),
    ULL(0xffbffffffffeffef),
    ULL(0xafdfaf77fbfcfeef),
    ULL(0xffdffffffffeffef),
    ULL(0xd7efd7bb7dfeffef),
    ULL(0xffeffffffffeffef),
    ULL(0xebf7ebddbe7effef),
    ULL(0xfff7fffffffeffef),
    ULL(0xf5fbf5eedfbe7fef),
    ULL(0xfffbfffffffeffef),
    ULL(0xfafdfaf7efdebf6f),
    ULL(0xfffdfffffffeffef),
    ULL(0xfdfefdfbf7eedfaf),
    ULL(0xfffefffffffeffef),
    ULL(0xdfbf7fbfdfeef7eb),
    ULL(0xffff7ffffffeffef),
    ULL(0xef5fbf5feff6fbed),
    ULL(0xffffbffffffeffef),
    ULL(0x77afdfaf77fafdee),
    ULL(0xffffdffffffeffef),
    ULL(0xbbd7efd7bb7cfeef),
    ULL(0xffffeffffffeffef),
    ULL(0xddebf7ebddbe7fef),
    ULL(0xfffff7fffffeffef),
    ULL(0xeef5fbf5eedebf6f),
    ULL(0xfffffbfffffeffef),
    ULL(0xf7fafdfaf7eedfaf),
    ULL(0xfffffdfffffeffef),
    ULL(0xfbfdfefdfbf6efcf),
    ULL(0xfffffefffffeffef),
    ULL(0xefdfbf7fbfdeefe7),
    ULL(0xffffff7ffffeffef),
    ULL(0xf7ef5fbf5feef7eb),
    ULL(0xffffffbffffeffef),
    ULL(0xfb77afdfaf76fbed),
    ULL(0xffffffdffffeffef),
    ULL(0x7dbbd7efd7ba7dee),
    ULL(0xffffffeffffeffef),
    ULL(0xbeddebf7ebdcbe6f),
    ULL(0xfffffff7fffeffef),
    ULL(0xdfeef5fbf5eedfaf),
    ULL(0xfffffffbfffefeef),
    ULL(0xeff7fafdfaf6efcf),
    ULL(0xfffffffdfffefeef),
    ULL(0xf7fbfdfefdfaf7ef),
    ULL(0xfffffffefffefeef),
    ULL(0xf7efdfbf7fbedfef),
    ULL(0xffffffff7ffeffef),
    ULL(0xfbf7ef5fbf5eefe7),
    ULL(0xffffffffbffeffef),
    ULL(0xfdfb77afdfae77eb),
    ULL(0xffffffffdffeffef),
    ULL(0xfe7dbbd7efd6bb6d),
    ULL(0xffffffffeffeffef),
    ULL(0x7fbeddebf7eaddae),
    ULL(0xfa7dbedfe772be4d),
    ULL(0xbfdfeef5fbf4eecf),
    ULL(0xea75ba5dab50ae4d),
    ULL(0xdfeff7fafdfaf6ef),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfae7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebfcf),
    ULL(0xffffffffff7effef),
    ULL(0xfdfbf7ef5fbe5fef),
    ULL(0xffffffffffbeffef),
    ULL(0xfefdfb77afdeaf67),
    ULL(0xffffffffffdeffef),
    ULL(0xfffe7dbbd7eed7ab),
    ULL(0xffffffffffeeffef),
    ULL(0xff7fbeddebf6ebcd),
    ULL(0xaa55aa55ab52aa4d),
    ULL(0x7a3d9ecee572b44c),
    ULL(0xaa55aa55ab50aa4d),
    ULL(0xaa55aa55aa54aa45),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffeffef),
    ULL(0xfffffffffffeffef),
    ULL(0xfdfbf7efdfbe7faf),
    ULL(0xfffffffffffe7fef),
    ULL(0xfefdfbf7ef5ebf4f),
    ULL(0xfffffffffffebfef),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54aa45),
    ULL(0xaa55aa55aa50aa41),
    ULL(0x0000000000000000),
    ULL(0x2010080402000000),
    ULL(0xaa55aa55aa54aa45),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdebf6f),
    ULL(0xfffffffffffeff6f),
    ULL(0xfffefdfbf7ee5faf),
    ULL(0xfffffffffffeffaf),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaad56a359a4ca041),
    ULL(0xaa55aa55aa54aa41),
    ULL(0xaa55aa55aa54aa45),
    ULL(0xaa55aa55aa54aa40),
    ULL(0x2a158a45a250a844),
    ULL(0xaa55aa55aa54aa44),
    ULL(0x7fbfdfeff7fafdf6),
    ULL(0x7ffffffffffefff7),
    ULL(0xbf5feff7fbfcfef7),
    ULL(0xbffffffffffefff7),
    ULL(0xdfaf77fbfdfefff7),
    ULL(0xdffffffffffefff7),
    ULL(0xefd7bb7dfefefff7),
    ULL(0xeffffffffffefff7),
    ULL(0xf7ebddbe7ffefff7),
    ULL(0xf7fffffffffefff7),
    ULL(0xfbf5eedfbf7efff7),
    ULL(0xfbfffffffffefff7),
    ULL(0xfdfaf7efdfbe7ff7),
    ULL(0xfdfffffffffefff7),
    ULL(0xfefdfbf7efdebf77),
    ULL(0xfefffffffffefff7),
    ULL(0xbf7fbfdfeff6fbf5),
    ULL(0xff7ffffffffefff7),
    ULL(0x5fbf5feff7fafdf6),
    ULL(0xffbffffffffefff7),
    ULL(0xafdfaf77fbfcfef7),
    ULL(0xffdffffffffefff7),
    ULL(0xd7efd7bb7dfefff7),
    ULL(0xffeffffffffefff7),
    ULL(0xebf7ebddbe7efff7),
    ULL(0xfff7fffffffefff7),
    ULL(0xf5fbf5eedfbe7ff7),
    ULL(0xfffbfffffffefff7),
    ULL(0xfafdfaf7efdebf77),
    ULL(0xfffdfffffffefff7),
    ULL(0xfdfefdfbf7eedfb7),
    ULL(0xfffefffffffefff7),
    ULL(0xdfbf7fbfdfeef7f3),
    ULL(0xffff7ffffffefff7),
    ULL(0xef5fbf5feff6fbf5),
    ULL(0xffffbffffffefff7),
    ULL(0x77afdfaf77fafdf6),
    ULL(0xffffdffffffefff7),
    ULL(0xbbd7efd7bb7cfef7),
    ULL(0xffffeffffffefff7),
    ULL(0xddebf7ebddbe7ff7),
    ULL(0xfffff7fffffefff7),
    ULL(0xeef5fbf5eedebf77),
    ULL(0xfffffbfffffefff7),
    ULL(0xf7fafdfaf7eedfb7),
    ULL(0xfffffdfffffefff7),
    ULL(0xfbfdfefdfbf6efd7),
    ULL(0xfffffefffffefff7),
    ULL(0xefdfbf7fbfdeeff7),
    ULL(0xffffff7ffffefff7),
    ULL(0xf7ef5fbf5feef7f3),
    ULL(0xffffffbffffefff7),
    ULL(0xfb77afdfaf76fbf5),
    ULL(0xffffffdffffefff7),
    ULL(0x7dbbd7efd7ba7df6),
    ULL(0xffffffeffffefff7),
    ULL(0xbeddebf7ebdcbe77),
    ULL(0xfffffff7fffefff7),
    ULL(0xdfeef5fbf5eedfb7),
    ULL(0xfffffffbfffefef7),
    ULL(0xeff7fafdfaf6efd7),
    ULL(0xfffffffdfffefef7),
    ULL(0xf7fbfdfefdfaf7e7),
    ULL(0xfffffffefffefef7),
    ULL(0xf7efdfbf7fbedfe7),
    ULL(0xffffffff7ffefff7),
    ULL(0xfbf7ef5fbf5eeff7),
    ULL(0xffffffffbffefff7),
    ULL(0xfdfb77afdfae77f3),
    ULL(0xffffffffdffefff7),
    ULL(0xfe7dbbd7efd6bb75),
    ULL(0xffffffffeffefff7),
    ULL(0x7fbeddebf7eaddb6),
    ULL(0xfffffffff7fafff7),
    ULL(0xbfdfeef5fbf4eed7),
    ULL(0xea75ba5dab50ae55),
    ULL(0xdfeff7fafdfaf6e7),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfaf7),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebfd7),
    ULL(0xffffffffff7efff7),
    ULL(0xfdfbf7ef5fbe5fe7),
    ULL(0xffffffffffbefff7),
    ULL(0xfefdfb77afdeaf77),
    ULL(0xffffffffffdefff7),
    ULL(0xfffe7dbbd7eed7b3),
    ULL(0xffffffffffeefff7),
    ULL(0xff7fbeddebf6ebd5),
    ULL(0xfffffffffff2fff7),
    ULL(0x7fbfdfeef5faf5e6),
    ULL(0xea75ba5daf50ae55),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffefff7),
    ULL(0xfffffffffffefff7),
    ULL(0xfdfbf7efdfbe7fb7),
    ULL(0xfffffffffffe7ff7),
    ULL(0xfefdfbf7ef5ebf57),
    ULL(0xfffffffffffebff7),
    ULL(0xfffefdfb77aedfa7),
    ULL(0xfffffffffffedff7),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2010080402000004),
    ULL(0xaa55aa55aa54aa55),
    ULL(0x2010080402000204),
    ULL(0xfefdfbf7efdebf77),
    ULL(0xfffffffffffeff77),
    ULL(0xfffefdfbf7ee5fb7),
    ULL(0xfffffffffffeffb7),
    ULL(0xfffffefdfb76afd7),
    ULL(0xfffffffffffeffd7),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54aa55),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x2a158a45a250a854),
    ULL(0xaa55aa55aa54aa54),
    ULL(0x7fbfdfeff7fafdfa),
    ULL(0x7ffffffffffefffb),
    ULL(0xbf5feff7fbfcfefb),
    ULL(0xbffffffffffefffb),
    ULL(0xdfaf77fbfdfefffb),
    ULL(0xdffffffffffefffb),
    ULL(0xefd7bb7dfefefffb),
    ULL(0xeffffffffffefffb),
    ULL(0xf7ebddbe7ffefffb),
    ULL(0xf7fffffffffefffb),
    ULL(0xfbf5eedfbf7efffb),
    ULL(0xfbfffffffffefffb),
    ULL(0xfdfaf7efdfbe7ffb),
    ULL(0xfdfffffffffefffb),
    ULL(0xfefdfbf7efdebf7b),
    ULL(0xfefffffffffefffb),
    ULL(0xbf7fbfdfeff6fbf9),
    ULL(0xff7ffffffffefffb),
    ULL(0x5fbf5feff7fafdfa),
    ULL(0xffbffffffffefffb),
    ULL(0xafdfaf77fbfcfefb),
    ULL(0xffdffffffffefffb),
    ULL(0xd7efd7bb7dfefffb),
    ULL(0xffeffffffffefffb),
    ULL(0xebf7ebddbe7efffb),
    ULL(0xfff7fffffffefffb),
    ULL(0xf5fbf5eedfbe7ffb),
    ULL(0xfffbfffffffefffb),
    ULL(0xfafdfaf7efdebf7b),
    ULL(0xfffdfffffffefffb),
    ULL(0xfdfefdfbf7eedfbb),
    ULL(0xfffefffffffefffb),
    ULL(0xdfbf7fbfdfeef7fb),
    ULL(0xffff7ffffffefffb),
    ULL(0xef5fbf5feff6fbf9),
    ULL(0xffffbffffffefffb),
    ULL(0x77afdfaf77fafdfa),
    ULL(0xffffdffffffefffb),
    ULL(0xbbd7efd7bb7cfefb),
    ULL(0xffffeffffffefffb),
    ULL(0xddebf7ebddbe7ffb),
    ULL(0xfffff7fffffefffb),
    ULL(0xeef5fbf5eedebf7b),
    ULL(0xfffffbfffffefffb),
    ULL(0xf7fafdfaf7eedfbb),
    ULL(0xfffffdfffffefffb),
    ULL(0xfbfdfefdfbf6efdb),
    ULL(0xfffffefffffefffb),
    ULL(0xefdfbf7fbfdeeff3),
    ULL(0xffffff7ffffefffb),
    ULL(0xf7ef5fbf5feef7fb),
    ULL(0xffffffbffffefffb),
    ULL(0xfb77afdfaf76fbf9),
    ULL(0xffffffdffffefffb),
    ULL(0x7dbbd7efd7ba7dfa),
    ULL(0xffffffeffffefffb),
    ULL(0xbeddebf7ebdcbe7b),
    ULL(0xfffffff7fffefffb),
    ULL(0xdfeef5fbf5eedfbb),
    ULL(0xfffffffbfffefffb),
    ULL(0xeff7fafdfaf6efdb),
    ULL(0xfffffffdfffefffb),
    ULL(0xf7fbfdfefdfaf7eb),
    ULL(0xfffffffefffefffb),
    ULL(0xf7efdfbf7fbedfeb),
    ULL(0xffffffff7ffefffb),
    ULL(0xfbf7ef5fbf5eeff3),
    ULL(0xffffffffbffefffb),
    ULL(0xfdfb77afdfae77fb),
    ULL(0xffffffffdffefffb),
    ULL(0xfe7dbbd7efd6bb79),
    ULL(0xffffffffeffefffb),
    ULL(0x7fbeddebf7eaddba),
    ULL(0xfffffffff7fefffb),
    ULL(0xbfdfeef5fbf4eedb),
    ULL(0xea75ba5dab54af5b),
    ULL(0xdfeff7fafdfaf7eb),
    ULL(0x2010080400000200),
    ULL(0xeff7fbfdfefcfbf3),
    ULL(0x2010080402000200),
    ULL(0xfbf7efdfbf7ebfdb),
    ULL(0xffffffffff7efffb),
    ULL(0xfdfbf7ef5fbe5feb),
    ULL(0xffffffffffbefffb),
    ULL(0xfefdfb77afdeaf73),
    ULL(0xffffffffffdefffb),
    ULL(0xfffe7dbbd7eed7bb),
    ULL(0xffffffffffeefffb),
    ULL(0xff7fbeddebf6ebd9),
    ULL(0xfffffffffff6fffb),
    ULL(0x7fbfdfeef5faf5ea),
    ULL(0xea75ba5daf50af5b),
    ULL(0xaa55aa55aa54aa53),
    ULL(0x2010080402000200),
    ULL(0xfffffffffffefffb),
    ULL(0xfffffffffffefffb),
    ULL(0xfdfbf7efdfbe7fbb),
    ULL(0xfffffffffffe7ffb),
    ULL(0xfefdfbf7ef5ebf5b),
    ULL(0xfffffffffffebffb),
    ULL(0xfffefdfb77aedfab),
    ULL(0xfffffffffffedffb),
    ULL(0xfffffe7dbbd6efd3),
    ULL(0xfffffffffffeeffb),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xaa55aa55aa54aa51),
    ULL(0x2010080402000200),
    ULL(0xfefdfbf7efdebf7b),
    ULL(0xfffffffffffeff7b),
    ULL(0xfffefdfbf7ee5fbb),
    ULL(0xfffffffffffeffbb),
    ULL(0xfffffefdfb76afdb),
    ULL(0xfffffffffffeffdb),
    ULL(0xfffffffe7dbad7eb),
    ULL(0xfffffffffffeffeb),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x2a158a45a250a850),
    ULL(0xaa55aa55aa54aa50),
    ULL(0x7fbfdfeff7fafdfc),
    ULL(0x7ffffffffffefffd),
    ULL(0xbf5feff7fbfcfefd),
    ULL(0xbffffffffffefffd),
    ULL(0xdfaf77fbfdfefffd),
    ULL(0xdffffffffffefffd),
    ULL(0xefd7bb7dfefefffd),
    ULL(0xeffffffffffefffd),
    ULL(0xf7ebddbe7ffefffd),
    ULL(0xf7fffffffffefffd),
    ULL(0xfbf5eedfbf7efffd),
    ULL(0xfbfffffffffefffd),
    ULL(0xfdfaf7efdfbe7ffd),
    ULL(0xfdfffffffffefffd),
    ULL(0xfefdfbf7efdebf7d),
    ULL(0xfefffffffffefffd),
    ULL(0xbf7fbfdfeff6fbfd),
    ULL(0xff7ffffffffefffd),
    ULL(0x5fbf5feff7fafdfc),
    ULL(0xffbffffffffefffd),
    ULL(0xafdfaf77fbfcfefd),
    ULL(0xffdffffffffefffd),
    ULL(0xd7efd7bb7dfefffd),
    ULL(0xffeffffffffefffd),
    ULL(0xebf7ebddbe7efffd),
    ULL(0xfff7fffffffefffd),
    ULL(0xf5fbf5eedfbe7ffd),
    ULL(0xfffbfffffffefffd),
    ULL(0xfafdfaf7efdebf7d),
    ULL(0xfffdfffffffefffd),
    ULL(0xfdfefdfbf7eedfbd),
    ULL(0xfffefffffffefffd),
    ULL(0xdfbf7fbfdfeef7f9),
    ULL(0xffff7ffffffefffd),
    ULL(0xef5fbf5feff6fbfd),
    ULL(0xffffbffffffefffd),
    ULL(0x77afdfaf77fafdfc),
    ULL(0xffffdffffffefffd),
    ULL(0xbbd7efd7bb7cfefd),
    ULL(0xffffeffffffefffd),
    ULL(0xddebf7ebddbe7ffd),
    ULL(0xfffff7fffffefffd),
    ULL(0xeef5fbf5eedebf7d),
    ULL(0xfffffbfffffefffd),
    ULL(0xf7fafdfaf7eedfbd),
    ULL(0xfffffdfffffefffd),
    ULL(0xfbfdfefdfbf6efdd),
    ULL(0xfffffefffffefffd),
    ULL(0xefdfbf7fbfdeeff5),
    ULL(0xffffff7ffffefffd),
    ULL(0xf7ef5fbf5feef7f9),
    ULL(0xffffffbffffefffd),
    ULL(0xfb77afdfaf76fbfd),
    ULL(0xffffffdffffefffd),
    ULL(0x7dbbd7efd7ba7dfc),
    ULL(0xffffffeffffefffd),
    ULL(0xbeddebf7ebdcbe7d),
    ULL(0xfffffff7fffefffd),
    ULL(0xdfeef5fbf5eedfbd),
    ULL(0xfffffffbfffefffd),
    ULL(0xeff7fafdfaf6efdd),
    ULL(0xfffffffdfffefffd),
    ULL(0xf7fbfdfefdfaf7ed),
    ULL(0xfffffffefffefffd),
    ULL(0xf7efdfbf7fbedfed),
    ULL(0xffffffff7ffefffd),
    ULL(0xfbf7ef5fbf5eeff5),
    ULL(0xffffffffbffefffd),
    ULL(0xfdfb77afdfae77f9),
    ULL(0xffffffffdffefffd),
    ULL(0xfe7dbbd7efd6bb7d),
    ULL(0xffffffffeffefffd),
    ULL(0x7fbeddebf7eaddbc),
    ULL(0xfffffffff7fefffd),
    ULL(0xbfdfeef5fbf4eedd),
    ULL(0xfffffffffbfefffd),
    ULL(0xdfeff7fafdfaf7ed),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfbf5),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebfdd),
    ULL(0xffffffffff7efffd),
    ULL(0xfdfbf7ef5fbe5fed),
    ULL(0xffffffffffbefffd),
    ULL(0xfefdfb77afdeaf75),
    ULL(0xffffffffffdefffd),
    ULL(0xfffe7dbbd7eed7b9),
    ULL(0xffffffffffeefffd),
    ULL(0xff7fbeddebf6ebdd),
    ULL(0xfffffffffff6fffd),
    ULL(0x7fbfdfeef5faf5ec),
    ULL(0xfffffffffffafffd),
    ULL(0xbfdfeff7fafcfaf5),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffefffd),
    ULL(0xfffffffffffefffd),
    ULL(0xfdfbf7efdfbe7fbd),
    ULL(0xfffffffffffe7ffd),
    ULL(0xfefdfbf7ef5ebf5d),
    ULL(0xfffffffffffebffd),
    ULL(0xfffefdfb77aedfad),
    ULL(0xfffffffffffedffd),
    ULL(0xfffffe7dbbd6efd5),
    ULL(0xfffffffffffeeffd),
    ULL(0xffff7fbeddeaf7e9),
    ULL(0xfffffffffffef7fd),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfbf7efdebf7d),
    ULL(0xfffffffffffeff7d),
    ULL(0xfffefdfbf7ee5fbd),
    ULL(0xfffffffffffeffbd),
    ULL(0xfffffefdfb76afdd),
    ULL(0xfffffffffffeffdd),
    ULL(0xfffffffe7dbad7ed),
    ULL(0xfffffffffffeffed),
    ULL(0xffffff7fbedcebf5),
    ULL(0xfffffffffffefff5),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x7fbfdfeff7fafdfe),
    ULL(0x7ffffffffffefffe),
    ULL(0xbf5feff7fbfcfefe),
    ULL(0xbffffffffffefffe),
    ULL(0xdfaf77fbfdfefffe),
    ULL(0xdffffffffffefffe),
    ULL(0xefd7bb7dfefefffe),
    ULL(0xeffffffffffefffe),
    ULL(0xf7ebddbe7ffefffe),
    ULL(0xf7fffffffffefffe),
    ULL(0xfbf5eedfbf7efffe),
    ULL(0xfbfffffffffefffe),
    ULL(0xfdfaf7efdfbe7ffe),
    ULL(0xfdfffffffffefffe),
    ULL(0xfefdfbf7efdebf7e),
    ULL(0xfefffffffffefffe),
    ULL(0xbf7fbfdfeff6fbfc),
    ULL(0xff7ffffffffefffe),
    ULL(0x5fbf5feff7fafdfe),
    ULL(0xffbffffffffefffe),
    ULL(0xafdfaf77fbfcfefe),
    ULL(0xffdffffffffefffe),
    ULL(0xd7efd7bb7dfefffe),
    ULL(0xffeffffffffefffe),
    ULL(0xebf7ebddbe7efffe),
    ULL(0xfff7fffffffefffe),
    ULL(0xf5fbf5eedfbe7ffe),
    ULL(0xfffbfffffffefffe),
    ULL(0xfafdfaf7efdebf7e),
    ULL(0xfffdfffffffefffe),
    ULL(0xfdfefdfbf7eedfbe),
    ULL(0xfffefffffffefffe),
    ULL(0xdfbf7fbfdfeef7fa),
    ULL(0xffff7ffffffefffe),
    ULL(0xef5fbf5feff6fbfc),
    ULL(0xffffbffffffefffe),
    ULL(0x77afdfaf77fafdfe),
    ULL(0xffffdffffffefffe),
    ULL(0xbbd7efd7bb7cfefe),
    ULL(0xffffeffffffefffe),
    ULL(0xddebf7ebddbe7ffe),
    ULL(0xfffff7fffffefffe),
    ULL(0xeef5fbf5eedebf7e),
    ULL(0xfffffbfffffefffe),
    ULL(0xf7fafdfaf7eedfbe),
    ULL(0xfffffdfffffefffe),
    ULL(0xfbfdfefdfbf6efde),
    ULL(0xfffffefffffefffe),
    ULL(0xefdfbf7fbfdeeff6),
    ULL(0xffffff7ffffefffe),
    ULL(0xf7ef5fbf5feef7fa),
    ULL(0xffffffbffffefffe),
    ULL(0xfb77afdfaf76fbfc),
    ULL(0xffffffdffffefffe),
    ULL(0x7dbbd7efd7ba7dfe),
    ULL(0xffffffeffffefffe),
    ULL(0xbeddebf7ebdcbe7e),
    ULL(0xfffffff7fffefffe),
    ULL(0xdfeef5fbf5eedfbe),
    ULL(0xfffffffbfffefffe),
    ULL(0xeff7fafdfaf6efde),
    ULL(0xfffffffdfffefffe),
    ULL(0xf7fbfdfefdfaf7ee),
    ULL(0xfffffffefffefffe),
    ULL(0xf7efdfbf7fbedfee),
    ULL(0xffffffff7ffefffe),
    ULL(0xfbf7ef5fbf5eeff6),
    ULL(0xffffffffbffefffe),
    ULL(0xfdfb77afdfae77fa),
    ULL(0xffffffffdffefffe),
    ULL(0xfe7dbbd7efd6bb7c),
    ULL(0xffffffffeffefffe),
    ULL(0x7fbeddebf7eaddbe),
    ULL(0xfffffffff7fefffe),
    ULL(0xbfdfeef5fbf4eede),
    ULL(0xfffffffffbfcfffe),
    ULL(0xdfeff7fafdfaf7ee),
    ULL(0x2010080400000204),
    ULL(0xeff7fbfdfefcfbf6),
    ULL(0x2010080402000204),
    ULL(0xfbf7efdfbf7ebfde),
    ULL(0xffffffffff7efffe),
    ULL(0xfdfbf7ef5fbe5fee),
    ULL(0xffffffffffbefffe),
    ULL(0xfefdfb77afdeaf76),
    ULL(0xffffffffffdefffe),
    ULL(0xfffe7dbbd7eed7ba),
    ULL(0xffffffffffeefffe),
    ULL(0xff7fbeddebf6ebdc),
    ULL(0xfffffffffff6fbfe),
    ULL(0x7fbfdfeef5faf5ee),
    ULL(0xfffffffffff8fbfe),
    ULL(0xbfdfeff7fafcfaf6),
    ULL(0x2010080402000204),
    ULL(0xfffffffffffefffe),
    ULL(0xfffffffffffefffe),
    ULL(0xfdfbf7efdfbe7fbe),
    ULL(0xfffffffffffe7ffe),
    ULL(0xfefdfbf7ef5ebf5e),
    ULL(0xfffffffffffebffe),
    ULL(0xfffefdfb77aedfae),
    ULL(0xfffffffffffedffe),
    ULL(0xfffffe7dbbd6efd6),
    ULL(0xfffffffffffeeffe),
    ULL(0xffff7fbeddeaf7ea),
    ULL(0xfffffffffffef3fa),
    ULL(0xff7fbfdfeef4fbf4),
    ULL(0xfffffffffffcfbfa),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0xfefdfbf7efdebf7e),
    ULL(0xfffffffffffeff7e),
    ULL(0xfffefdfbf7ee5fbe),
    ULL(0xfffffffffffeffbe),
    ULL(0xfffffefdfb76afde),
    ULL(0xfffffffffffeffde),
    ULL(0xfffffffe7dbad7ee),
    ULL(0xfffffffffffeffee),
    ULL(0xffffff7fbedcebf6),
    ULL(0xfffffffffffefbf2),
    ULL(0xffff7fbfdfeef5fa),
    ULL(0xfffffffffffefbfa),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
    ULL(0x0000000000000000),
};



int KBPK_rank6_raw(int wk,int bk,int wb, int side){
    return (KBPK_rank6_[wk][bk][side] & bitboards.BitPosArray[wb])!=NULLBITBOARD;
}

#define VM(sq) SQUARE(7-FILE_(sq),RANK(sq))

int ScoreKBPK_rank6(board_t *board){
    int wk,bk,wb,wp,side,winner;
    int s;
    winner = (board->b[white][bishop] ? white : black);
    side=board->side;
    // make winner white
    side=(winner==white)?side:1^side;
    wp=(winner==white?trailz(board->b[winner][pawn]):63-leadz(board->b[winner][pawn]));
    ASSERT((wp==A6)|| (wp==H6));
    wb = leadz (board->b[winner][bishop]);
    wb=(winner==white)?wb:63-wb;
    wk= board->king[winner];
    wk=(winner==white)?wk:63-wk;
    bk= board->king[1^winner];
    bk=(winner==white)?bk:63-bk;
    if(wp==A6){
	wk=VM(wk);
	bk=VM(bk);
	wb=VM(wb);
    }
    if(KBPK_rank6_raw(wk,bk,wb,side)==0){
	return DRAWSCORE;
    }else{
	s=MATERIALE(board,winner)+50; 
	s=((winner==side)?s:-s);
	return s;
    }
}

int ScoreKBPK(board_t *board, uint32_t *flags){

    // TODO: 
    // Replace file check with bitboard mask.
    // Make heuristic draw conditions more precise. 

    int side, xside, winner, loser;
    int KBPK;
    int file, t, new_file, prom_rank, prom_color, prom_square, first_pawn, first_blocker_pawn, blocked;
    BitBoard c, blocker_pawns;
    int s;
    int loser_king_distance, winner_king_distance, side_bonus, winner_pawn_distance;
    

    side=board->side;
    xside=1^side;

    KBPK=false;
    if((nbits(board->friends[side])==nbits(board->b[side][pawn])+nbits(board->b[side][bishop])+1)
       && (nbits(board->b[side][bishop])==1)
       && (nbits(board->b[side][pawn])>=1)
       && nbits(board->friends[xside])==nbits(board->b[xside][pawn])+1
       ){
	*flags=EG_UPPERBOUND; // flags for side: the winner gets at most an upperbound
	winner=side;
	loser=xside;
	KBPK=true;
    }else if((nbits(board->friends[xside])==nbits(board->b[xside][pawn])+nbits(board->b[xside][bishop])+1)
	     && (nbits(board->b[xside][bishop])==1)
	     && (nbits(board->b[xside][pawn])>=1)
	     && nbits(board->friends[side])==nbits(board->b[side][pawn])+1
	     ){
	*flags=EG_LOWERBOUND; // flags for side: the winner gets at most an upperbound
	winner=xside;
	loser=side;
	KBPK=true;
    }
    if(KBPK){
	if 	(nbits(board->friends[loser])==1){
	    *flags=EG_EXACTSCORE;
	} // bound flags have already been set
	file=-1;
	c=board->b[winner][pawn];
	while(c){
	    t = leadz (c);
	    CLEARBIT (c, t);  
	    // replace by masking!
	    new_file=FILE_(t);
	    if((file!=-1 && new_file!=file)|| (new_file!=0 && new_file!=7)){
		*flags=EG_NOTRECOGNIZED;
		return EG_SCORENOTRECOGNIZED;
	    }else{
		file=new_file;
	    }
	}
	if(winner==white){
	    prom_rank=7;
	}else{
	    prom_rank=0;
	}
	prom_color=1^((prom_rank+file)&1);
	if(prom_color==white && (board->b[winner][bishop]&bitboards.WhiteSquares)!=NULLBITBOARD){
	    *flags=EG_NOTRECOGNIZED;
	    return EG_SCORENOTRECOGNIZED;
	}
	if(prom_color==black && (board->b[winner][bishop]&bitboards.BlackSquares)!=NULLBITBOARD){
	    *flags=EG_NOTRECOGNIZED;
	    return EG_SCORENOTRECOGNIZED;
	}
	prom_square=SQUARE(file,prom_rank);
	loser_king_distance=distance[prom_square][board->king[loser]];
	if(loser_king_distance<= 1){
	    return DRAWSCORE;
	}
	// heuristic scores for winner
	first_pawn=(winner==white?trailz(board->b[winner][pawn]):leadz(board->b[winner][pawn]));
	side_bonus=(winner==side?1:0);
	winner_pawn_distance=distance[prom_square][first_pawn];
	winner_king_distance=distance[prom_square][board->king[winner]];
	
	blocker_pawns=bitboards.FileBit[file] & board->b[loser][pawn];
	blocked=false;
	if(blocker_pawns){
	    first_blocker_pawn=(winner==white?trailz(blocker_pawns):leadz(blocker_pawns));
	    blocked=(winner==white?first_blocker_pawn>first_pawn:first_blocker_pawn<first_pawn);
	}
	if(!blocked && 
	   ((winner==white && (first_pawn==A6 || first_pawn==H6))
	    || (winner==black && (first_pawn==A3 || first_pawn==H3)))){
	       // Pawn on the sixth rank. There are some special situations
	       // in this case which we handle by a bitbase.
	    return ScoreKBPK_rank6(board);
	}else if (!blocked && loser_king_distance>winner_pawn_distance-side_bonus+1){
	    s=MATERIALE(board,winner)-10*winner_pawn_distance+70; 
	}else if(!blocked){
	    if (loser_king_distance>winner_king_distance-side_bonus+1){
		s=MATERIALE(board,winner)-10*winner_pawn_distance; 
	    }else{
		s=5*loser_king_distance;
	    }
	}else{ // blocked
	    if (loser_king_distance>winner_king_distance-side_bonus+1){
                /* the /3 works best because KPK is mis evaluated */
		s=(MATERIALE(board,winner)/3+loser_king_distance) ;
		if((blocker_pawns&bitboards.WhiteSquares)!=NULLBITBOARD && (board->b[winner][bishop]&bitboards.WhiteSquares)!=NULLBITBOARD){
		    s+=20;
		}else
		if((blocker_pawns&bitboards.BlackSquares)!=NULLBITBOARD && (board->b[winner][bishop]&bitboards.BlackSquares)!=NULLBITBOARD){
		    s+=20;
		}else
		if(abs(first_blocker_pawn-first_pawn)>8){
	           s+=15;
		}
	    }else{
		s=5*loser_king_distance;
	    }
	    
	}
	if(side!=winner){
	    s=-s;
	}
	return s;
    }
    *flags=EG_NOTRECOGNIZED;
    return EG_SCORENOTRECOGNIZED;
	
}
/*
 * The code below constructs a bit base of positions where the pawn is
 * on H6. The bitbase is extracted from Gaviota Table Bases.
 */

static void BoardFromPieces(board_t *board, int side, int wk, int bk, int wb){
    BoardInit(board);
    SETBIT(board->b[white][king],wk);
    SETBIT(board->b[white][bishop],wb);
    SETBIT(board->b[white][pawn],H6);
    SETBIT(board->b[black][king],bk);
    BoardUpdateFriends(board); // also updates blockers
    board->ep=-1;
    board->flag=0;
    board->side=side;
    board->material[white]=evals.ValueB+evals.ValueP;
    board->material[black]=0;
    board->pmaterial[white]=evals.ValueB;
    board->pmaterial[black]=0;
    board->castled[white]=true;
    board->castled[black]=true;
    board->king[white]=wk;
    board->king[black]=bk;
    BoardUpdateCBoard(board);
    BoardUpdateMvboard(board);
    board->Game50=0;
    board->GameCnt=0;
    board->in_check=AttackToSq (board,board->king[board->side], 1^board->side);
    board->xin_check=AttackToSq (board,board->king[1^board->side], board->side);
    BoardUpdateHashKey(board);
    BoardUpdateMaterialIndex(board);
    board->phase = Material[board->material_index].phase;
}


void KBPK_rank6_gen(void){
    int wk,bk,wb,side,score;
    board_t board[1];
    uint8_t KBPK[64][64][64][2];
    int flags;
    memset(KBPK,0,sizeof(KBPK));
    for(side=white;side<=black;side++){
	for(wk=A1; wk<=H8; wk++){
	    if(wk==H6){
		continue;
	    }
	    for(bk=A1; bk<=H8; bk++){
		if(wk==bk || wk==H6){
		    continue;
		}
		for(wb=A1; wb<=H8; wb++){
		    if(wb==wk || wb==bk || wb==H6){
			continue;
		    }
		    BoardFromPieces(board,side,wk,bk,wb);
		    if(BoardValidate(board)!=0){
			continue;
		    }
		    score=GTBScore(GTB,board,GTB_MODE_WDL,&flags);
		    if(score==DRAWSCORE){
			KBPK[wk][bk][wb][side]=0;
		    }else{
			KBPK[wk][bk][wb][side]=1;
		    }
		}
	    }
	}
    }
    memset(KBPK_rank6_,0,sizeof(KBPK_rank6_));
    for(side=white;side<=black;side++){
	for(wk=A1;wk<=H8;wk++){
	    for(bk=A1;bk<=H8;bk++){
		for(wb=A1;wb<=H8;wb++){
		    if(KBPK[wk][bk][wb][side]==1){
			SETBIT(KBPK_rank6_[wk][bk][side],wb);
		    }
		}
	    }
	}
    }
    Output("static uint64_t KBPK_rank6_[64][64][2]={\n");
    for(wk=A1;wk<=H8;wk++){
    	for(bk=A1;bk<=H8;bk++){
    	    for(side=white;side<=black;side++){
    		Output("    ULL(0x"U64_FORMAT"),\n",KBPK_rank6_[wk][bk][side]);
    	    }
    	}
    }
    Output("};\n");
}
